Resent-Date: Mon, 11 Jan 1999 11:12:16 +0100 (MET)
From: zippel@fh-brandenburg.de (Roman Zippel)
Subject: mm and head.S diff
To: linux-m68k@lists.linux-m68k.org
Date: Mon, 11 Jan 1999 11:11:35 +0100 (MET)
Resent-From: linux-m68k@phil.uni-sb.de

Hi,

This time a minor update for the memory management, I tested
this as good as I can and it does compile for other machines,
but it still must be tested on 020/030 (looking to some atari
people :) ).

Here the changes:
- remove remaining CONFIG_OPTIMIZE_0x0 switches (this allows
  also again to optimize for 040/060)
- kbd_reset_setup() is unused on m68k and had different
  definitions in main.c and setup.c
- avoid the linux/config.h and use the new config includes
  in the asm headers (could now do someome make checkconfig?
  all I know is that in scripts/checkconfig.pl in line 32
  a s/\//_/g must be included but I don't know how :) )
- some more definitions in m68k_defs.c and use them for some
  optimization in entry.S
- z2ram is working now at least for chipram/memory entries,
  but I'm not sure about z2 mem, as it's already sorted out
  quite early in config.c before zorro.c sees it, but I don't
  have any z2 mem to test this.
- VTOP/PTOV is obsolete
- shut up the ariadne2 interrupt
- amifb uses now writethrough caching for the videomem access,
  might improve console performance ;)
  (BTW the penguin doesn't stays on top anymore, instead it's
  scrolled away and I get wrong colors until the first console
  change).

The remaining stuff is the new head.S (Michael: I got your diff
too late, but try this) and kernel_map is now ioremap as on
other architectures. The new head.S compiles fine now for mac/
atari too, even console/mem_print should be usable again and
I'm quite sure it generates correct mappings for the 030. The
tt register are initialized correctly too and mmu_map_tt got
a new argument to use both registers.
It would be nice if someone could test on an atari, since I
changed a bit in the mac mapping (for the videomem I simply
create a 4MB mapping), that needs to be tested, so that I would
like to know that head.S is working at all for 020/030.
The new head.S is BTW now in the init section and lots of magic
dependencies to mm code is removed. There is no seperate pointer
table management for the kernel anymore and kmap.c is now a
lots simpler (although also a bit slower but the code is now
more compact). The only thing that is missing now, the kernel
doesn't free its tables, but it is/was unused anyway and as soon
someone is going to use it, I'll reimplement that :).

bye, Roman

diff -Nur -X m68k_nodiff linux-2.2-p68k.org/Documentation/Configure.help linux-2.2-p68k/Documentation/Configure.help
--- linux-2.2-p68k.org/Documentation/Configure.help	Wed Jan  6 22:25:36 1999
+++ linux-2.2-p68k/Documentation/Configure.help	Sat Jan  9 00:58:29 1999
@@ -9804,26 +9804,10 @@
   MC68EC040 will not work, as it does not include an MMU (Memory
   Management Unit).
 
-Use -m68040 flag for 68040 specific optimizations
-CONFIG_OPTIMIZE_040
-  If you will only be running this kernel on a 68040-series processor,
-  this will make the kernel run somewhat faster. However, it will no
-  longer run on a 68020 or 68030, no matter whether you included 68020
-  and 68030 support or not. Say N unless the only processor you are
-  compiling support for is the 68040 (or 68LC040).
-
 68060 support
 CONFIG_M68060
   If you anticipate running this kernel on a computer with a MC68060
   processor, say Y. Otherwise, say N.
-
-Use -m68060 flag for 68060 specific optimizations
-CONFIG_OPTIMIZE_060
-  If you will only be running this kernel on a 68060-series processor,
-  this will make the kernel run somewhat faster. However, it will no
-  longer run on a 68020, 68030 or 68040, no matter whether you
-  included support for those processors or not. Say N unless the only
-  processor you are compiling support for is the 68060.
 
 Advanced processor options
 CONFIG_ADVANCED_CPU
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/arch/m68k/Makefile linux-2.2-p68k/arch/m68k/Makefile
--- linux-2.2-p68k.org/arch/m68k/Makefile	Wed Jan  6 22:25:36 1999
+++ linux-2.2-p68k/arch/m68k/Makefile	Wed Jan  6 23:19:06 1999
@@ -29,12 +29,19 @@
 # without -fno-strength-reduce the 53c7xx.c driver fails ;-(
 CFLAGS += -pipe -fno-strength-reduce -ffixed-a2
 
-ifdef CONFIG_OPTIMIZE_040
+# enable processor switch if compiled only for a single cpu
+ifndef CONFIG_M68020
+ifndef CONFIG_M68030
+
+ifndef CONFIG_M68060
 CFLAGS := $(CFLAGS) -m68040
 endif
 
-ifdef CONFIG_OPTIMIZE_060
+ifndef CONFIG_M68040
 CFLAGS := $(CFLAGS) -m68060
+endif
+
+endif
 endif
 
 ifdef CONFIG_KGDB
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/arch/m68k/amiga/config.c linux-2.2-p68k/arch/m68k/amiga/config.c
--- linux-2.2-p68k.org/arch/m68k/amiga/config.c	Sat Oct 31 02:34:15 1998
+++ linux-2.2-p68k/arch/m68k/amiga/config.c	Wed Jan  6 23:32:23 1999
@@ -52,7 +52,6 @@
 /* amiga specific keyboard functions */
 extern int amiga_keyb_init(void);
 extern int amiga_kbdrate (struct kbd_repeat *);
-extern void amiga_kbd_reset_setup(char*, int);
 /* amiga specific irq functions */
 extern void amiga_init_IRQ (void);
 extern void (*amiga_default_handler[]) (int, void *, struct pt_regs *);
@@ -343,7 +342,6 @@
   mach_sched_init      = amiga_sched_init;
   mach_keyb_init       = amiga_keyb_init;
   mach_kbdrate         = amiga_kbdrate;
-  kbd_reset_setup      = amiga_kbd_reset_setup;
   mach_init_IRQ        = amiga_init_IRQ;
   mach_default_handler = &amiga_default_handler;
   mach_request_irq     = amiga_request_irq;
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/arch/m68k/atari/atakeyb.c linux-2.2-p68k/arch/m68k/atari/atakeyb.c
--- linux-2.2-p68k.org/arch/m68k/atari/atakeyb.c	Wed Jan  6 00:39:33 1999
+++ linux-2.2-p68k/arch/m68k/atari/atakeyb.c	Wed Jan  6 23:19:06 1999
@@ -861,8 +861,3 @@
 	
 	return( 0 );
 }
-
-/* for "kbd-reset" cmdline param */
-__initfunc(void atari_kbd_reset_setup(char *str, int *ints))
-{
-}
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/arch/m68k/atari/config.c linux-2.2-p68k/arch/m68k/atari/config.c
--- linux-2.2-p68k.org/arch/m68k/atari/config.c	Sat Oct 31 01:44:51 1998
+++ linux-2.2-p68k/arch/m68k/atari/config.c	Wed Jan  6 23:19:06 1999
@@ -60,7 +60,6 @@
 extern int atari_keyb_init(void);
 extern int atari_kbdrate (struct kbd_repeat *);
 extern void atari_kbd_leds (unsigned int);
-extern void atari_kbd_reset_setup(char*, int);
 /* atari specific irq functions */
 extern void atari_init_IRQ (void);
 extern int atari_request_irq (unsigned int irq, void (*handler)(int, void *, struct pt_regs *),
@@ -251,7 +250,6 @@
     mach_keyb_init       = atari_keyb_init;
     mach_kbdrate         = atari_kbdrate;
     mach_kbd_leds        = atari_kbd_leds;
-    kbd_reset_setup      = atari_kbd_reset_setup;
     mach_init_IRQ        = atari_init_IRQ;
     mach_request_irq     = atari_request_irq;
     mach_free_irq        = atari_free_irq;
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/arch/m68k/config.in linux-2.2-p68k/arch/m68k/config.in
--- linux-2.2-p68k.org/arch/m68k/config.in	Wed Jan  6 22:25:36 1999
+++ linux-2.2-p68k/arch/m68k/config.in	Wed Jan  6 23:19:06 1999
@@ -22,12 +22,15 @@
 comment 'Platform dependent setup'
 
 bool 'Amiga support' CONFIG_AMIGA
+if [ "$CONFIG_AMIGA" = "y" ]; then
+  define_bool CONFIG_APUS n
+fi
 bool 'Atari support' CONFIG_ATARI
 if [ "$CONFIG_ATARI" = "y" ]; then
   bool '  Hades support' CONFIG_HADES
   if [ "$CONFIG_HADES" = "y" ]; then
     define_bool CONFIG_PCI y
-  fi  
+  fi
 fi
 bool 'Macintosh support' CONFIG_MAC
 if [ "$CONFIG_MAC" = "y" ]; then
@@ -44,6 +47,7 @@
 if [ "$CONFIG_HP300" = "y" ]; then
   bool 'DIO bus support' CONFIG_DIO
 fi
+define_bool CONFIG_SUN3 n
 if [ "$CONFIG_PCI" = "y" ]; then
   bool 'Backward-compatible /proc/pci' CONFIG_PCI_OLD_PROC
 fi
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/arch/m68k/fpsp040/skeleton.S linux-2.2-p68k/arch/m68k/fpsp040/skeleton.S
--- linux-2.2-p68k.org/arch/m68k/fpsp040/skeleton.S	Sat Oct 31 01:10:59 1998
+++ linux-2.2-p68k/arch/m68k/fpsp040/skeleton.S	Sat Jan  9 16:44:35 1999
@@ -40,6 +40,7 @@
 
 #include <linux/linkage.h>
 #include <asm/entry.h>
+#include "../kernel/m68k_defs.h"
 
 |SKELETON	idnt    2,1 | Motorola 040 Floating Point Software Package
 
@@ -375,12 +376,12 @@
 	.global	fpsp_done
 fpsp_done:
 	btst	#0x5,%sp@		| supervisor bit set in saved SR?
-	beq	Lnotkern
+	beq	.Lnotkern
 	rte
-Lnotkern:
+.Lnotkern:
 	SAVE_ALL_INT
 	GET_CURRENT(%d0)
-	tstl	%curptr@(LTASK_NEEDRESCHED)
+	tstl	%curptr@(TASK_NEEDRESCHED)
 	jne	SYMBOL_NAME(ret_from_exception)	| deliver signals,
 						| reschedule etc..
 	RESTORE_ALL
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/arch/m68k/hp300/config.c linux-2.2-p68k/arch/m68k/hp300/config.c
--- linux-2.2-p68k.org/arch/m68k/hp300/config.c	Sat Oct 31 01:45:10 1998
+++ linux-2.2-p68k/arch/m68k/hp300/config.c	Wed Jan  6 23:19:06 1999
@@ -55,11 +55,6 @@
 {
 }
 
-/* for "kbd-reset" cmdline param */
-__initfunc(void hp300_kbd_reset_setup(char *str, int i))
-{
-}
-
 static void hp300_get_model(char *model)
 {
   strcpy(model, "HP9000/300");
@@ -74,7 +69,6 @@
   mach_init_IRQ        = hp300_init_IRQ;
   mach_request_irq     = hp300_request_irq;
   mach_free_irq        = hp300_free_irq;
-  kbd_reset_setup      = hp300_kbd_reset_setup;
   mach_get_model       = hp300_get_model;
   mach_get_irq_list    = hp300_get_irq_list;
   mach_gettimeoffset   = hp300_gettimeoffset;
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/arch/m68k/ifpsp060/iskeleton.S linux-2.2-p68k/arch/m68k/ifpsp060/iskeleton.S
--- linux-2.2-p68k.org/arch/m68k/ifpsp060/iskeleton.S	Sat Oct 31 00:49:32 1998
+++ linux-2.2-p68k/arch/m68k/ifpsp060/iskeleton.S	Wed Jan  6 23:19:06 1999
@@ -36,6 +36,7 @@
 
 #include <linux/linkage.h>
 #include <asm/entry.h>
+#include "../kernel/m68k_defs.h"
 
 
 |################################
@@ -69,12 +70,12 @@
 	.global		_060_isp_done
 _060_isp_done:
 	btst	#0x5,%sp@		| supervisor bit set in saved SR?
-	beq	Lnotkern
+	beq	.Lnotkern
 	rte
-Lnotkern:
+.Lnotkern:
 	SAVE_ALL_INT
 	GET_CURRENT(%d0)
-	tstl	%curptr@(LTASK_NEEDRESCHED)
+	tstl	%curptr@(TASK_NEEDRESCHED)
 	jne	SYMBOL_NAME(ret_from_exception)	| deliver signals,
 						| reschedule etc..
 	RESTORE_ALL
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/arch/m68k/kernel/entry.S linux-2.2-p68k/arch/m68k/kernel/entry.S
--- linux-2.2-p68k.org/arch/m68k/kernel/entry.S	Sat Oct 31 02:34:19 1998
+++ linux-2.2-p68k/arch/m68k/kernel/entry.S	Sun Jan 10 15:18:22 1999
@@ -31,11 +31,15 @@
  */
 
 #include <linux/sys.h>
-#include <linux/config.h>
 #include <linux/linkage.h>
 #include <asm/entry.h>
+#include <asm/errno.h>
 #include <asm/setup.h>
 #include <asm/segment.h>
+#include <asm/traps.h>
+
+#include <config/amiga.h>
+#include <config/m68060.h>
 
 #include "m68k_defs.h"
 
@@ -65,24 +69,24 @@
 
 ENTRY(reschedule)
 	| save top of frame
-	movel	%sp,%curptr@(TS_ESP0)
+	movel	%sp,%curptr@(TASK_TSS+TSS_ESP0)
 
 	pea	SYMBOL_NAME(ret_from_exception)
 	jmp	SYMBOL_NAME(schedule)
 
 badsys:
-	movel	#-LENOSYS,LPT_OFF_D0(%sp)
+	movel	#-ENOSYS,PT_D0(%sp)
 	jra	SYMBOL_NAME(ret_from_exception)
 
 do_trace:
-	movel	#-LENOSYS,LPT_OFF_D0(%sp)	| needed for strace
+	movel	#-ENOSYS,PT_D0(%sp)	| needed for strace
 	subql	#4,%sp
 	SAVE_SWITCH_STACK
 	jbsr	SYMBOL_NAME(syscall_trace)
 	RESTORE_SWITCH_STACK
 	addql	#4,%sp
 	jbsr	@(SYMBOL_NAME(sys_call_table),%d2:l:4)@(0)
-	movel	%d0,%sp@(LPT_OFF_D0)	| save the return value
+	movel	%d0,%sp@(PT_D0)		| save the return value
 	subql	#4,%sp			| dummy return address
 	SAVE_SWITCH_STACK
 	jbsr	SYMBOL_NAME(syscall_trace)
@@ -98,34 +102,34 @@
 
 	GET_CURRENT(%d0)
 	| save top of frame
-	movel	%sp,%curptr@(TS_ESP0)
+	movel	%sp,%curptr@(TASK_TSS+TSS_ESP0)
 
 	cmpl	#NR_syscalls,%d2
 	jcc	badsys
-	btst	#LPF_TRACESYS_BIT,%curptr@(LTASK_FLAGS+LPF_TRACESYS_OFF)
+	btst	#PF_TRACESYS_BIT,%curptr@(TASK_FLAGS+PF_TRACESYS_OFF)
 	jne	do_trace
 	jbsr	@(SYMBOL_NAME(sys_call_table),%d2:l:4)@(0)
-	movel	%d0,%sp@(LPT_OFF_D0)	| save the return value
+	movel	%d0,%sp@(PT_D0)		| save the return value
 
 SYMBOL_NAME_LABEL(ret_from_exception)
-	btst	#5,%sp@(LPT_OFF_SR)	| check if returning to kernel
+	btst	#5,%sp@(PT_SR)		| check if returning to kernel
 	bnes	2f			| if so, skip resched, signals
 	| only allow interrupts when we are really the last one on the
 	| kernel stack, otherwise stack overflow can occur during
 	| heavy interupt load
 	andw	#ALLOWINT,%sr
-	tstl	%curptr@(LTASK_NEEDRESCHED)
+	tstl	%curptr@(TASK_NEEDRESCHED)
 	jne	SYMBOL_NAME(reschedule)
 	cmpl	#SYMBOL_NAME(task),%curptr	| task[0] cannot have signals
 	jeq	2f
 					| check for delayed trace
-	bclr	#LPF_DTRACE_BIT,%curptr@(LTASK_FLAGS+LPF_DTRACE_OFF)
+	bclr	#PF_DTRACE_BIT,%curptr@(TASK_FLAGS+PF_DTRACE_OFF)
 	jne	do_delayed_trace
 5:
-	tstl	%curptr@(LTASK_STATE)	| state
+	tstl	%curptr@(TASK_STATE)	| state
 	jne	SYMBOL_NAME(reschedule)
 
-	tstl	%curptr@(LTASK_SIGPENDING)
+	tstl	%curptr@(TASK_SIGPENDING)
 	jne	Lsignal_return
 2:	RESTORE_ALL
 
@@ -141,7 +145,7 @@
 	RESTORE_ALL
 
 do_delayed_trace:
-	bclr	#7,%sp@(LPT_OFF_SR)	| clear trace bit in SR
+	bclr	#7,%sp@(PT_SR)		| clear trace bit in SR
 	pea	1			| send SIGTRAP
 	movel	%curptr,%sp@-
 	pea	LSIGTRAP
@@ -158,7 +162,7 @@
 	GET_CURRENT(%d0)
 	addql	#1,SYMBOL_NAME(local_irq_count)
 					|  put exception # in d0
-	bfextu %sp@(LPT_OFF_FORMATVEC){#4,#10},%d0
+	bfextu %sp@(PT_VECTOR){#4,#10},%d0
 
 	movel	%sp,%sp@-
 	movel	%d0,%sp@- 		|  put vector # on stack
@@ -172,7 +176,7 @@
 	RESTORE_ALL
 1:
 #if 1
-	bfextu  %sp@(LPT_OFF_SR){#5,#3},%d0	| Check for nested interrupt.
+	bfextu  %sp@(PT_SR){#5,#3},%d0	| Check for nested interrupt.
 #if MAX_NOINT_IPL > 0
 	cmpiw	#MAX_NOINT_IPL,%d0
 #endif
@@ -240,37 +244,31 @@
 
 SYMBOL_NAME_LABEL(resume)
 	/*
-	 * Beware - when entering resume, offset of tss is in d1,
-	 * prev (the current task) is in a0, next (the new task)
-	 * is in a1 and d2.b is non-zero if the mm structure is
-	 * shared between the tasks, so don't change these
+	 * Beware - when entering resume, prev (the current task) is
+	 * in a0, next (the new task) is in a1,so don't change these
 	 * registers until their contents are no longer needed.
 	 */
 
-	/* offset of tss struct (processor state) from beginning
-	   of task struct */
-	addl	%d1,%a0
-
 	/* save sr */
-	movew	%sr,%a0@(LTSS_SR)
+	movew	%sr,%a0@(TASK_TSS+TSS_SR)
 
 	/* save fs (sfc,%dfc) (may be pointing to kernel memory) */
 	movec	%sfc,%d0
-	movew	%d0,%a0@(LTSS_FS)
+	movew	%d0,%a0@(TASK_TSS+TSS_FS)
 
 	/* save usp */
 	/* it is better to use a movel here instead of a movew 8*) */
 	movec	%usp,%d0
-	movel	%d0,%a0@(LTSS_USP)
+	movel	%d0,%a0@(TASK_TSS+TSS_USP)
 
 	/* save non-scratch registers on stack */
 	SAVE_SWITCH_STACK
 
 	/* save current kernel stack pointer */
-	movel	%sp,%a0@(LTSS_KSP)
+	movel	%sp,%a0@(TASK_TSS+TSS_KSP)
 
 	/* save floating point context */
-	fsave	%a0@(LTSS_FPCTXT+27*4)
+	fsave	%a0@(TASK_TSS+TSS_FPSTATE)
 
 #if defined(CONFIG_M68060)
 #if !defined(CPU_M68060_ONLY)
@@ -278,27 +276,27 @@
 	beqs	1f
 #endif
 	/* The 060 FPU keeps status in bits 15-8 of the first longword */
-	tstb	%a0@(LTSS_FPCTXT+27*4+2)
+	tstb	%a0@(TASK_TSS+TSS_FPSTATE+2)
 	jeq	3f
 #if !defined(CPU_M68060_ONLY)
 	jra	2f
 #endif
 #endif /* CONFIG_M68060 */
 #if !defined(CPU_M68060_ONLY)
-1:	tstb	%a0@(LTSS_FPCTXT+27*4)
+1:	tstb	%a0@(TASK_TSS+TSS_FPSTATE)
 	jeq	3f
 #endif
-2:	fmovemx	%fp0-%fp7,%a0@(LTSS_FPCTXT)
-	fmoveml	%fpcr/%fpsr/%fpiar,%a0@(LTSS_FPCTXT+24*4)
+2:	fmovemx	%fp0-%fp7,%a0@(TASK_TSS+TSS_FPREG)
+	fmoveml	%fpcr/%fpsr/%fpiar,%a0@(TASK_TSS+TSS_FPCNTL)
 3:
 
-	/* get pointer to tss struct (a1 contains new task) */
+	/* switch to new task (a1 contains new task) */
 	movel	%a1,%curptr
-	addl	%d1,%a1
 
 	/* Skip address space switching if they are the same. */
-	tstb	%d2
-	jne	4f
+	movel	%a0@(TASK_MM),%d0
+	cmpl	%a1@(TASK_MM),%d0
+	jeq	4f
 
 #if defined(CPU_M68020_OR_M68030) && defined(CPU_M68040_OR_M68060)
 	/* 68040 or 68060 ? */
@@ -316,7 +314,7 @@
 	movec	%d0,%cacr
 
 	/* switch the root pointer */
-	pmove	%a1@(LTSS_CRP),%crp
+	pmove	%a1@(TASK_TSS+TSS_CRP),%crp
 #endif
 
 #if defined(CPU_M68020_OR_M68030) && defined(CPU_M68040_OR_M68060)
@@ -333,7 +331,7 @@
 	pflushan
 
 	/* switch the root pointer */
-	movel	%a1@(LTSS_CRP+4),%d0
+	movel	%a1@(TASK_TSS+TSS_CRP+4),%d0
 	movec	%d0,%urp
 
 #if defined (CONFIG_M68060)
@@ -359,37 +357,37 @@
 	beqs	1f
 #endif
 	/* The 060 FPU keeps status in bits 15-8 of the first longword */
-	tstb	%a1@(LTSS_FPCTXT+27*4+2)
+	tstb	%a1@(TASK_TSS+TSS_FPSTATE+2)
 	jeq	3f
 #if !defined(CPU_M68060_ONLY)
 	jra	2f
 #endif
 #endif /* CONFIG_M68060 */
 #if !defined(CPU_M68060_ONLY)
-1:	tstb	%a1@(LTSS_FPCTXT+27*4)
+1:	tstb	%a1@(TASK_TSS+TSS_FPSTATE)
 	jeq	3f
 #endif	
-2:	fmovemx	%a1@(LTSS_FPCTXT),%fp0-%fp7
-	fmoveml	%a1@(LTSS_FPCTXT+24*4),%fpcr/%fpsr/%fpiar
-3:	frestore %a1@(LTSS_FPCTXT+27*4)
+2:	fmovemx	%a1@(TASK_TSS+TSS_FPREG),%fp0-%fp7
+	fmoveml	%a1@(TASK_TSS+TSS_FPCNTL),%fpcr/%fpsr/%fpiar
+3:	frestore %a1@(TASK_TSS+TSS_FPSTATE)
 
 	/* restore the kernel stack pointer */
-	movel	%a1@(LTSS_KSP),%sp
+	movel	%a1@(TASK_TSS+TSS_KSP),%sp
 
 	/* restore non-scratch registers */
 	RESTORE_SWITCH_STACK
 
 	/* restore user stack pointer */
-	movel	%a1@(LTSS_USP),%a0
+	movel	%a1@(TASK_TSS+TSS_USP),%a0
 	movel	%a0,%usp
 
 	/* restore fs (sfc,%dfc) */
-	movew	%a1@(LTSS_FS),%a0
+	movew	%a1@(TASK_TSS+TSS_FS),%a0
 	movec	%a0,%sfc
 	movec	%a0,%dfc
 
 	/* restore status register */
-	movew	%a1@(LTSS_SR),%sr
+	movew	%a1@(TASK_TSS+TSS_SR),%sr
 
 	rts
 
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/arch/m68k/kernel/head.S linux-2.2-p68k/arch/m68k/kernel/head.S
--- linux-2.2-p68k.org/arch/m68k/kernel/head.S	Sat Oct 31 00:12:33 1998
+++ linux-2.2-p68k/arch/m68k/kernel/head.S	Sun Jan 10 15:01:56 1999
@@ -7,9 +7,12 @@
 **
 ** 68040 fixes by Michael Rausch
 ** 68060 fixes by Roman Hodek
+** MMU cleanup by Randy Thelen
+** Final MMU cleanup by Roman Zippel
 **
 ** Atari support by Andreas Schwab, using ideas of Robert de Vries
 ** and Bjoern Brauel
+** VME Support by Richard Hirst
 **
 ** 94/11/14 Andreas Schwab: put kernel at PAGESIZE
 ** 94/11/18 Andreas Schwab: remove identity mapping of STRAM for Atari
@@ -18,6 +21,8 @@
 ** 96/04/26 Guenther Kelleter: fixed identity mapping for Falcon with
 ** 			      Magnum- and FX-alternate ram
 ** 98/04/25 Phil Blundell: added HP300 support
+** 1998/08/30 David Kilzer: Added support for fbcon_font_desc structures
+**            for linux-2.1.115
 **
 ** This file is subject to the terms and conditions of the GNU General Public
 ** License. See the file README.legal in the main directory of this archive
@@ -34,69 +39,275 @@
  * Put us in supervisor state.
  *
  * The kernel setup code takes the following steps:
- *   Raise interrupt level
- *   Set up initial kernel memory mapping.
- *	This sets up a mapping of the 4M of memory the kernel
- *	is located in.	It also does a mapping of any initial
- *	machine specific areas.
- * Note that the kernel is located at virtual address 0x1000 == _start
- *   Enable cache memories
- *   Jump to kernel startup
- *
- * Register d6 contains the CPU flags and d4 the machine type
- * from the boot_info information for most of this file.
- * The upper word of d6 contains a bit for '040 or '060, since these two
- * are quite similar for initial mm setup. Another bit in d6 allows
- * distinction of the '060. The lower word of d6 contains the cache mode
- * that should be applied to pages containing descriptors. This mode is
- * non-cached/non-serialized for the '040 and cacheable/write-through for
- * the '060.
- *
- * General register usage:
- *   a6 - start of unused memory
- *	  new pages can be allocated from here
- *   a5 - mmu root table
- *   a4 - mmu pointer table
- *   a3 - mmu page tables
- *   a2 - points to the page table entry for a6
- *	  cache status can be changed (used for '0[46]0)
- *	  you must increase a2 if alloc a new page
- *   d7 - used for debug output and some macros
- *   d6 - cpu type and cache mode
- *   d5 - physical start address of kernel
- *   d4 - machine type
+ * .  Raise interrupt level
+ * .  Set up initial kernel memory mapping.
+ *    .  This sets up a mapping of the 4M of memory the kernel is located in.
+ *    .  It also does a mapping of any initial machine specific areas.
+ * .  Enable the MMU
+ * .  Enable cache memories
+ * .  Jump to kernel startup
+ *
+ * Much of the file restructuring was to accomplish:
+ * 1) Remove register dependency through-out the file.
+ * 2) Increase use of subroutines to perform functions
+ * 3) Increase readability of the code
+ *
+ * Of course, readability is a subjective issue, so it will never be
+ * argued that that goal was accomplished.  It was merely a goal.
+ * A key way to help make code more readable is to give good
+ * documentation.  So, the first thing you will find is exaustive
+ * write-ups on the structure of the file, and the features of the
+ * functional subroutines.
+ *
+ * General Structure:
+ * ------------------
+ *	Without a doubt the single largest chunk of head.S is spent
+ * mapping the kernel and I/O physical space into the logical range
+ * for the kernel.
+ *	There are new subroutines and data structures to make MMU
+ * support cleaner and easier to understand.
+ * 	First, you will find a routine call "mmu_map" which maps
+ * a logical to a physical region for some length given a cache
+ * type on behalf of the caller.  This routine makes writing the
+ * actual per-machine specific code very simple.
+ *	A central part of the code, but not a subroutine in itself,
+ * is the mmu_init code which is broken down into mapping the kernel
+ * (the same for all machines) and mapping machine-specific I/O
+ * regions.
+ *	Also, there will be a description of engaging the MMU and
+ * caches.
+ *	You will notice that there is a chunk of code which
+ * can emit the entire MMU mapping of the machine.  This is present
+ * only in debug modes and can be very helpful.
+ *	Further, there is a new console driver in head.S that is
+ * also only engaged in debug mode.  Currently, it's only supported
+ * on the Macintosh class of machines.  However, it is hoped that
+ * others will plug-in support for specific machines.
+ *
+ * ######################################################################
+ *
+ * mmu_map
+ * -------
+ *	mmu_map was written for two key reasons.  First, it was clear
+ * that it was very difficult to read the previous code for mapping
+ * regions of memory.  Second, the Macintosh required such extensive
+ * memory allocations that it didn't make sense to propogate the
+ * existing code any further.
+ *	mmu_map requires some parameters:
+ *
+ *	mmu_map (logical, physical, length, cache_type)
+ *
+ *	While this essentially describes the function in the abstract, you'll
+ * find more indepth description of other parameters at the implementation site.
+ * 
+ * mmu_get_root_table_entry
+ * ------------------------
+ * mmu_get_ptr_table_entry
+ * -----------------------
+ * mmu_get_page_table_entry
+ * ------------------------
+ * 
+ *	These routines are used by other mmu routines to get a pointer into
+ * a table, if necessary a new table is allocated. These routines are working
+ * basically like pmd_alloc() and pte_alloc() in <asm/pgtable.h>. The root
+ * table needs of course only to be allocated once in mmu_get_root_table_entry,
+ * so that here also some mmu specific initialization is done. The second page
+ * at the start of the kernel (the first page is unmapped later) is used for
+ * the kernel_pg_dir. It must be at a position known at link time (as it's used
+ * to initialize the init task struct) and since it's needs special cache
+ * settings, it's the easiest to use this page, the rest of the page is used
+ * for further pointer tables.
+ * mmu_get_page_table_entry allocates always a whole page for page tables, this
+ * means 1024 pages and so 4MB of memory can be mapped. It doesn't make sense
+ * to manage page tables in smaller pieces as nearly all mappings have that
+ * size.
+ *
+ * ######################################################################
+ *
+ *
+ * ######################################################################
+ *
+ * mmu_engage
+ * ----------
+ *	Thanks to a small helping routine enabling the mmu got quiet simple
+ * and there is only one way left. mmu_engage makes a complete a new mapping
+ * that only includes the absolute necessary to be able to jump to the final
+ * postion and to restore the original mapping.
+ * As this code doesn't need a transparent translation register anymore this
+ * means all registers are free to be used by machines that needs them for
+ * other purposes.
+ *
+ * ######################################################################
+ *
+ * mmu_print
+ * ---------
+ *	This algorithm will print out the page tables of the system as
+ * appropriate for an 030 or an 040.  This is useful for debugging purposes
+ * and as such is enclosed in #ifdef MMU_PRINT/#endif clauses.
+ *
+ * ######################################################################
+ *
+ * console_init
+ * ------------
+ *	The console is also able to be turned off.  The console in head.S
+ * is specifically for debugging and can be very useful.  It is surrounded by
+ * #ifdef CONSOLE/#endif clauses so it doesn't have to ship in known-good
+ * kernels.  It's basic algorithm is to determine the size of the screen
+ * (in height/width and bit depth) and then use that information for
+ * displaying an 8x8 font or an 8x16 (widthxheight).  I prefer the 8x8 for
+ * debugging so I can see more good data.  But it was trivial to add support
+ * for both fonts, so I included it.
+ *	Also, the algorithm for plotting pixels is abstracted so that in
+ * theory other platforms could add support for different kinds of frame
+ * buffers.  This could be very useful.
+ *
+ * console_put_penguin
+ * -------------------
+ *	An important part of any Linux bring up is the penguin and there's
+ * nothing like getting the Penguin on the screen!  This algorithm will work
+ * on any machine for which there is a console_plot_pixel.
+ *
+ * console_scroll
+ * --------------
+ *	My hope is that the scroll algorithm does the right thing on the
+ * various platforms, but it wouldn't be hard to add the test conditions
+ * and new code if it doesn't.
+ *
+ * console_putc
+ * -------------
+ *
+ * ######################################################################
+ *
+ *	Register usage has greatly simplified within head.S. Every subroutine
+ * saves and restores all registers that it modifies (except it returns a
+ * value in there of course). So the only register that needs to be initialized
+ * is the stack pointer.
+ * All other init code and data is now placed in the init section, so it will
+ * be automatically freed at the end of the kernel initialization.
+ *
+ * ######################################################################
+ *
+ * options
+ * -------
+ *	There are many options availble in a build of this file.  I've
+ * taken the time to describe them here to save you the time of searching
+ * for them and trying to understand what they mean.
+ *
+ * CONFIG_xxx:	These are the obvious machine configuration defines created
+ * during configuration.  These are defined in include/linux/autoconf.h.
+ *
+ * CONSOLE:	There is support for head.S console in this file.  This
+ * console can talk to a Mac frame buffer, but could easily be extrapolated
+ * to extend it to support other platforms.
+ *
+ * TEST_MMU:	This is a test harness for running on any given machine but
+ * getting an MMU dump for another class of machine.  The classes of machines
+ * that can be tested are any of the makes (Atari, Amiga, Mac, VME, etc.)
+ * and any of the models (030, 040, 060, etc.).
+ *
+ *	NOTE:	TEST_MMU is NOT permanent!  It is scheduled to be removed
+ *		When head.S boots on Atari, Amiga, Macintosh, and VME
+ *		machines.  At that point the underlying logic will be
+ *		believed to be solid enough to be trusted, and TEST_MMU
+ *		can be dropped.  Do note that that will clean up the
+ *		head.S code significantly as large blocks of #if/#else
+ *		clauses can be removed.
+ *
+ * MMU_NOCACHE_KERNEL:	On the Macintosh platform there was an inquiry into
+ * determing why devices don't appear to work.  A test case was to remove
+ * the cacheability of the kernel bits.
+ *
+ * MMU_PRINT:	There is a routine built into head.S that can display the
+ * MMU data structures.  It outputs its result through the serial_putc
+ * interface.  So where ever that winds up driving data, that's where the
+ * mmu struct will appear.  On the Macintosh that's typically the console.
+ *
+ * SERIAL_DEBUG:	There are a series of putc() macro statements
+ * scattered through out the code to give progress of status to the
+ * person sitting at the console.  This constant determines whether those
+ * are used.
+ *
+ * DEBUG:	This is the standard DEBUG flag that can be set for building
+ *		the kernel.  It has the effect adding additional tests into
+ *		the code.
+ *
+ * FONT_6x11:
+ * FONT_8x8:
+ * FONT_8x16:
+ *		In theory these could be determined at run time or handed
+ *		over by the booter.  But, let's be real, it's a fine hard
+ *		coded value.  (But, you will notice the code is run-time
+ *		flexible!)  A pointer to the font's struct fbcon_font_desc
+ *		is kept locally in Lconsole_font.  It is used to determine
+ *		font size information dynamically.
+ *
+ * Atari constants:
+ * USE_PRINTER:	Use the printer port for serial debug.
+ * USE_SCC_B:	Use the SCC port A (Serial2) for serial debug.
+ * USE_SCC_A:	Use the SCC port B (Modem2) for serial debug.
+ * USE_MFP:	Use the ST-MFP port (Modem1) for serial debug.
+ *
+ * Macintosh constants:
+ * MAC_SERIAL_DEBUG:	Turns on serial debug output for the Macintosh.
+ * MAC_USE_SCC_A:	Use the SCC port A (modem) for serial debug.
+ * MAC_USE_SCC_B:	Use the SCC port B (printer) for serial debug (default).
  */
 
 #include <linux/config.h>
 #include <linux/linkage.h>
+#include <linux/init.h>
 #include <asm/bootinfo.h>
 #include <asm/setup.h>
 #include <asm/pgtable.h>
+#include "m68k_defs.h"
 
-.globl SYMBOL_NAME(kernel_pg_dir), SYMBOL_NAME(kpt)
-.globl SYMBOL_NAME(availmem)
-.globl SYMBOL_NAME(m68k_pgtable_cachemode)
-.globl SYMBOL_NAME(kernel_pmd_table), SYMBOL_NAME(swapper_pg_dir)
+#ifdef CONFIG_MAC
 
-#if defined(CONFIG_MVME16x)
-.globl SYMBOL_NAME(mvme_bdid_ptr)
-#endif
+#include <asm/machw.h>
 
 /*
- * Added m68k_supervisor_cachemode for 68060 boards where some drivers
- * need writethrough caching for supervisor accesses.  Drivers known to
- * be effected are 53c7xx.c and apricot.c (when used on VME boards).
- * Richard Hirst.
+ * Macintosh console support
  */
 
-#ifdef CONFIG_060_WRITETHROUGH
+#define CONSOLE
+
+/*
+ * Macintosh serial debug support; outputs boot info to the printer
+ *   and/or modem serial ports
+ */
+#undef MAC_SERIAL_DEBUG
+
+/*
+ * Macintosh serial debug port selection; define one or both;
+ *   requires MAC_SERIAL_DEBUG to be defined
+ */
+#define MAC_USE_SCC_A		/* Macintosh modem serial port */
+#define MAC_USE_SCC_B		/* Macintosh printer serial port */
+
+#endif	/* CONFIG_MAC */
+
+#undef MMU_PRINT
+#undef MMU_NOCACHE_KERNEL
+#define SERIAL_DEBUG
+#undef DEBUG
+
+/*
+ * For the head.S console, there are three supported fonts, 6x11, 8x16 and 8x8.
+ * The 8x8 font is harder to read but fits more on the screen.
+ */
+#define FONT_8x8 	/* default */
+/* #define FONT_8x16	/* 2nd choice */
+/* #define FONT_6x11	/* 3rd choice */
+
+.globl SYMBOL_NAME(kernel_pg_dir)
+.globl SYMBOL_NAME(availmem)
+.globl SYMBOL_NAME(m68k_pgtable_cachemode)
 .globl SYMBOL_NAME(m68k_supervisor_cachemode)
-#endif
 
-D6B_0460 = 16		/* indicates 680[46]0 in d6 */
-D6B_060  = 17		/* indicates 68060 in d6 */
-D6F_040  = 1<<D6B_0460
-D6F_060  = (1<<D6B_0460)+(1<<D6B_060)
+CPUTYPE_040	= 1	/* indicates an 040 */
+CPUTYPE_060	= 2	/* indicates an 060 */
+CPUTYPE_0460	= 3	/* if either above are set, this is set */
+CPUTYPE_020	= 4	/* indicates an 020 */
 
 /* Translation control register */
 TC_ENABLE = 0x8000
@@ -144,6 +355,7 @@
 
 /* Miscellaneous definitions */
 PAGESIZE	= 4096
+PAGESHIFT	= 12
 
 ROOT_TABLE_SIZE	= 128
 PTR_TABLE_SIZE	= 128
@@ -152,32 +364,164 @@
 PTR_INDEX_SHIFT  = 18
 PAGE_INDEX_SHIFT = 12
 
-TABLENR_4MB	= 16	/* # of page tables needed to page 4 MB */
-TABLENR_16MB	= 64	/* same for 16 MB */
+/* Several macros to make the writing of subroutines easier:
+ * - func_start marks the beginning of the routine which setups the frame
+ *   register and saves the registers, it also defines another macro
+ *   to automatically restore the registers again.
+ * - func_return marks the end of the routine and simply calls the prepared
+ *   macro to restore registers and jump back to the caller.
+ * - func_define generates another macro to automatically put arguments
+ *   onto the stack call the subroutine and cleanup the stack again.
+ */
+
+/* Within subroutines these macros can be used to access the arguments
+ * on the stack. With STACK some allocated memory on the stack can be
+ * accessed and ARG0 points to the return address (used by mmu_engage).
+ */
+#define	STACK	%a6@(stackstart)
+#define ARG0	%a6@(4)
+#define ARG1	%a6@(8)
+#define ARG2	%a6@(12)
+#define ARG3	%a6@(16)
+#define ARG4	%a6@(20)
+
+.macro	func_start	name,saveregs,stack=0
+.L\name:
+	linkw	%a6,#-\stack
+	moveml	\saveregs,%sp@-
+.set	stackstart,-\stack	
+
+.macro	func_return_\name
+	moveml	%sp@+,\saveregs
+	unlk	%a6
+	rts
+.endm
+.endm
 
-#define putc(ch) moveq &ch,%d7; jbsr Lserial_putc
-#define putr() putc(13); putc(10)
-#define putn(nr) movel nr,%d7; jbsr Lserial_putnum
-
-#define is_not_amiga(lab) moveq &MACH_AMIGA,%d7; cmpl %d4,%d7; jne lab
-#define is_not_atari(lab) moveq &MACH_ATARI,%d7; cmpl %d4,%d7; jne lab
-#define is_not_mvme16x(lab) moveq &MACH_MVME16x,%d7; cmpl %d4,%d7; jne lab
-#define is_not_bvme6000(lab) moveq &MACH_BVME6000,%d7; cmpl %d4,%d7; jne lab
-#define is_not_hp300(lab) moveq &MACH_HP300,%d7	;  cmpl %d4,%d7; jne lab
-
-#define is_040_or_060(lab) btst &D6B_0460,%d6; jne lab
-#define is_not_040_or_060(lab) btst &D6B_0460,%d6; jeq lab
-#define is_060(lab) btst &D6B_060,%d6; jne lab
-#define is_not_060(lab) btst &D6B_060,%d6; jeq lab
+.macro	func_return	name
+	func_return_\name
+.endm
+
+.macro	func_call	name
+	jbsr	.L\name
+.endm
+
+.macro	move_stack	nr,arg1,arg2,arg3,arg4
+.if	\nr
+	move_stack	"(\nr-1)",\arg2,\arg3,\arg4
+	movel	\arg1,%sp@-
+.endif
+.endm
+
+.macro	func_define	name,nr=0
+.macro	\name	arg1,arg2,arg3,arg4
+	move_stack	\nr,\arg1,\arg2,\arg3,\arg4
+	func_call	\name
+.if	\nr
+	lea	%sp@(\nr*4),%sp
+.endif
+.endm
+.endm
+
+func_define	mmu_map,4
+func_define	mmu_map_tt,4
+func_define	mmu_fixup_page_mmu_cache,1
+func_define	mmu_temp_map,2
+func_define	mmu_engage
+func_define	mmu_get_root_table_entry,1
+func_define	mmu_get_ptr_table_entry,2
+func_define	mmu_get_page_table_entry,2
+func_define	mmu_print
+func_define	get_new_page
+
+.macro	mmu_map_eq	arg1,arg2,arg3
+	mmu_map	\arg1,\arg1,\arg2,\arg3
+.endm
+
+.macro	get_bi_record	record
+	pea	\record
+	func_call	get_bi_record
+	addql	#4,%sp
+.endm
+
+func_define	serial_putc,1
+func_define	console_putc,1
+
+.macro	putc	ch
+#if defined(CONSOLE) || defined(SERIAL_DEBUG)
+	pea	\ch
+#endif
+#ifdef CONSOLE
+	func_call	console_putc
+#endif
+#ifdef SERIAL_DEBUG
+	func_call	serial_putc
+#endif
+#if defined(CONSOLE) || defined(SERIAL_DEBUG)
+	addql	#4,%sp
+#endif
+.endm
+
+.macro	dputc	ch
+#ifdef DEBUG
+	putc	\ch
+#endif
+.endm
+
+func_define	putn,1
+
+.macro	dputn	nr
+#ifdef DEBUG
+	putn	\nr
+#endif
+.endm
+
+.macro	puts		string
+#if defined(CONSOLE) || defined(SERIAL_DEBUG)
+	__INITDATA
+.Lstr\@:
+	.string	"\string"
+	__FINIT
+	pea	%pc@(.Lstr\@)
+	func_call	puts
+	addql	#4,%sp
+#endif
+.endm
+
+.macro	dputs	string
+#ifdef DEBUG
+	puts	"\string"
+#endif
+.endm
+
+
+#define is_not_amiga(lab) cmpl &MACH_AMIGA,%pc@(m68k_machtype); jne lab
+#define is_not_atari(lab) cmpl &MACH_ATARI,%pc@(m68k_machtype); jne lab
+#define is_not_mac(lab) cmpl &MACH_MAC,%pc@(m68k_machtype); jne lab
+#define is_not_mvme16x(lab) cmpl &MACH_MVME16x,%pc@(m68k_machtype); jne lab
+#define is_not_bvme6000(lab) cmpl &MACH_BVME6000,%pc@(m68k_machtype); jne lab
+#define is_not_hp300(lab) cmpl &MACH_HP300,%pc@(m68k_machtype); jne lab
+
+#define is_040_or_060(lab)	btst &CPUTYPE_0460,%pc@(.Lcputype+3); jne lab
+#define is_not_040_or_060(lab)	btst &CPUTYPE_0460,%pc@(.Lcputype+3); jeq lab
+#define is_040(lab)		btst &CPUTYPE_040,%pc@(.Lcputype+3); jne lab
+#define is_060(lab)		btst &CPUTYPE_060,%pc@(.Lcputype+3); jne lab
+#define is_not_060(lab)		btst &CPUTYPE_060,%pc@(.Lcputype+3); jeq lab
+#define is_020(lab)		btst &CPUTYPE_020,%pc@(.Lcputype+3); jne lab
+#define is_not_020(lab)		btst &CPUTYPE_020,%pc@(.Lcputype+3); jeq lab
 
 /* On the HP300 we use the on-board LEDs for debug output before
    the console is running.  Writing a 1 bit turns the corresponding LED
    _off_ - on the 340 bit 7 is towards the back panel of the machine.  */
+.macro	leds	mask
 #ifdef CONFIG_HP300
-#define leds(x) is_not_hp300(42f) ; moveb #(x),%d7 ; jbsr Lset_leds; 42:
-#else
-#define leds(x)
+	is_not_hp300(.Lled\@)
+	pea	\mask
+	func_call	leds
+	addql	#4,%sp
+.Lled\@:
 #endif
+.endm
 
 .text
 ENTRY(_stext)
@@ -192,81 +536,193 @@
 	.long	MACH_ATARI, ATARI_BOOTI_VERSION
 	.long	MACH_MVME16x, MVME16x_BOOTI_VERSION
 	.long	MACH_BVME6000, BVME6000_BOOTI_VERSION
+	.long	MACH_MAC, MAC_BOOTI_VERSION
 	.long	0
-1:	jra	SYMBOL_NAME(_start)
+1:	jra	SYMBOL_NAME(__start)
 
-.equ	SYMBOL_NAME(kernel_pmd_table),SYMBOL_NAME(_stext)
-.equ	SYMBOL_NAME(kernel_pg_dir),SYMBOL_NAME(kernel_pmd_table)
-.equ	SYMBOL_NAME(swapper_pg_dir),SYMBOL_NAME(kernel_pg_dir)+(ROOT_TABLE_SIZE<<2)
-.equ	Lavail_pmd_table,SYMBOL_NAME(swapper_pg_dir)+(ROOT_TABLE_SIZE<<2)
+.equ	SYMBOL_NAME(kernel_pg_dir),SYMBOL_NAME(_stext)
 
 .equ	.,SYMBOL_NAME(_stext)+PAGESIZE
 
 ENTRY(_start)
+	jra	SYMBOL_NAME(__start)
+__INIT
+ENTRY(__start)
 
 /*
  * Setup initial stack pointer
  */
-	lea	%pc@(SYMBOL_NAME(_stext):w),%sp
+	lea	%pc@(SYMBOL_NAME(_stext)),%sp
 
 /*
  * Record the CPU and machine type.
  */
 
-	movew	#BI_MACHTYPE,%d0
-	jbsr	Lget_bi_record
-	movel	%a0@,%d4
-	lea	%pc@(SYMBOL_NAME(m68k_machtype)),%a0
-	movel	%d4,%a0@
-	movew	#BI_FPUTYPE,%d0
-	jbsr	Lget_bi_record
-	movel	%a0@,%d0
-	lea	%pc@(SYMBOL_NAME(m68k_fputype)),%a0
-	movel	%d0,%a0@
-	movew	#BI_MMUTYPE,%d0
-	jbsr	Lget_bi_record
-	movel	%a0@,%d0
-	lea	%pc@(SYMBOL_NAME(m68k_mmutype)),%a0
-	movel	%d0,%a0@
-	movew	#BI_CPUTYPE,%d0
-	jbsr	Lget_bi_record
+	get_bi_record	BI_MACHTYPE
+	lea	%pc@(SYMBOL_NAME(m68k_machtype)),%a1
+	movel	%a0@,%a1@
+
+	get_bi_record	BI_FPUTYPE
+	lea	%pc@(SYMBOL_NAME(m68k_fputype)),%a1
+	movel	%a0@,%a1@
+
+	get_bi_record	BI_MMUTYPE
+	lea	%pc@(SYMBOL_NAME(m68k_mmutype)),%a1
+	movel	%a0@,%a1@
+
+	get_bi_record	BI_CPUTYPE
+	lea	%pc@(SYMBOL_NAME(m68k_cputype)),%a1
+	movel	%a0@,%a1@
+
+#ifdef CONFIG_MAC
+/*
+ * For Macintosh, we need to determine the display parameters early (at least
+ * while debugging it).
+ */
+
+	is_not_mac(.Ltest_notmac)
+
+	get_bi_record	BI_MAC_VADDR
+	lea	%pc@(.Lmac_videobase),%a1
+	movel	%a0@,%a1@
+
+	get_bi_record	BI_MAC_VDEPTH
+	lea	%pc@(.Lmac_videodepth),%a1
+	movel	%a0@,%a1@
+
+	get_bi_record	BI_MAC_VDIM
+	lea	%pc@(.Lmac_dimensions),%a1
+	movel	%a0@,%a1@
+
+	get_bi_record	BI_MAC_VROW
+	lea	%pc@(.Lmac_rowbytes),%a1
+	movel	%a0@,%a1@
+
+#ifdef MAC_SERIAL_DEBUG
+	get_bi_record	BI_MAC_SCCBASE
+	lea	%pc@(.Lmac_sccbase),%a1
+	movel	%a0@,%a1@
+#endif /* MAC_SERIAL_DEBUG */
+
+#if 0
+	/*
+	 * Clear the screen
+	 */
+	lea	%pc@(.Lmac_videobase),%a0
+	movel	%a0@,%a1
+	lea	%pc@(.Lmac_dimensions),%a0
+	movel	%a0@,%d1
+	swap	%d1		/* #rows is high bytes */
+	andl	#0xFFFF,%d1	/* rows */
+	subl	#10,%d1
+	lea	%pc@(.Lmac_rowbytes),%a0
+loopy2:
 	movel	%a0@,%d0
-	lea	%pc@(SYMBOL_NAME(m68k_cputype)),%a0
-	movel	%d0,%a0@
+	subql	#1,%d0
+loopx2:
+	moveb	#0x55, %a1@+
+	dbra	%d0,loopx2
+	dbra	%d1,loopy2
+#endif
+
+.Ltest_notmac:
+#endif /* CONFIG_MAC */
+
+
+/*
+ * There are ultimately two pieces of information we want for all kinds of
+ * processors CpuType and CacheBits.  The CPUTYPE was passed in from booter
+ * and is converted here from a booter type definition to a separate bit
+ * number which allows for the standard is_0x0 macro tests.
+ */
+	movel	%pc@(SYMBOL_NAME(m68k_cputype)),%d0
+	/*
+	 * Assume it's an 030
+	 */
+	clrl	%d1
 
+	/*
+	 * Test the BootInfo cputype for 060
+	 */
 	btst	#CPUB_68060,%d0
 	jeq	1f
-	/* '060: d6 := BIT0460|BIT060, cache mode 0x60 (no-cache/non-ser) */
-	movel	#D6F_060+_PAGE_CACHE040W,%d6
-	jra	2f
-1:	btst	#CPUB_68040,%d0
-	jeq	1f
-	/* '040: d6 := BIT0460, cache mode 0x00 (write-through) */
-	movel	#D6F_040+_PAGE_CACHE040W,%d6
-	jra	2f
-1:	/* '020 or '030: d6 := no CPU bit, cache mode unused */
-	moveq	#0,%d6
+	bset	#CPUTYPE_060,%d1
+	bset	#CPUTYPE_0460,%d1
+	jra	3f
+1:
+	/*
+	 * Test the BootInfo cputype for 040
+	 */
+	btst	#CPUB_68040,%d0
+	jeq	2f
+	bset	#CPUTYPE_040,%d1
+	bset	#CPUTYPE_0460,%d1
+	jra	3f
+2:
+	/*
+	 * Test the BootInfo cputype for 020
+	 */
+	btst	#CPUB_68020,%d0
+	jeq	3f
+	bset	#CPUTYPE_020,%d1
+	jra	3f
+3:
+	/*
+	 * Record the cpu type
+	 */
+	lea	%pc@(.Lcputype),%a0
+	movel	%d1,%a0@
 
-2:	lea	%pc@(SYMBOL_NAME(m68k_pgtable_cachemode)),%a0
-	moveq	#0,%d0
-	movew	%d6,%d0
-	movel	%d0,%a0@		/* save cache mode for page tables */
+	/*
+	 * NOTE:
+	 *
+	 * Now the macros are valid:
+	 *	is_040_or_060
+	 *	is_not_040_or_060
+	 *	is_040
+	 *	is_060
+	 *	is_not_060
+	 */
 
 	/*
+	 * Determine the cache mode for pages holding MMU tables
+	 * and for supervisor mode, unused for '020 and '030
+	 */
+	clrl	%d0
+	clrl	%d1
+
+	is_not_040_or_060(.Lsave_cachetype)
+
+	/*
+	 * '040 or '060
+	 * d1 := cacheable write-through
+	 * NOTE: The 68040 manual strongly recommends non-cached for MMU tables,
+	 * but we have been using write-through since at least 2.0.29 so I
+	 * guess it is OK.
+	 */
+#ifdef CONFIG_060_WRITETHROUGH
+	/*
 	 * If this is a 68060 board using drivers with cache coherency
 	 * problems, then supervisor memory accesses need to be write-through
-         * also; otherwise, we want copyback.
+	 * also; otherwise, we want copyback.
 	 */
 
-#if defined(CONFIG_060_WRITETHROUGH)
-	is_not_060(Lset_norm)
-	jra	1f
-Lset_norm:
-	move.w	#_PAGE_CACHE040,%d0
+	is_not_060(1f)
+	movel	#_PAGE_CACHE040W,%d0
+	jra	.Lsave_cachetype
+#endif /* CONFIG_060_WRITETHROUGH */
 1:
-  	lea	%pc@(SYMBOL_NAME(m68k_supervisor_cachemode)),%a0
+	movew	#_PAGE_CACHE040,%d0
+
+	movel	#_PAGE_CACHE040W,%d1
+
+.Lsave_cachetype:
+	/* Save cache mode for supervisor mode and page tables
+	 */
+	lea	%pc@(SYMBOL_NAME(m68k_supervisor_cachemode)),%a0
 	movel	%d0,%a0@
-#endif
+	lea	%pc@(SYMBOL_NAME(m68k_pgtable_cachemode)),%a0
+	movel	%d1,%a0@
 
 /*
  * raise interrupt level
@@ -293,288 +749,120 @@
  */
 
 #ifdef CONFIG_ATARI
-	is_not_atari(Lnotypetest)
+	is_not_atari(.Lnotypetest)
 
 	/* get special machine type (Medusa/Hades/AB40) */
 	moveq	#0,%d3 /* default if tag doesn't exist */
-	movew	#BI_ATARI_MCH_TYPE,%d0
-	jbsr	Lget_bi_record
+	get_bi_record	BI_ATARI_MCH_TYPE
 	tstl	%d0
 	jbmi	1f
 	movel	%a0@,%d3
-1:	
-	/* %d3 is not clobbered until Atari page tables are set up,
-	 * where it is used again. */
-
+	lea	%pc@(SYMBOL_NAME(atari_mch_type)),%a0
+	movel	%d3,%a0@
+1:
 	/* On the Hades, the iobase must be set up before opening the
 	 * serial port. There are no I/O regs at 0x00ffxxxx at all. */
 	moveq	#0,%d0
 	cmpl	#ATARI_MACH_HADES,%d3
 	jbne	1f
 	movel	#0xff000000,%d0		/* Hades I/O base addr: 0xff000000 */
-1:	lea     %pc@(Liobase),%a0
+1:	lea     %pc@(.Liobase),%a0
 	movel   %d0,%a0@
-Lnotypetest:
+
+.Lnotypetest:
 #endif
 
 /*
  * Initialize serial port
  */
-
-	jbsr Lserial_init
-
-	putr()
-	putc('A')
+	jbsr	.Lserial_init
 
 /*
- * Get address at end of bootinfo and mask off at a page boundary.
+ * Initialize console
  */
-	moveq	#0,%d0
-	jbsr	Lget_bi_record
-	addw	#PAGESIZE-1,%a0
-	movel	%a0,%d0
-	andl	#-PAGESIZE,%d0
-	movel	%d0,%a6
-
-	putc('B')
+#ifdef CONFIG_MAC
+	is_not_mac(.Lnocon)
+#ifdef CONSOLE
+	jbsr	.Lconsole_init
+#ifdef CONSOLE_PENGUIN
+	jbsr	.Lconsole_put_penguin
+#endif	/* CONSOLE_PENGUIN */
+	jbsr	.Lconsole_put_stats
+#endif	/* CONSOLE */
+.Lnocon:
+#endif	/* CONFIG_MAC */
+
+
+	putc	'\n'
+	putc	'A'
+	dputn	%pc@(.Lcputype)
+	dputn	%pc@(SYMBOL_NAME(m68k_supervisor_cachemode))
+	dputn	%pc@(SYMBOL_NAME(m68k_pgtable_cachemode))
 
 /*
  * Save physical start address of kernel
  */
-	lea	%pc@(SYMBOL_NAME(_stext)-PAGESIZE:w),%a0
-	movel	%a0,%d5
-
-/*
- * initialize the kernel root table.
- */
-	lea	%pc@(SYMBOL_NAME(kernel_pg_dir):w),%a5
-	movel	%a5,%a0
-	moveq	#ROOT_TABLE_SIZE-1,%d1
-1:	clrl	%a0@+
-	dbra	%d1,1b
+	lea	%pc@(.Lphys_kernel_start),%a0
+	lea	%pc@(SYMBOL_NAME(_stext)),%a1
+	subl	#SYMBOL_NAME(_stext),%a1
+	movel	%a1,%a0@
 
-	/*
-	 * Initialize root table descriptor pointing to the kernel pointer
-	 * table.
-	 */
-	lea	%pc@(Lavail_pmd_table:w),%a4
-	moveq	#_PAGE_TABLE,%d0
-	addl	%a4,%d0
-	movel	%d0,%a5@
+	putc	'B'
 
-	putc('C')
+	leds	0x4
 
 /*
- * Initialize the pointer tables referred to above.  They either point
- * to page tables in the case of the 680[46]0 or contain early
- * termination page descriptors in the case of the 68851 or 68030.
+ *	mmu_init
  *
- * Each pointer table entry points to a 64 entry page table.  16 of these
- * page tables are grouped to form a single 1024 entry page table which
- * fits in a single 4096 byte page.
- *
- * Some register usages:
- *    a0 -> pointer table descriptor address
- *    a1 -> pointer table descriptor
- *    d1 -> counter
- *    d2 -> pointer table descriptor increment (varies according to CPU)
+ *	This block of code does what's necessary to map in the various kinds
+ *	of machines for execution of Linux.
+ *	First map the first 4 MB of kernel code & data
  */
 
-	/* clear the kernel pointer table */
-	movel	%a4,%a0
-	moveq	#PTR_TABLE_SIZE-1,%d1
-1:	clrl	%a0@+
-	dbra	%d1,1b
-
-	movel	%a4,%a0
-	moveq	#15,%d1
-
-	/*
-	 * base value of pointer table descriptor is either
-	 * the address of the first page table (680[46]0)
-	 * or the base address of physical memory (68030).
-	 */
-	is_040_or_060(1f)
-
-	/* 680[23]0 */
-	movel	%d5,%a1				/* base address */
-	addql	#_PAGE_PRESENT,%a1		/* descriptor type */
-	movel	#PAGE_TABLE_SIZE*PAGESIZE,%d2	/* increment */
-	jra	2f
-
-1:	/* 680[46]0 */
-	movel	%a6,%a3			/* base address */
-	addw	#PAGESIZE,%a6		/* allocate page for 16 page tables */
-	lea	%pc@(SYMBOL_NAME(kpt)),%a1
-	movel	%a3,%a1@		/* save address of page table */
-	movel	%a3,%a1
-	addw	#_PAGE_TABLE+_PAGE_ACCESSED,%a1	/* descriptor type */
-	movel	#PAGE_TABLE_SIZE<<2,%d2 /* increment */
-
-2:	movel	%a1,%a0@+
-	addl	%d2,%a1
-	dbra	%d1,2b
-
-	putc('D')
-
-/*
- * If we are running on a 680[46]0, we have a kernel page table and
- * must initialize it.	Make the entries point to the first
- * 4M of physical memory (the memory we are residing in).
- * Set the cache mode bits to Cacheable, Copyback.  Set the Global bits
- * in the descriptors also.
- */
-	is_not_040_or_060(Lnot040)
-
-	putc('F')
-
-	movel	%a3,%a0
-	movel	%d5,%a1
-#if defined(CONFIG_060_WRITETHROUGH)
-	addw	#_PAGE_GLOBAL040+_PAGE_PRESENT+_PAGE_ACCESSED,%a1
-	addl	m68k_supervisor_cachemode,%a1
-#else
-	addw    #_PAGE_GLOBAL040+_PAGE_CACHE040+_PAGE_PRESENT+_PAGE_ACCESSED,%a1
-#endif
-	movew	#(PAGE_TABLE_SIZE*TABLENR_4MB)-1,%d1
-	movel	#PAGESIZE,%d2
-1:	movel	%a1,%a0@+
-	addl	%d2,%a1
-	dbra	%d1,1b
-
-	/*
-	 * on the 68040, pages used to hold mmu tables should
-	 * be initialized as noncachable; the '060 allows write-through.
-	 * Do this for the root table page (which also contains
-	 * all pointer tables utilized thus far) and the
-	 * kernel page table.
-	 */
-	movel	%a5,%d0
-	subl	%d5,%d0
-	moveq	#PAGE_INDEX_SHIFT,%d2
-	lsrl	%d2,%d0
-	lea	%a3@(%d0:l:4),%a2
-	movel	%a2@,%d1
-	andw	#_CACHEMASK040,%d1
-	orw	%d6,%d1
-	movel	%d1,%a2@
+	mmu_map	#0,%pc@(.Lphys_kernel_start),#4*1024*1024,\
+		%pc@(SYMBOL_NAME(m68k_supervisor_cachemode))
 
-	movel	%a3,%d0
-	subl	%d5,%d0
-	lsrl	%d2,%d0
-	lea	%a3@(%d0:l:4),%a2
-	movel	%a2@,%d1
-	andw	#_CACHEMASK040,%d1
-	orw	%d6,%d1
-	movel	%d1,%a2@+
-	/*
-	 * %a2 points now to the page table entry for available pages at %a6,
-	 * hence caching modes for new pages can easily set unless increasing
-	 * of %a2 are forgotten.
-	 */
-Lnot040:
+	putc	'C'
 
-	leds(0x4)
-	
-/*
- * Do any machine specific page table initializations.
- */
 #ifdef CONFIG_AMIGA
-	is_not_amiga(Lnotami)
 
+.Lmmu_init_amiga:
+
+	is_not_amiga(.Lmmu_init_not_amiga)
 /*
- * Setup a mapping of the first 16M of physical address space at virtual
- * address 0x80000000, using early termination page descriptors for the
- * 68030, and proper page tables for the 680[46]0.  Set this area as
- * non-cacheable.
+ * mmu_init_amiga
  */
 
-	putc('H')
-
-	is_040_or_060(Lspami68040)
-
-	/*
-	 * for the 68030, just setup a translation to map in the first
-	 * 32M of physical address space at virtual address 0x80000000
-         * using an early termination page descriptor.
-	 */
-
-	putc('I')
-
-	movel	#_PAGE_NOCACHE030+_PAGE_PRESENT+_PAGE_ACCESSED,%d0
-	movel	%d0,%a5@(0x40<<2)
-
-	jra	Lmapphys
+	putc	'D'
 
-Lspami68040:
+	is_not_040_or_060(1f)
 
 	/*
-	 * for the 680[46]0, use another pointer table, and allocate 4 more
-	 * page tables.  Initialize the pointer table to point to the
-	 * page tables.  Then initialize the page tables to point to
-	 * the first 16M of memory, with no caching (noncachable/serialized).
+	 * 040: Map the 16Meg range physical 0x0 upto logical 0x8000.0000
 	 */
+	mmu_map	#0x80000000,#0,#0x01000000,#_PAGE_NOCACHE_S
 
-	/* clear the amiga pointer table */
-	lea	%a4@(PTR_TABLE_SIZE<<2),%a4
-	moveq	#PTR_TABLE_SIZE-1,%d1
-1:	clrl	%a0@+
-	dbra	%d1,1b
-
-	/* allocate 4 pages for 64 page tables */
-	movel	%a6,%a3
-	addw	#4*PAGESIZE,%a6
-
-	/* initialize the pointer table */
-	movel	%a4,%a0
-	movel	%a3,%a1
-	addw	#_PAGE_TABLE+_PAGE_ACCESSED,%a1	/* base descriptor */
-	movel	#PAGE_TABLE_SIZE<<2,%d2 /* increment */
-	moveq	#TABLENR_16MB-1,%d1
-
-1:	movel	%a1,%a0@+
-	addl	%d2,%a1
-	dbra	%d1,1b
-
-	/* ensure that the root table points to the pointer table */
-	movel	%a4,%a0
-	addw	#_PAGE_TABLE+_PAGE_ACCESSED,%a0
-	movel	%a0,%a5@(0x40<<2)
+	jbra	.Lmmu_init_done
 
+1:
 	/*
-	 * initialize the page tables
-	 * descriptor bits include noncachable/serialized and global bits.
+	 * 030:	Map the 32Meg range physical 0x0 upto logical 0x8000.0000
 	 */
-	movel	%a3,%a0
-	movew	#_PAGE_GLOBAL040+_PAGE_NOCACHE_S+_PAGE_PRESENT+_PAGE_ACCESSED,%a1
-	movel	#PAGESIZE,%d2
-	movew	#(PAGE_TABLE_SIZE*TABLENR_16MB)-1,%d1
-
-1:	movel	%a1,%a0@+
-	addl	%d2,%a1
-	dbra	%d1,1b
-
-	/*
-	 * Finally, since we just allocated 4 page tables, make sure that
-	 * the virtual mapping of the 4 page tables indicates
-	 * noncachable/serialized.
-	 */
-	moveq	#3,%d0
-1:	movel	%a2@,%d1	/* a2 already points to root table offset */
-	andw	#_CACHEMASK040,%d1
-	orw	%d6,%d1
-	movel	%d1,%a2@+
-	dbra	%d0,1b
+	mmu_map	#0x80000000,#0,#0x02000000,#_PAGE_NOCACHE030
+	mmu_map_tt	1,#0xf8000000,#0x08000000,#_PAGE_NOCACHE_S
 
-	jra	Lmapphys
+	jbra	.Lmmu_init_done
 
-Lnotami:
+.Lmmu_init_not_amiga:
 #endif
 
 #ifdef CONFIG_ATARI
-	is_not_atari(Lnotatari)
 
-	move.w	#PAGESIZE,%sp
+.Lmmu_init_atari:
+
+	is_not_atari(.Lmmu_init_not_atari)
+
+	putc	'E'
 
 /* On the Atari, we map the I/O region (phys. 0x00ffxxxx) by mapping
    the last 16 MB of virtual address space to the first 16 MB (i.e.
@@ -591,99 +879,57 @@
 
 	/* I/O base addr for non-Medusa, non-Hades: 0x00000000 */
 	moveq	#0,%d0
+	movel	%pc@(SYMBOL_NAME(atari_mch_type)),%d3
 	cmpl	#ATARI_MACH_MEDUSA,%d3
 	jbeq	2f
 	cmpl	#ATARI_MACH_HADES,%d3
 	jbne	1f
 2:	movel	#0xff000000,%d0 /* Medusa/Hades base addr: 0xff000000 */
 1:	movel	%d0,%d3
-	
-	/* Let the root table point to the new pointer table */
-	lea	%a4@(PTR_TABLE_SIZE<<2),%a4
-	movel	%a4,%a0
-	addw	#_PAGE_TABLE+_PAGE_ACCESSED,%a0
-	movel	%a0,%a5@(0x7f<<2)       /* 0xFE000000 - 0xFFFFFFFF */
 
-	/* clear lower half of the pointer table (0xfexxxxxx) */
-	movel	%a4,%a0
-	movel	#(PTR_TABLE_SIZE/2)-1,%d2
-1:	clrl	%a0@+
-	dbra	%d2,1b
-
-	is_040_or_060(Lspata68040)
-
-/* Mapping of the last 16M of virtual address space to the first 16M
-   for efficient addressing of hardware registers */
-	movel	#PAGE_TABLE_SIZE*PAGESIZE,%d1
-	movel	#(PTR_TABLE_SIZE/2)-1,%d2
-	movel	%d3,%d0
-	orw	#_PAGE_PRESENT+_PAGE_ACCESSED,%d0
-1:	movel	%d0,%a0@+
-	addl	%d1,%d0
-	dbra	%d2,1b
-	moveq	#_PAGE_NOCACHE030,%d0	/* make non-cachable */
-	addl	%d0,%a4@(0x7f<<2)	/* 0xFFFC0000-0xFFFFFFFF (I/O space) */
-/* GK: 0xFFF00000-0xFFF3FFFF (IDE-bus) has to be non-cachable too */
-	addl	%d0,%a4@(0x7c<<2)
-
-	jra	Lmapphys
-
-Lspata68040:
-	/* allocate 4 page tables */
-	movel	%a6,%a3
-	addw	#4*PAGESIZE,%a6
-
-	/* Initialize the upper half of the pointer table (a0 is still valid) */
-	movel	%a3,%a1
-	addw	#_PAGE_TABLE+_PAGE_ACCESSED,%a1
-	movel	#PAGE_TABLE_SIZE<<2,%d2
-	moveq	#TABLENR_16MB-1,%d1
-1:	movel	%a1,%a0@+
-	addl	%d2,%a1
-	dbra 	%d1,1b
-
-	/* Initialize the page tables as noncacheable/serialized! */
-	movel	%a3,%a0
-	movel	%d3,%a1
-	addw	#_PAGE_GLOBAL040+_PAGE_NOCACHE_S+_PAGE_PRESENT+_PAGE_ACCESSED,%a1
-	movel	#PAGESIZE,%d2
-	movew	#(PAGE_TABLE_SIZE*TABLENR_16MB)-1,%d1
-1:	movel	%a1,%a0@+
-	addl	%d2,%a1
-	dbra	%d1,1b
+	is_040_or_060(.Lspata68040)
 
-	/*
-	 * Finally, since we just allocated 4 page tables, make sure that
-	 * the virtual mapping of the 4 page tables indicates
-	 * noncachable or write-through.
-	 */
-	moveq	#3,%d0
-1:	movel	%a2@,%d1	/* a2 already points to root table offset */
-	andw	#_CACHEMASK040,%d1
-	orw	%d6,%d1
-	movel	%d1,%a2@+
-	dbra	%d0,1b
+	/* Map everything non-cacheable, though not all parts really
+	 * need to disable caches (crucial only for 0xffc000..0xffffff
+	 * (standard I/O) and 0xf00000..0xf3ffff (IDE)). The remainder
+	 * isn't really used, except for sometimes peeking into the
+	 * ROMs (mirror at phys. 0x0), so caching isn't necessary for
+	 * this. */
+	mmu_map	#0xff000000,%d3,#0x01000000,#_PAGE_NOCACHE030
 
-Lnotatari:
+	jbra	.Lmmu_init_done
+
+.Lspata68040:
+
+	mmu_map	#0xff000000,%d3,#0x01000000,#_PAGE_NOCACHE_S
+
+	jbra	.Lmmu_init_done
+
+.Lmmu_init_not_atari:
 #endif
 
 #ifdef CONFIG_HP300
-	is_not_hp300(Lnothp300)
+	is_not_hp300(.Lnothp300)
 
 /* On the HP300, we map the ROM, INTIO and DIO regions (phys. 0x00xxxxxx)
-   by mapping 32MB from 0xf0xxxxxx -> 0x00xxxxxx) using an 030 early 
-   termination page descriptor.  The ROM mapping is needed because the LEDs 
+   by mapping 32MB from 0xf0xxxxxx -> 0x00xxxxxx) using an 030 early
+   termination page descriptor.  The ROM mapping is needed because the LEDs
    are mapped there too.  */
 
+	mmu_map	#0xf0000000,#0,#0x01000000,#_PAGE_NOCACHE030
+
+#if 0
 	movel	#_PAGE_NOCACHE030+_PAGE_PRESENT+_PAGE_ACCESSED,%d0
 	movel	%d0,%a5@(0x78<<2)
+#endif
+
+.Lnothp300:
 
-Lnothp300:
-	
 #endif
 
-#if defined(CONFIG_MVME16x)
-	is_not_mvme16x(Lnot16x)
+#ifdef CONFIG_MVME16x
+
+	is_not_mvme16x(.Lnot16x)
 
 	/* Get pointer to board ID data */
 	movel	%d2,%sp@-
@@ -696,415 +942,1520 @@
 	 * On MVME16x we have already created kernel page tables for
 	 * 4MB of RAM at address 0, so now need to do a transparent
 	 * mapping of the top of memory space.  Make it 0.5GByte for now.
+	 * Supervisor only access, so transparent mapping doesn't
+	 * clash with User code virtual address space.
+	 * this covers IO devices, PROM and SRAM.  The PROM and SRAM
+	 * mapping is needed to allow 167Bug to run.
+	 * IO is in the range 0xfff00000 to 0xfffeffff.
+	 * PROM is 0xff800000->0xffbfffff and SRAM is
+	 * 0xffe00000->0xffe1ffff.
 	 */
 
-	movel	#0xe01f0000,%d2		/* logical address base */
-	orw	#0xa040,%d2		/* add in magic bits */
-	.long	0x4e7b2005		/* movec d2,ittr1 */
-	.long	0x4e7b2007		/* movec d2,dttr1 */
+	mmu_map_tt	1,#0xe0000000,#0x20000000,#_PAGE_NOCACHE_S
 
-Lnot16x:
-#endif
+	jbra	.Lmmu_init_done
+
+.Lnot16x:
+#endif	/* CONFIG_MVME162 | CONFIG_MVME167 */
 
-#if defined(CONFIG_BVME6000)
-	is_not_bvme6000(Lnotbvm)
+#ifdef CONFIG_BVME6000
+
+	is_not_bvme6000(.Lnot6000)
 
 	/*
 	 * On BVME6000 we have already created kernel page tables for
 	 * 4MB of RAM at address 0, so now need to do a transparent
-	 * mapping of the top of memory space.  Make it 0.5GByte for now.
+	 * mapping of the top of memory space.  Make it 0.5GByte for now,
+	 * so we can access on-board i/o areas.
+	 * Supervisor only access, so transparent mapping doesn't
+	 * clash with User code virtual address space.
 	 */
 
-	movel	#0xe01f0000,%d2		/* logical address base */
-	orw	#0xa040,%d2		/* add in magic bits */
-	.long	0x4e7b2005		/* movec d2,ittr1 */
-	.long	0x4e7b2007		/* movec d2,dttr1 */
-	.long	0x4e7b2004		/* movec d2,ittr0 */
-	.long	0x4e7b2006		/* movec d2,dttr0 */
+	mmu_map_tt	1,#0xe0000000,#0x20000000,#_PAGE_NOCACHE_S
 
-Lnotbvm:
-#endif
+	jbra	.Lmmu_init_done
+
+.Lnot6000:
+#endif /* CONFIG_BVME6000 */
 
 /*
- * Setup a transparent mapping of the physical memory we are executing in.
+ * mmu_init_mac
+ *
+ * The Macintosh mappings are less clear.
+ *
+ * Even as of this writing, it is unclear how the
+ * Macintosh mappings will be done.  However, as
+ * the first author of this code I'm proposing the
+ * following model:
+ *
+ * Map the kernel (that's already done),
+ * Map the I/O (on most machines that's the
+ * 0x5000.0000 ... 0x5200.0000 range,
+ * Map the video frame buffer using as few pages
+ * as absolutely (this requirement mostly stems from
+ * the fact that when the frame buffer is at
+ * 0x0000.0000 then we know there is valid RAM just
+ * above the screen that we don't want to waste!).
  *
- * Only do this if the physical memory is not in the first 16M Meg, or not on
- * an Amiga since the first 16M is already identity mapped on the Amiga.
+ * By the way, if the frame buffer is at 0x0000.0000
+ * then the Macintosh is known as an RBV based Mac.
+ *
+ * By the way 2, the code currently maps in a bunch of
+ * regions.  But I'd like to cut that out.  (And move most
+ * of the mappings up into the kernel proper ... or only
+ * map what's necessary.)
  */
-Lmapphys:
-	putc('J')
-	leds(0x8)
 
-#ifdef CONFIG_AMIGA
-	is_not_amiga(Lmapphysnotamiga)
+#ifdef CONFIG_MAC
 
-/*
- * The virtual address of the start of the kernel is 0x1000. We transparently
- * translate the memory where we running in and can enable then the MMU. Hence
- * we have now two locations of the kernel in memory and can jump to the final
- * place. Except if the physical location is in the first 16MB, translation
- * will overlap later virtual location, but as we already mapped the first
- * 16MB to 0x80000000, we can jump there after translation and MMU is enabled
- * and then we can switch off translation and go to the final place.
- * On 020/030 we must emulate transparant translation, since 020 doesn't know
- * it, but due to early termination pointer this is easy to do.
- * When MMU is enabled, stack pointer and Lcustom will become again valid and
- * stack points to the unused first page.
- */
+.Lmmu_init_mac:
 
-/*
- * Setup Supervisor Root Pointer register to point to page directory,
- * setup translation register contents and enable translation.
- */
-	putc('K')
+	is_not_mac(.Lmmu_init_not_mac)
 
-	movew	#PAGESIZE,%sp
+	putc	'F'
 
-	/* fixup the Amiga custom register location before printing */
-	lea	%pc@(Lcustom),%a0
-	movel	#0x80000000,%a0@
+	lea	%pc@(.Lmac_videobase),%a0
+	lea	%pc@(.Lconsole_video_virtual),%a1
+	movel	%a0@,%a1@
 
-	is_040_or_060(Lamimmu68040)
+	is_not_040_or_060(1f)
 
-	moveq	#ROOT_INDEX_SHIFT,%d2
-	movel	%d5,%d0
-	lsrl	%d2,%d0
-	movel	%d0,%d1
-	lsll	%d2,%d1
-	orw	#_PAGE_PRESENT+_PAGE_ACCESSED,%d1
-	lsll	#2,%d0
-	movel	%a5@(%d0:w),%d2
-	movel	%d1,%a5@(%d0:w)
-	lea	%pc@(Lmmu),%a3
-	/* no limit, 4byte descriptors */
-	movel	#0x80000002,%a3@
-	movel	%a5,%a3@(4)
-	pmove	%a3@,%srp
-	pmove	%a3@,%crp
-	pflusha
+	moveq	#_PAGE_NOCACHE_S,%d3
+	jbra	2f
+1:
+	moveq	#_PAGE_NOCACHE030,%d3
+2:
 	/*
-	 * enable,super root enable,4096 byte pages,7 bit root index,
-	 * 7 bit pointer index, 6 bit page table index.
+	 * Mac Note: screen address of logical 0xF000.0000 -> <screen physical>
+	 *	     we simply map the 4MB that contains the videomem
 	 */
-	movel	#0x82c07760,%a3@
-	pmove	%a3@,%tc	/* enable the MMU */
-	tstl	%d0
-	jne	1f
-	jmp	%pc@(2f+0x80000000)
-1:	jmp	2f:w
-2:	movel	%d2,%a5@(%d0:w)
-	pflusha
-	jmp	LdoneMMUenable:w
 
-Lamimmu68040:
+	movel	#VIDEOMEMMASK,%d0
+	andl	.Lmac_videobase,%d0
 
-	.chip	68040
-	lea	2f:w,%a0
-	movel	%d5,%d0
-	andl	#0xff000000,%d0
-	jne	1f
-	lea	%pc@(2f+0x80000000),%a0
-1:	orw	#TTR_ENABLE+TTR_KERNELMODE+_PAGE_NOCACHE_S,%d0
-	movec	%d0,%itt0
-	movec	%a5,%urp
-	movec	%a5,%srp
-	pflusha
-	movel	#TC_ENABLE+TC_PAGE4K,%d0
-	/*
-	 * this value is also ok for the 68060, we don`t use the cache
-	 * mode/protection defaults
-	 */
-	movec	%d0,%tc		/* enable the MMU */
-	jmp	%a0@
-2:	moveq	#0,%d0
-	movec	%d0,%itt0
-	jmp	LdoneMMUenable:w
-	.chip	68k
+	mmu_map		#VIDEOMEMBASE,%d0,#VIDEOMEMSIZE,%d3
+	mmu_map_eq	#0x40800000,#0x02000000,%d3	/* rom ? */
+	mmu_map_eq	#0x50000000,#0x02000000,%d3
+	mmu_map_eq	#0x60000000,#0x00400000,%d3
+	mmu_map_eq	#0x9c000000,#0x00400000,%d3
+	mmu_map_tt	1,#0xf8000000,#0x08000000,%d3
+
+	jbra	.Lmmu_init_done
 
-Lmapphysnotamiga:
+.Lmmu_init_not_mac:
 #endif
 
-#ifdef CONFIG_ATARI
-	is_not_atari(Lmapphysnotatari)
+.Lmmu_init_done:
+
+	putc	'G'
+	leds	0x8
 
 /*
- * If the kernel physical address is different from its virtual address, we
- * will temporarily set up an identity mapping of the 16MB chunk with
- * transparent translation where the kernel is executing.
+ * mmu_fixup
+ *
+ * On the 040 class machines, all pages that are used for the
+ * mmu have to be fixed up. According to Motorola, pages holding mmu
+ * tables should be non-cacheable on a '040 and write-through on a
+ * '060. But analysis of the reasons for this, and practical
+ * experience, showed that write-through also works on a '040.
+ *
+ * Allocated memory so far goes from kernel_end to memory_start that
+ * is used for all kind of tables, for that the cache attributes
+ * are now fixed.
  */
-	putc('L')
-
-	/* fixup the  Atari iobase register location before printing */
-	lea	%pc@(Liobase),%a0
-	movel	#0xff000000,%a0@
-
-	is_040_or_060(Latarimmu68040)
-
-	.chip	68030
-	lea	%pc@(Lmmu),%a3
-	movel	%d5,%d0
-	jne	1f
-	lea	LdoneMMUenable:w,%a0
-	jra	3f
-1:	lea	4f:w,%a0
-	andl	#0xff000000,%d0 /* logical address base */
-	jeq	2f
-	orw	#TTR_ENABLE+TTR_CI+TTR_RWM+TTR_FCB2+TTR_FCM1+TTR_FCM0,%d0
-	movel	%d0,%a3@
-	pmove	%a3@,%tt0
-	jra	3f
-	/* tt0 doesn't work if physical and virtual address of kernel is in
-	 * the same 16M area (Falcon with Magnum/FX, kernel in alternate ram)
-	 * Transparent translation through kernel pointer table
-	 * Requires that this code until after MMU enabling lies in
-	 * the 256K page around %d5
-	 */
-2:	movel	%a5@,%d1
-	andw	#0xfff0,%d1
-	movel	%d1,%a1
-	movel	%d5,%d1
-	moveq	#PTR_INDEX_SHIFT,%d0
-	lsrl	%d0,%d1
-	lea	%a1@(%d1:l:4),%a1
-	movel	%d5,%d1
-	orw	#_PAGE_PRESENT+_PAGE_ACCESSED,%d1
-	movel	%a1@,%d2
-	movel	%d1,%a1@
-	lea	5f:w,%a0
-	/* no limit, 4byte descriptors */
-3:	movel	#0x80000002,%a3@
-	movel	%a5,%a3@(4)
-	pmove	%a3@,%srp
-	pmove	%a3@,%crp
-	pflusha
-	/*
-	 * enable,super root enable,4096 byte pages,7 bit root index,
-	 * 7 bit pointer index, 6 bit page table index.
-	 */
-	movel	#0x82c07760,%a3@
-	pmove	%a3@,%tc	/* enable the MMU */
-	jmp	%a0@
-4:	clrl	%a3@
-	pmove	%a3@,%tt0
-	jra	LdoneMMUenable
-5:	movel	%d2,%a1@
-	jra	LdoneMMUenable
-	.chip	68k
+.Lmmu_fixup:
 
-Latarimmu68040:
-	.chip	68040
-	movel	%d5,%d0
-	jne	1f
-	lea	LdoneMMUenable:w,%a0
-	jra	2f
-1:	lea	3f:w,%a0
-	andl	#0xff000000,%d0 /* logical address base */
-	orw	#TTR_ENABLE+TTR_KERNELMODE+_PAGE_NOCACHE_S,%d0
-	movec	%d0,%itt0
-2:	nop
-	pflusha
-	movec	%a5,%srp
-	movec	%a5,%urp
-	movel	#TC_ENABLE+TC_PAGE4K,%d0
-	/*
-	 * this value is also ok for the 68060, we don`t use the cache
-	 * mode/protection defaults
-	 */
-	movec	%d0,%tc		/* enable the MMU */
-	jmp	%a0@
-3:	moveq	#0,%d0
-	movec	%d0,%itt0
-	jra	LdoneMMUenable
-	.chip	68k
+	is_not_040_or_060(.Lmmu_fixup_done)
 
-Lmapphysnotatari:
+#ifdef MMU_NOCACHE_KERNEL
+	jbra	.Lmmu_fixup_done
 #endif
 
-#if defined(CONFIG_MVME16x)
-	is_not_mvme16x(Lmapphysnot16x)
-	/*
-	 * save physaddr of phys mem in register a3
+	/* first fix the page at the start of the kernel, that
+         * contains also kernel_pg_dir.
 	 */
-	moveq	#'L',%d7
-	jbsr	Lserial_putc
+	movel	%pc@(.Lphys_kernel_start),%d0
+	lea	%pc@(SYMBOL_NAME(_stext)),%a0
+	subl	%d0,%a0
+	mmu_fixup_page_mmu_cache	%a0
 
-	.word	0xf4d8		/* CINVA I/D    */
-	.word	0xf518		/* pflusha      */
-	.long	0x4e7bd807	/* movec a5,srp */
-	.long	0x4e7bd806	/* movec a5,urp */
-	movel	#(TC_ENABLE+TC_PAGE4K),%d0
-	.long	0x4e7b0003	/* movec d0,tc  (enable the MMU) */
-	jra	LdoneMMUenable	/* branch to continuation of startup */
+	movel	%pc@(.Lkernel_end),%a0
+	subl	%d0,%a0
+	movel	%pc@(.Lmemory_start),%a1
+	subl	%d0,%a1
+	bra	2f
+1:
+	mmu_fixup_page_mmu_cache	%a0
+	addw	#PAGESIZE,%a0
+2:
+	cmpl	%a0,%a1
+	jgt	1b
 
-Lmapphysnot16x:
+.Lmmu_fixup_done:
 
+#ifdef MMU_PRINT
+	mmu_print
 #endif
 
-#if defined(CONFIG_HP300)
-	is_not_hp300(Lmapphysnothp300)
-
 /*
- * Physical RAM is at 0xff000000.  We want to map the kernel at 0x00000000.
- * In order to avoid disaster when we enable the MMU we need to make a
- * transparent mapping of the RAM we're executing out of as well.
- */
-	/*
-	 * save physaddr of phys mem in register a3
-	 */
+ * mmu_engage
+ *
+ * This chunk of code performs the gruesome task of engaging the MMU.
+ * The reason its gruesome is because when the MMU becomes engaged it
+ * maps logical addresses to physical addresses.  The Program Counter
+ * register is then passed through the MMU before the next instruction
+ * is fetched (the instruction following the engage MMU instruction).
+ * This may mean one of two things:
+ * 1. The Program Counter falls within the logical address space of
+ *    the kernel of which there are two sub-possibilities:
+ *    A. The PC maps to the correct instruction (logical PC == physical
+ *       code location), or
+ *    B. The PC does not map through and the processor will read some
+ *       data (or instruction) which is not the logically next instr.
+ *    As you can imagine, A is good and B is bad.
+ * Alternatively,
+ * 2. The Program Counter does not map through the MMU.  The processor
+ *    will take a Bus Error.
+ * Clearly, 2 is bad.
+ * It doesn't take a wiz kid to figure you want 1.A.
+ * This code creates that possibility.
+ * There are two possible 1.A. states (we now ignore the other above states):
+ * A. The kernel is located at physical memory addressed the same as
+ *    the logical memory for the kernel, i.e., 0x01000.
+ * B. The kernel is located some where else.  e.g., 0x0400.0000
+ *
+ *    Under some conditions the Macintosh can look like A or B.
+ * [A friend and I once noted that Apple hardware engineers should be
+ * wacked twice each day: once when they show up at work (as in, Whack!,
+ * "This is for the screwy hardware we know you're going to design today."),
+ * and also at the end of the day (as in, Whack! "I don't know what
+ * you designed today, but I'm sure it wasn't good."). -- rst]
+ *
+ * This code works on the following premise:
+ * If the kernel start (%d5) is within the first 16 Meg of RAM,
+ * then create a mapping for the kernel at logical 0x8000.0000 to
+ * the physical location of the pc.  And, create a transparent
+ * translation register for the first 16 Meg.  Then, after the MMU
+ * is engaged, the PC can be moved up into the 0x8000.0000 range
+ * and then the transparent translation can be turned off and then
+ * the PC can jump to the correct logical location and it will be
+ * home (finally).  This is essentially the code that the Amiga used
+ * to use.  Now, it's generalized for all processors.  Which means
+ * that a fresh (but temporary) mapping has to be created.  The mapping
+ * is made in page 0 (an as of yet unused location -- except for the
+ * stack!).  This temporary mapping will only require 1 pointer table
+ * and a single page table (it can map 256K).
+ *
+ * OK, alternatively, imagine that the Program Counter is not within
+ * the first 16 Meg.  Then, just use Transparent Translation registers
+ * to do the right thing.
+ *
+ * Last, if _start is already at 0x01000, then there's nothing special
+ * to do (in other words, in a degenerate case of the first case above,
+ * do nothing).
+ *
+ * Let's do it.
+ *
+ *
+ */
 
-	.chip	68030
-	lea	%pc@(Lmmu),%a3
-	movel	%d5,%d0
-	andl	#0xff000000,%d0 /* logical address base */
-	orw	#TTR_ENABLE+TTR_CI+TTR_RWM+TTR_FCB2+TTR_FCM1+TTR_FCM0,%d0
-	movel	%d0,%a3@
-	pmove	%a3@,%tt0
-	/* no limit, 4byte descriptors */
-	movel	#0x80000002,%a3@
-	movel	%a5,%a3@(4)
-	pmove	%a3@,%srp
-	pmove	%a3@,%crp
-	pflusha
-	/*
-	 * enable,super root enable,4096 byte pages,7 bit root index,
-	 * 7 bit pointer index, 6 bit page table index.
-	 */
-	movel	#0x82c07760,%a3@
-	pmove	%a3@,%tc	/* enable the MMU */
-	jmp	1f
-1:	
-	.chip	68k
+	putc	'H'
 
-	/*
-	 * Fix up the custom register to point to the new location of the LEDs.
-	 */
-	lea	%pc@(Lcustom),%a1
-	movel	#0xf0000000,%a1@
+	mmu_engage
 
-	/*
-	 * Energise the FPU and caches.
-	 */
-	orl	#0x64, 0xf05f400c 
-	
-Lmapphysnothp300:
+#ifdef CONFIG_AMIGA
+	is_not_amiga(1f)
+	/* fixup the Amiga custom register location before printing */
+	clrl	.Lcustom
+1:
+#endif
 
+#ifdef CONFIG_ATARI
+	is_not_atari(1f)
+	/* fixup the Atari iobase register location before printing */
+	movel	#0xff000000,.Liobase
+1:
 #endif
 
-#if defined(CONFIG_BVME6000)
-	is_not_bvme6000(Lmapphysnotbvm)
+#ifdef CONFIG_MAC
+	is_not_mac(1f)
+	movel	#~VIDEOMEMMASK,%d0
+	andl	.Lmac_videobase,%d0
+	addl	#VIDEOMEMBASE,%d0
+	movel	%d0,.Lmac_videobase
+1:
+#endif
+
+#ifdef CONFIG_HP300
+	is_not_hp300(1f)
 	/*
-	 * save physaddr of phys mem in register a3
+	 * Fix up the custom register to point to the new location of the LEDs.
 	 */
-	moveq	#'L',%d7
-	jbsr	Lserial_putc
+	movel	#0xf0000000,.Lcustom
 
-	.word	0xf4d8		/* CINVA I/D    */
-	.word	0xf518		/* pflusha      */
-	.long	0x4e7bd807	/* movec a5,srp */
-	.long	0x4e7bd806	/* movec a5,urp */
-	movel	#(TC_ENABLE+TC_PAGE4K),%d0
 	/*
-	 * this value is also ok for the 68060, we don`t use the cache
-	 * mode/protection defaults
+	 * Energise the FPU and caches.
 	 */
-	.long	0x4e7b0003	/* movec d0,tc  (enable the MMU) */
-	jra	LdoneMMUenable	/* branch to continuation of startup */
-
-Lmapphysnotbvm:
-
+	movel	#0x60,0xf05f400c
+1:
 #endif
 
-LdoneMMUenable:
-
 /*
  * Fixup the addresses for the kernel pointer table and availmem.
  * Convert them from physical addresses to virtual addresses.
  */
 
-	putc('M')
-	leds(0x10)
+	putc	'I'
+	leds	0x10
 
-	/*
-	 * d5 contains physaddr of kernel start
-	 */
-	subl	%d5,SYMBOL_NAME(kpt)
-
-	/*
-	 * do the same conversion on the first available memory
+	/* do the same conversion on the first available memory
 	 * address (in a6).
 	 */
-	subl	%d5,%a6
-	movel	%a6,SYMBOL_NAME(availmem) /* first available memory address */
-
-	putc('N')
+	movel	.Lmemory_start,%d0
+	movel	%d0,SYMBOL_NAME(availmem)
 
 /*
  * Enable caches
  */
-	is_040_or_060(Lcache680460)
 
-	movel	#CC3_ENABLE_DB+CC3_CLR_D+CC3_ENABLE_D+CC3_ENABLE_IB+CC3_CLR_I+CC3_ENABLE_I,%d0
-	movec	%d0,%cacr
-	jra	1f
+	is_not_040_or_060(.Lcache_not_680460)
 
-Lcache680460:
+.Lcache680460:
 	.chip	68040
+	nop
 	cpusha	%bc
-	.chip	68k
+	nop
 
-	is_060(Lcache68060)
+	is_060(.Lcache68060)
 
 	movel	#CC6_ENABLE_D+CC6_ENABLE_I,%d0
 	/* MMU stuff works in copyback mode now, so enable the cache */
 	movec	%d0,%cacr
-	jra	1f
+	jra	.Lcache_done
 
-Lcache68060:
-	.chip	68060
+.Lcache68060:
 	movel	#CC6_ENABLE_D+CC6_ENABLE_I+CC6_ENABLE_SB+CC6_PUSH_DPI+CC6_ENABLE_B+CC6_CLRA_B,%d0
 	/* MMU stuff works in copyback mode now, so enable the cache */
 	movec	%d0,%cacr
 	/* enable superscalar dispatch in PCR */
 	moveq	#1,%d0
+	.chip	68060
 	movec	%d0,%pcr
+
+	jbra	.Lcache_done
+.Lcache_not_680460:
+.Lcache68030:
+	.chip	68030
+	movel	#CC3_ENABLE_DB+CC3_CLR_D+CC3_ENABLE_D+CC3_ENABLE_IB+CC3_CLR_I+CC3_ENABLE_I,%d0
+	movec	%d0,%cacr
+
+	jra	.Lcache_done
 	.chip	68k
-1:
+.Lcache_done:
+
+	putc	'J'
 
 /*
  * Setup initial stack pointer
- * We need to get current loaded up with our first task...
  */
 	lea	SYMBOL_NAME(init_task_union),%a2
-	lea	8192(%a2),%sp
+	lea	0x2000(%a2),%sp
+
+/* jump to the kernel start */
+	putc	'\n'
+	leds	0x55
+
+	subl	%a6,%a6		/* clear a6 for gdb */
+	jbsr	SYMBOL_NAME(start_kernel)
+
+/*
+ * Find a tag record in the bootinfo structure
+ * The bootinfo structure is located right after the kernel bss
+ * Returns: d0: size (-1 if not found)
+ *          a0: data pointer (end-of-records if not found)
+ */
+func_start	get_bi_record,%d1
+
+	movel	ARG1,%d0
+	lea	%pc@(SYMBOL_NAME(_end)),%a0
+1:	tstw	%a0@(BIR_TAG)
+	jeq	3f
+	cmpw	%a0@(BIR_TAG),%d0
+	jeq	2f
+	addw	%a0@(BIR_SIZE),%a0
+	jra	1b
+2:	moveq	#0,%d0
+	movew	%a0@(BIR_SIZE),%d0
+	lea	%a0@(BIR_DATA),%a0
+	jra	4f
+3:	moveq	#-1,%d0
+	lea	%a0@(BIR_SIZE),%a0
+4:
+func_return	get_bi_record
+
+
+/*
+ *	MMU Initialization Begins Here
+ *
+ *	The structure of the MMU tables on the 68k machines
+ *	is thus:
+ *	Root Table
+ *		Logical addresses are translated through
+ *	a hierarchical translation mechanism where the high-order
+ *	seven bits of the logical address (LA) are used as an
+ *	index into the "root table."  Each entry in the root
+ *	table has a bit which specifies if it's a valid pointer to a
+ *	pointer table.  Each entry defines a 32KMeg range of memory.
+ *	If an entry is invalid then that logical range of 32M is
+ *	invalid and references to that range of memory (when the MMU
+ *	is enabled) will fault.  If the entry is valid, then it does
+ *	one of two things.  On 040/060 class machines, it points to
+ *	a pointer table which then describes more finely the memory
+ *	within that 32M range.  On 020/030 class machines, a technique
+ *	called "early terminating descriptors" are used.  This technique
+ *	allows an entire 32Meg to be described by a single entry in the
+ *	root table.  Thus, this entry in the root table, contains the
+ *	physical address of the memory or I/O at the logical address
+ *	which the entry represents and it also contains the necessary
+ *	cache bits for this region.
+ *
+ *	Pointer Tables
+ *		Per the Root Table, there will be one or more
+ *	pointer tables.  Each pointer table defines a 32M range.
+ *	Not all of the 32M range need be defined.  Again, the next
+ *	seven bits of the logical address are used an index into
+ *	the pointer table to point to page tables (if the pointer
+ *	is valid).  There will undoubtedly be more than one
+ *	pointer table for the kernel because each pointer table
+ *	defines a range of only 32M.  Valid pointer table entries
+ *	point to page tables, or are early terminating entries
+ *	themselves.
+ *
+ *	Page Tables
+ *		Per the Pointer Tables, each page table entry points
+ *	to the physical page in memory that supports the logical
+ *	address that translates to the particular index.
+ *
+ *	In short, the Logical Address gets translated as follows:
+ *		bits 31..26 - index into the Root Table
+ *		bits 25..18 - index into the Pointer Table
+ *		bits 17..12 - index into the Page Table
+ *		bits 11..0  - offset into a particular 4K page
+ *
+ *	The algorithms which follows do one thing: they abstract
+ *	the MMU hardware.  For example, there are three kinds of
+ *	cache settings that are relevant.  Either, memory is
+ *	being mapped in which case it is either Kernel Code (or
+ *	the RamDisk) or it is MMU data.  On the 030, the MMU data
+ *	option also describes the kernel.  Or, I/O is being mapped
+ *	in which case it has its own kind of cache bits.  There
+ *	are constants which abstract these notions from the code that
+ *	actually makes the call to map some range of memory.
+ *
+ *
+ *
+ */
+
+#ifdef MMU_PRINT
+/*
+ *	mmu_print
+ *
+ *	This algorithm will print out the current MMU mappings.
+ *
+ *	Input:
+ *		%a5 points to the root table.  Everything else is calculated
+ *			from this.
+ */
+
+#define mmu_next_valid		0
+#define mmu_start_logical	4
+#define mmu_next_logical	8
+#define mmu_start_physical	12
+#define mmu_next_physical	16
+
+#define MMU_PRINT_INVALID		-1
+#define MMU_PRINT_VALID			1
+#define MMU_PRINT_UNINITED		0
+
+#define putZc(z,n)		jbne 1f; putc z; jbra 2f; 1: putc n; 2:
+
+func_start	mmu_print,%a0-%a6/%d0-%d7
+
+	lea	%pc@(SYMBOL_NAME(kernel_pg_dir)),%a5
+	lea	%pc@(.Lmmu_print_data),%a0
+	movel	#MMU_PRINT_UNINITED,%a0@(mmu_next_valid)
+
+	is_not_040_or_060(mmu_030_print)
+
+mmu_040_print:
+	puts	"\nMMU040\n"
+	puts	"rp:"
+	putn	%a5
+	putc	'\n'
+#if 0
+	/*
+	 * The following #if/#endif block is a tight algorithm for dumping the 040
+	 * MMU Map in gory detail.  It really isn't that practical unless the
+	 * MMU Map algorithm appears to go awry and you need to debug it at the
+	 * entry per entry level.
+	 */
+	movel	#ROOT_TABLE_SIZE-1,%d5
+	movel	%a5@+,%d7		/* Burn an entry to skip the kernel mappings, they work */
+1:	tstl	%d5
+	jbeq	mmu_print_done
+	subq	#1,%d5
+	movel	%a5@+,%d7
+	btst	#1,%d7
+	jbeq	1b
+
+2:	putn	%d7
+	andil	#0xFFFFFE00,%d7
+	movel	%d7,%a4
+	movel	#PTR_TABLE_SIZE,%d4
+	putc	' '
+3:	tstl	%d4
+	jbeq	11f
+	subq	#1,%d4
+	movel	%a4@+,%d7
+	btst	#1,%d7
+	jbeq	3b
+
+4:	putn	%d7
+	andil	#0xFFFFFF00,%d7
+	movel	%d7,%a3
+	movel	#PAGE_TABLE_SIZE,%d3
+5:	movel	#8,%d2
+6:	tstl	%d3
+	jbeq	31f
+	subq	#1,%d3
+	movel	%a3@+,%d6
+	btst	#0,%d6
+	jbeq	6b
+7:	tstl	%d2
+	jbeq	8f
+	subq	#1,%d2
+	putc	' '
+	jbra	91f
+8:	putc	'\n'
+	movel	#8+1+8+1+1,%d2
+9:	putc	' '
+	dbra	%d2,9b
+	movel	#7,%d2
+91:	putn	%d6
+	jbra	6b
+
+31:	putc	'\n'
+	movel	#8+1,%d2
+32:	putc	' '
+	dbra	%d2,32b
+	jbra	3b
+
+11:	putc	'\n'
+	jbra	1b
+#endif /* MMU 040 Dumping code that's gory and detailed */
+
+	lea	%pc@(SYMBOL_NAME(kernel_pg_dir)),%a5
+	movel	%a5,%a0			/* a0 has the address of the root table ptr */
+	movel	#0x00000000,%a4		/* logical address */
+	moveql	#0,%d0
+40:
+	/* Increment the logical address and preserve in d5 */
+	movel	%a4,%d5
+	addil	#PAGESIZE<<13,%d5
+	movel	%a0@+,%d6
+	btst	#1,%d6
+	jbne	41f
+	jbsr	mmu_print_tuple_invalidate
+	jbra	48f
+41:
+	movel	#0,%d1
+	andil	#0xfffffe00,%d6
+	movel	%d6,%a1
+42:
+	movel	%a4,%d5
+	addil	#PAGESIZE<<6,%d5
+	movel	%a1@+,%d6
+	btst	#1,%d6
+	jbne	43f
+	jbsr	mmu_print_tuple_invalidate
+	jbra	47f
+43:
+	movel	#0,%d2
+	andil	#0xffffff00,%d6
+	movel	%d6,%a2
+44:
+	movel	%a4,%d5
+	addil	#PAGESIZE,%d5
+	movel	%a2@+,%d6
+	btst	#0,%d6
+	jbne	45f
+	jbsr	mmu_print_tuple_invalidate
+	jbra	46f
+45:
+	moveml	%d0-%d1,%sp@-
+	movel	%a4,%d0
+	movel	%d6,%d1
+	andil	#0xfffff4e0,%d1
+	lea	%pc@(mmu_040_print_flags),%a6
+	jbsr	mmu_print_tuple
+	moveml	%sp@+,%d0-%d1
+46:
+	movel	%d5,%a4
+	addq	#1,%d2
+	cmpib	#64,%d2
+	jbne	44b
+47:
+	movel	%d5,%a4
+	addq	#1,%d1
+	cmpib	#128,%d1
+	jbne	42b
+48:
+	movel	%d5,%a4			/* move to the next logical address */
+	addq	#1,%d0
+	cmpib	#128,%d0
+	jbne	40b
+
+	.chip	68040
+	movec	%dtt1,%d0
+	movel	%d0,%d1
+	andiw	#0x8000,%d1		/* is it valid ? */
+	jbeq	1f			/* No, bail out */
+
+	movel	%d0,%d1
+	andil	#0xff000000,%d1		/* Get the address */
+	putn	%d1
+	puts	"=="
+	putn	%d1
+
+	movel	%d0,%d6
+	jbsr	mmu_040_print_flags_tt
+1:
+	movec	%dtt0,%d0
+	movel	%d0,%d1
+	andiw	#0x8000,%d1		/* is it valid ? */
+	jbeq	1f			/* No, bail out */
+
+	movel	%d0,%d1
+	andil	#0xff000000,%d1		/* Get the address */
+	putn	%d1
+	puts	"=="
+	putn	%d1
+
+	movel	%d0,%d6
+	jbsr	mmu_040_print_flags_tt
+1:
+	.chip	68k
+
+	jbra	mmu_print_done
+
+mmu_040_print_flags:
+	btstl	#10,%d6
+	putZc(' ','G')	/* global bit */
+	btstl	#7,%d6
+	putZc(' ','S')	/* supervisor bit */
+mmu_040_print_flags_tt:
+	btstl	#6,%d6
+	jbne	3f
+	putc	'C'
+	btstl	#5,%d6
+	putZc('w','c')	/* write through or copy-back */
+	jbra	4f
+3:
+	putc	'N'
+	btstl	#5,%d6
+	putZc('s',' ')	/* serialized non-cacheable, or non-cacheable */
+4:
+	rts
+
+mmu_030_print_flags:
+	btstl	#6,%d6
+	putZc('C','I')	/* write through or copy-back */
+	rts
+
+mmu_030_print:
+	puts	"\nrp:"
+	putn	%a5
+	puts	"\n\nMMU030\n"
+	movel	%a5,%d0
+	andil	#0xfffffff0,%d0
+	movel	%d0,%a0
+	movel	#0x00000000,%a4		/* logical address */
+	movel	#0,%d0
+30:
+	movel	%a4,%d5
+	addil	#PAGESIZE<<13,%d5
+	movel	%a0@+,%d6
+	btst	#1,%d6			/* is it a ptr? */
+	jbne	31f			/* yes */
+	btst	#0,%d6			/* is it early terminating? */
+	jbeq	1f			/* no */
+	jbsr	mmu_030_print_helper
+	jbra	38f
+1:
+	jbsr	mmu_print_tuple_invalidate
+	jbra	38f
+31:
+	movel	#0,%d1
+	andil	#0xfffffff0,%d6
+	movel	%d6,%a1
+32:
+	movel	%a4,%d5
+	addil	#PAGESIZE<<6,%d5
+	movel	%a1@+,%d6
+	btst	#1,%d6
+	jbne	33f
+	btst	#0,%d6
+	jbeq	1f			/* no */
+	jbsr	mmu_030_print_helper
+	jbra	37f
+1:
+	jbsr	mmu_print_tuple_invalidate
+	jbra	37f
+33:
+	movel	#0,%d2
+	andil	#0xfffffff0,%d6
+	movel	%d6,%a2
+34:
+	movel	%a4,%d5
+	addil	#PAGESIZE,%d5
+	movel	%a2@+,%d6
+	btst	#0,%d6
+	jbne	35f
+	jbsr	mmu_print_tuple_invalidate
+	jbra	36f
+35:
+	jbsr	mmu_030_print_helper
+36:
+	movel	%d5,%a4
+	addq	#1,%d2
+	cmpib	#64,%d2
+	jbne	34b
+37:
+	movel	%d5,%a4
+	addq	#1,%d1
+	cmpib	#128,%d1
+	jbne	32b
+38:
+	movel	%d5,%a4			/* move to the next logical address */
+	addq	#1,%d0
+	cmpib	#128,%d0
+	jbne	30b
+
+mmu_print_done:
+	puts	"\n\n"
+
+func_return	mmu_print
+
+
+mmu_030_print_helper:
+	moveml	%d0-%d1,%sp@-
+	movel	%a4,%d0
+	movel	%d6,%d1
+	lea	%pc@(mmu_030_print_flags),%a6
+	jbsr	mmu_print_tuple
+	moveml	%sp@+,%d0-%d1
+	rts
+
+mmu_print_tuple_invalidate:
+	moveml	%a0/%d7,%sp@-
+
+	lea	%pc@(.Lmmu_print_data),%a0
+	tstl	%a0@(mmu_next_valid)
+	jbmi	mmu_print_tuple_invalidate_exit
+
+	movel	#MMU_PRINT_INVALID,%a0@(mmu_next_valid)
+
+	putn	%a4
+
+	puts	"##\n"
+
+mmu_print_tuple_invalidate_exit:
+	moveml	%sp@+,%a0/%d7
+	rts
+
+
+mmu_print_tuple:
+	moveml	%d0-%d7/%a0,%sp@-
+
+	lea	%pc@(.Lmmu_print_data),%a0
+
+	tstl	%a0@(mmu_next_valid)
+	jbmi	mmu_print_tuple_print
+	jbeq	mmu_print_tuple_print
+	jbpl	mmu_print_tuple_test
+
+mmu_print_tuple_test:
+	cmpl	%a0@(mmu_next_physical),%d1
+	jbeq	mmu_print_tuple_increment
+
+mmu_print_tuple_print:
+	putn	%d0
+	puts	"->"
+	putn	%d1
+
+	movel	%d1,%d6
+	jbsr	%a6@
+
+mmu_print_tuple_record:
+	movel	#MMU_PRINT_VALID,%a0@(mmu_next_valid)
+
+	movel	%d1,%a0@(mmu_next_physical)
+
+mmu_print_tuple_increment:
+	movel	%d5,%d7
+	subl	%a4,%d7
+	addl	%d7,%a0@(mmu_next_physical)
+
+mmu_print_tuple_exit:
+	moveml	%sp@+,%d0-%d7/%a0
+	rts
+
+mmu_print_machine_cpu_types:
+	puts	"machine: "
+
+	is_not_amiga(1f)
+	puts	"amiga"
+	jbra	9f
+1:
+	is_not_atari(2f)
+	puts	"atari"
+	jbra	9f
+2:
+	is_not_mac(3f)
+	puts	"macintosh"
+	jbra	9f
+3:	puts	"unknown"
+9:	putc	'\n'
+
+	puts	"cputype: 0"
+	is_not_060(1f)
+	putc	'6'
+	jbra	9f
+1:
+	is_not_040_or_060(2f)
+	putc	'4'
+	jbra	9f
+2:	putc	'3'
+9:	putc	'0'
+	putc	'\n'
+
+	rts
+#endif /* MMU_PRINT */
+
+/*
+ * mmu_map_tt
+ *
+ * This is a specific function which works on all 680x0 machines.
+ * On 040 & 060 it will attempt to use Transparent Translation registers (tt1).
+ * On 020 & 030 it will call the standard mmu_map which will use early
+ * terminating descriptors.
+ */
+func_start	mmu_map_tt,%d0/%d1/%a0,4
+
+	dputs	"mmu_map_tt:"
+	dputn	ARG1
+	dputn	ARG2
+	dputn	ARG3
+	dputn	ARG4
+	dputc	'\n'
+
+	is_020(.Ldo_map)
+
+	/* Extract the highest bit set
+	 */
+	bfffo	ARG3{#0,#32},%d1
+	cmpw	#8,%d0
+	jcc	.Ldo_map
+
+	/* And get the mask
+	 */
+	moveq	#-1,%d0
+	lsrl	%d1,%d0
+	lsrl	#1,%d0
+
+	/* Mask the address
+	 */
+	movel	%d0,%d1
+	notl	%d1
+	andl	ARG2,%d1
+
+	/* Generate the upper 16bit of the tt register
+	 */
+	lsrl	#8,%d0
+	orl	%d0,%d1
+	clrw	%d1
+
+	is_040_or_060(.Lmmu_map_tt_040)
+
+	/* set 030 specific bits (read/write access for supervisor mode
+	 * (highest function code set, lower two bits masked)
+	 */
+	orw	#TTR_ENABLE+TTR_RWM+TTR_FCB2+TTR_FCM1+TTR_FCM0,%d1
+	movel	ARG4,%d0
+	btst	#6,%d0
+	jeq	1f
+	orw	#TTR_CI,%d1
+
+1:	lea	STACK,%a0
+	dputn	%d1
+	movel	%d1,%a0@
+	.chip	68030
+	tstl	ARG1
+	jne	1f
+	pmove	%a0@,%tt0
+	jra	2f
+1:	pmove	%a0@,%tt1
+2:	.chip	68k
+	jra	.Lmmu_map_tt_done
+
+	/* set 040 specific bits
+	 */
+.Lmmu_map_tt_040:
+	orw	#TTR_ENABLE+TTR_KERNELMODE,%d1
+	orl	ARG4,%d1
+	dputn	%d1
+
+	.chip	68040
+	tstl	ARG1
+	jne	1f
+	movec	%d1,%itt0
+	movec	%d1,%dtt0
+	jra	2f
+1:	movec	%d1,%itt1
+	movec	%d1,%dtt1
+2:	.chip	68k
+
+	jra	.Lmmu_map_tt_done
+
+.Ldo_map:
+	mmu_map_eq	ARG2,ARG3,ARG4
+
+.Lmmu_map_tt_done:
+
+func_return	mmu_map_tt
+
+/*
+ *	mmu_map
+ *
+ *	This routine will map a range of memory using a pointer
+ *	table and allocating the pages on the fly from the kernel.
+ *	The pointer table does not have to be already linked into
+ *	the root table, this routine will do that if necessary.
+ *
+ *	NOTE
+ *	This routine will assert failure and use the serial_putc
+ *	routines in the case of a run-time error.  For example,
+ *	if the address is already mapped.
+ *
+ *	NOTE-2
+ *	This routine will use early terminating descriptors
+ *	where possible for the 68020+68851 and 68030 type
+ *	processors.
+ */
+func_start	mmu_map,%d0-%d4/%a0-%a4
+
+	dputs	"mmu_map:"
+	dputn	ARG1
+	dputn	ARG2
+	dputn	ARG3
+	dputn	ARG4
+	dputc	'\n'
+
+	/* Get logical address and round it down to 256KB
+	 */
+	movel	ARG1,%d0
+	andl	#-(PAGESIZE*PAGE_TABLE_SIZE),%d0
+	movel	%d0,%a3
+
+	/* Get the end address
+	 */
+	movel	ARG1,%a4
+	addl	ARG3,%a4
+
+	/* Get physical address and round it down to 256KB
+	 */
+	movel	ARG2,%d0
+	andl	#-(PAGESIZE*PAGE_TABLE_SIZE),%d0
+	movel	%d0,%a2
+
+	/* Add page attributes to the physical address
+	 */
+	movel	ARG4,%d0
+	orw	#_PAGE_PRESENT+_PAGE_ACCESSED,%d0
+	addw	%d0,%a2
+
+	dputn	%a2
+	dputn	%a3
+	dputn	%a4
+
+	is_not_040_or_060(.Lmmu_map_030)
+
+	addw	#_PAGE_GLOBAL040,%a2
+/*
+ *	MMU 040 & 060 Support
+ *
+ *	The MMU usage for the 040 and 060 is different enough from
+ *	the 030 and 68851 that there is separate code.  This comment
+ *	block describes the data structures and algorithms built by
+ *	this code.
+ *
+ *	The 040 does not support early terminating descriptors, as
+ *	the 030 does.  Therefore, a third level of table is needed
+ *	for the 040, and that would be the page table.  In Linux,
+ *	page tables are allocated directly from the memory above the
+ *	kernel.
+ *
+ */
+
+.Lmmu_map_040:
+	/* Calculate the offset into the root table
+	 */
+	movel	%a3,%d0
+	moveq	#ROOT_INDEX_SHIFT,%d1
+	lsrl	%d1,%d0
+	mmu_get_root_table_entry	%d0
+
+	/* Calculate the offset into the pointer table
+	 */
+	movel	%a3,%d0
+	moveq	#PTR_INDEX_SHIFT,%d1
+	lsrl	%d1,%d0
+	andl	#PTR_TABLE_SIZE-1,%d0
+	mmu_get_ptr_table_entry		%a0,%d0
+
+	/* Calculate the offset into the page table
+	 */
+	movel	%a3,%d0
+	moveq	#PAGE_INDEX_SHIFT,%d1
+	lsrl	%d1,%d0
+	andl	#PAGE_TABLE_SIZE-1,%d0
+	mmu_get_page_table_entry	%a0,%d0
+
+	/* The page table entry must not no be busy
+	 */
+	tstl	%a0@
+	jne	.Lmmu_map_error
+
+	/* Do the mapping and advance the pointers
+	 */
+	movel	%a2,%a0@
+2:
+	addw	#PAGESIZE,%a2
+	addw	#PAGESIZE,%a3
+
+	/* Ready with mapping?
+	 */
+	cmpl	%a3,%a4
+	jhi	.Lmmu_map_040
+	jra	.Lmmu_map_done
+
+.Lmmu_map_030:
+	/* Calculate the offset into the root table
+	 */
+	movel	%a3,%d0
+	moveq	#ROOT_INDEX_SHIFT,%d1
+	lsrl	%d1,%d0
+	mmu_get_root_table_entry	%d0
+
+	/* Check if logical address 32MB aligned,
+	 * so we can try to map it once
+	 */
+	movel	%a3,%d0
+	andl	#(PTR_TABLE_SIZE*PAGE_TABLE_SIZE*PAGESIZE-1)&(-ROOT_TABLE_SIZE),%d0
+	jne	1f
+
+	/* Is there enough to map for 32MB at once
+	 */
+	lea	%a3@(PTR_TABLE_SIZE*PAGE_TABLE_SIZE*PAGESIZE),%a1
+	cmpl	%a1,%a4
+	jcs	1f
+
+	/* The root table entry must not no be busy
+	 */
+	tstl	%a0@
+	jne	.Lmmu_map_error
+
+	/* Do the mapping and advance the pointers
+	 */
+	puts	"early term1"
+	putn	%a2
+	putn	%a3
+	putn	%a1
+	putc	'\n'
+	movel	%a2,%a0@
+
+	movel	%a1,%a3
+	lea	%a2@(PTR_TABLE_SIZE*PAGE_TABLE_SIZE*PAGESIZE),%a2
+	jra	.Lmmu_mapnext_030
+1:
+	/* Calculate the offset into the pointer table
+	 */
+	movel	%a3,%d0
+	moveq	#PTR_INDEX_SHIFT,%d1
+	lsrl	%d1,%d0
+	andl	#PTR_TABLE_SIZE-1,%d0
+	mmu_get_ptr_table_entry		%a0,%d0
+
+	/* The pointer table entry must not no be busy
+	 */
+	tstl	%a0@
+	jne	.Lmmu_map_error
+
+	/* Do the mapping and advance the pointers
+	 */
+	puts	"early term2"
+	putn	%a2
+	putn	%a3
+	putc	'\n'
+	movel	%a2,%a0@
+
+	addl	#PAGE_TABLE_SIZE*PAGESIZE,%a2
+	addl	#PAGE_TABLE_SIZE*PAGESIZE,%a3
+
+.Lmmu_mapnext_030:
+	/* Ready with mapping?
+	 */
+	cmpl	%a3,%a4
+	jhi	.Lmmu_map_030
+	jra	.Lmmu_map_done
+
+.Lmmu_map_error:
+
+	dputs	"mmu_map error:"
+	dputn	%a2
+	dputn	%a3
+	dputc	'\n'
+
+.Lmmu_map_done:
+
+func_return	mmu_map
+
+/*
+ *	mmu_fixup
+ *
+ *	On the 040 class machines, all pages that are used for the
+ *	mmu have to be fixed up.
+ */
+
+func_start	mmu_fixup_page_mmu_cache,%d0/%a0
+
+	dputs	"mmu_fixup_page_mmu_cache"
+	dputn	ARG1
+	dputc	'\n'
+
+	/* Calculate the offset into the root table
+	 */
+	movel	ARG1,%d0
+	moveq	#ROOT_INDEX_SHIFT,%d1
+	lsrl	%d1,%d0
+	mmu_get_root_table_entry	%d0
+
+	/* Calculate the offset into the pointer table
+	 */
+	movel	ARG1,%d0
+	moveq	#PTR_INDEX_SHIFT,%d1
+	lsrl	%d1,%d0
+	andl	#PTR_TABLE_SIZE-1,%d0
+	mmu_get_ptr_table_entry		%a0,%d0
+
+	/* Calculate the offset into the page table
+	 */
+	movel	ARG1,%d0
+	moveq	#PAGE_INDEX_SHIFT,%d1
+	lsrl	%d1,%d0
+	andl	#PAGE_TABLE_SIZE-1,%d1
+	mmu_get_page_table_entry	%a0,%d0
+
+	movel	%a0@,%d0
+	andil	#_CACHEMASK040,%d0
+	orl	%pc@(SYMBOL_NAME(m68k_pgtable_cachemode)),%d0
+	movel	%d0,%a0@
+
+func_return	mmu_fixup_page_mmu_cache
+
+/*
+ *	mmu_temp_map
+ *
+ *	create a temporary mapping to enable the mmu,
+ *	this we don't need any transparation translation tricks.
+ */
+
+func_start	mmu_temp_map,%d0/%d1/%a0/%a1
+
+	dputs	"mmu_temp_map"
+	dputn	ARG1
+	dputn	ARG2
+	dputc	'\n'
+
+	lea	%pc@(.Ltemp_mmap_mem),%a1
+
+	/* Calculate the offset in the root table
+	 */
+	movel	ARG2,%d0
+	moveq	#ROOT_INDEX_SHIFT,%d1
+	lsrl	%d1,%d0
+	mmu_get_root_table_entry	%d0
+
+	/* Check if the table is temporary allocated, so we have to reuse it
+	 */
+	movel	%a0@,%d0
+	cmpl	%pc@(.Lmemory_start),%d0
+	jcc	1f
+
+	/* Temporary allocate a ptr table and insert it into the root table
+	 */
+	movel	%a1@,%d0
+	addl	#512,%a1@
+	orw	#_PAGE_TABLE+_PAGE_ACCESSED,%d0
+	movel	%d0,%a0@
+	dputs	" (new)"
+1:
+	dputn	%d0
+	/* Mask the root table entry for the ptr table
+	 */
+	andw	#-ROOT_TABLE_SIZE,%d0
+	movel	%d0,%a0
+
+	/* Calculate the offset into the pointer table
+	 */
+	movel	ARG2,%d0
+	moveq	#PTR_INDEX_SHIFT,%d1
+	lsrl	%d1,%d0
+	andl	#PTR_TABLE_SIZE-1,%d0
+	lea	%a0@(%d0*4),%a0
+	dputn	%a0
+
+	/* Check if a temporary page table is already allocated
+	 */
+	movel	%a0@,%d0
+	jne	1f
+
+	/* Temporary allocate a page table and insert it into the ptr table
+	 */
+	movel	%a1@,%d0
+	addl	#512,%a1@
+	orw	#_PAGE_TABLE+_PAGE_ACCESSED,%d0
+	movel	%d0,%a0@
+	dputs	" (new)"
+1:
+	dputn	%d0
+	/* Mask the ptr table entry for the page table
+	 */
+	andw	#-PTR_TABLE_SIZE,%d0
+	movel	%d0,%a0
+
+	/* Calculate the offset into the page table
+	 */
+	movel	ARG2,%d0
+	moveq	#PAGE_INDEX_SHIFT,%d1
+	lsrl	%d1,%d0
+	andl	#PAGE_TABLE_SIZE-1,%d0
+	lea	%a0@(%d0*4),%a0
+	dputn	%a0
+
+	/* Insert the address into the page table
+	 */
+	movel	ARG1,%d0
+	andw	#-PAGESIZE,%d0
+	orw	#_PAGE_PRESENT+_PAGE_ACCESSED,%d0
+	movel	%d0,%a0@
+	dputn	%d0
+
+	dputc	'\n'
+
+func_return	mmu_temp_map
+
+func_start	mmu_engage,%d0-%d2/%a0-%a4,8
+
+	moveq	#ROOT_TABLE_SIZE-1,%d0
+	movel	%pc@(.Lkernel_pgdir_ptr),%a0
+	movel	%pc@(.Lmemory_start),%a1
+1:
+	movel	%a0@+,%a1@+
+	dbra	%d0,1b
+
+	lea	%pc@(.Ltemp_mmap_mem),%a0
+	movel	%a1,%a0@
+
+	movew	#PAGESIZE-1,%d0
+1:
+	clrl	%a1@+
+	dbra	%d0,1b
+
+	lea	%pc@(1b),%a0
+	movel	#1b,%a1
+	mmu_temp_map	%a0,%a0
+	mmu_temp_map	%a0,%a1
+
+	addw	#PAGESIZE,%a0
+	addw	#PAGESIZE,%a1
+	mmu_temp_map	%a0,%a0
+	mmu_temp_map	%a0,%a1
+
+	movel	%pc@(.Lkernel_pgdir_ptr),%a2
+	mmu_temp_map	%a2,%a2
+	movel	%pc@(.Lmemory_start),%a3
+	mmu_temp_map	%a3,%a3
+	movel	%pc@(.Lphys_kernel_start),%d2
+
+	is_not_040_or_060(.Lmmu_engage_030)
+
+.Lmmu_engage_040:
+	.chip	68040
+	nop
+	cinva	%bc
+	nop
+	pflusha
+	nop
+	movec	%a2,%srp
+	movel	#TC_ENABLE+TC_PAGE4K,%d0
+	movec	%d0,%tc		/* enable the MMU */
+	.chip	68k
+	jmp	.Lmmu_engage_cleanup
+
+.Lmmu_engage_030:
+	.chip	68030
+	lea	STACK,%a0
+	movel	#0x80000002,%a0@
+	movel	%a2,%a0@(4)
+	movel	#0x0808,%d0
+	movec	%d0,%cacr
+	pmove	%a0@,%srp
+	pmove	%a0@,%crp
+	pflusha
+	/*
+	 * enable,super root enable,4096 byte pages,7 bit root index,
+	 * 7 bit pointer index, 6 bit page table index.
+	 */
+	movel	#0x82c07760,%a1@
+	pmove	%a1@,%tc	/* enable the MMU */
+	.chip	68k
+	jmp	.Lmmu_engage_cleanup
+
+.Lmmu_engage_cleanup:
+	moveq	#ROOT_TABLE_SIZE-1,%d0
+1:
+	movel	%a3@+,%a2@+
+	dbra	%d0,1b
+
+	is_not_040_or_060(1f)
+
+	.chip	68040
+	pflusha
+	nop
+	.chip	68k
+	jbra	2f
+1:
+	.chip	68030
+	pflusha
+	.chip	68k
+2:
+	subl	%d2,%fp
+	subl	%d2,%sp
+	subl	%d2,ARG0
+	subl	%d2,.Lmemory_start
+	clrl	.Lcustom
+
+func_return	mmu_engage
+
+func_start	mmu_get_root_table_entry,%d0/%a1
+
+|	dputs	"mmu_get_root_table_entry:"
+|	dputn	ARG1
+|	dputs	" ="
+
+	movel	%pc@(.Lkernel_pgdir_ptr),%a0
+	tstl	%a0
+	jne	2f
+
+	dputs	" (mmu_init:"
+
+	/* Find the start of free memory, get_bi_record does this for us,
+	 * as the bootinfo structure is located directly behind the kernel
+	 * and and we simply search for the last entry.
+	 */
+	get_bi_record	BI_LAST
+	addw	#PAGESIZE-1,%a0
+	movel	%a0,%d0
+	andw	#-PAGESIZE,%d0
+
+	dputn	%d0
+
+	lea	%pc@(.Lmemory_start),%a0
+	movel	%d0,%a0@
+	lea	%pc@(.Lkernel_end),%a0
+	movel	%d0,%a0@
+
+	/* we have to return the first page at _stext since the init code
+	 * in mm/init.c simply expects kernel_pg_dir there, the rest of
+	 * page is used for further ptr tables in get_ptr_table.
+	 */
+	lea	%pc@(SYMBOL_NAME(_stext)),%a0
+	lea	%pc@(.Lmmu_cached_pointer_tables),%a1
+	movel	%a0,%a1@
+	addl	#ROOT_TABLE_SIZE*4,%a1@
+
+	lea	%pc@(.Lmmu_num_pointer_tables),%a1
+	addql	#1,%a1@
+
+	/* clear the page
+	 */
+	movel	%a0,%a1
+	movew	#PAGESIZE/4-1,%d0
+1:
+	clrl	%a1@+
+	dbra	%d0,1b
+
+	lea	%pc@(.Lkernel_pgdir_ptr),%a1
+	movel	%a0,%a1@
+
+	dputn	%a0
+	dputs	")"
+2:
+	movel	ARG1,%d0
+	lea	%a0@(%d0*4),%a0
+
+|	dputn	%a0
+|	dputc	'\n'
+
+func_return	mmu_get_root_table_entry
+
+
+
+func_start	mmu_get_ptr_table_entry,%d0/%a1
+
+|	dputs	"mmu_get_ptr_table_entry:"
+|	dputn	ARG1
+|	dputn	ARG2
+|	dputs	" ="
+
+	movel	ARG1,%a0
+	movel	%a0@,%d0
+	jne	2f
+
+	/* Keep track of the number of pointer tables we use
+	 */
+	dputs	"(mmu_get_new_ptr_table:"
+	lea	%pc@(.Lmmu_num_pointer_tables),%a0
+	movel	%a0@,%d0
+	addql	#1,%a0@
+
+	/* See if there is a free pointer table in our cache of pointer tables
+	 */
+	lea	%pc@(.Lmmu_cached_pointer_tables),%a1
+	andw	#7,%d0
+	jne	1f
+
+	/* Get a new pointer table page from above the kernel memory
+	 */
+	get_new_page
+	movel	%a0,%a1@
+1:
+	/* There is an unused pointer table in our cache... use it
+	 */
+	movel	%a1@,%d0
+	addl	#PTR_TABLE_SIZE*4,%a1@
+
+	dputn	%d0
+	dputs	")"
+
+	/* Insert the new pointer table into the root table
+	 */
+	movel	ARG1,%a0
+	orw	#_PAGE_TABLE+_PAGE_ACCESSED,%d0
+	movel	%d0,%a0@
+2:
+	/* Extract the pointer table entry
+	 */
+	andw	#-PTR_TABLE_SIZE,%d0
+	movel	%d0,%a0
+	movel	ARG2,%d0
+	lea	%a0@(%d0*4),%a0
+
+|	dputn	%a0
+|	dputc	'\n'
+
+func_return	mmu_get_ptr_table_entry
+
+
+func_start	mmu_get_page_table_entry,%d0/%a1
+
+|	dputs	"mmu_get_page_table_entry:"
+|	dputn	ARG1
+|	dputn	ARG2
+|	dputs	" ="
+
+	movel	ARG1,%a0
+	movel	%a0@,%d0
+	jne	2f
+
+	/* If the page table entry doesn't exist, we allocate a complete new
+	 * page and use it as one continues big page table which can cover
+	 * 4MB of memory, nearly almost all mappings have that alignment.
+	 */
+	get_new_page
+	addw	#_PAGE_TABLE+_PAGE_ACCESSED,%a0
+
+	/* align pointer table entry for a page of page tables
+	 */
+	movel	ARG1,%d0
+	andw	#-(PAGESIZE/PAGE_TABLE_SIZE),%d0
+	movel	%d0,%a1
+
+	/* Insert the page tables into the pointer entries
+	 */
+	moveq	#PAGESIZE/PAGE_TABLE_SIZE/4-1,%d0
+1:
+	movel	%a0,%a1@+
+	lea	%a0@(PAGE_TABLE_SIZE*4),%a0
+	dbra	%d0,1b
+
+	/* Now we can get the initialized pointer table entry
+	 */
+	movel	ARG1,%a0
+	movel	%a0@,%d0
+2:
+	/* Extract the page table entry
+	 */
+	andw	#-PAGE_TABLE_SIZE,%d0
+	movel	%d0,%a0
+	movel	ARG2,%d0
+	lea	%a0@(%d0*4),%a0
+
+|	dputn	%a0
+|	dputc	'\n'
+
+func_return	mmu_get_page_table_entry
+
+/*
+ *	get_new_page
+ *
+ *	Return a new page from the memory start and clear it.
+ */
+func_start	get_new_page,%d0/%a1
+
+	dputs	"(get_new_page:"
+
+	/* allocate the page and adjust memory_start
+	 */
+	lea	%pc@(.Lmemory_start),%a0
+	movel	%a0@,%a1
+	addl	#PAGESIZE,%a0@
+
+	/* clear the new page
+	 */
+	movel	%a1,%a0
+	movew	#PAGESIZE/4-1,%d0
+1:
+	clrl	%a1@+
+	dbra	%d0,1b
 
-/* jump to the kernel start */
-	putr()
-	leds(0x55)
+	dputn	%a0
+	dputs	")"
+
+func_return	get_new_page
 
-	subl	%a6,%a6 /* clear a6 for gdb */
-	jbsr	SYMBOL_NAME(start_kernel)
 
-/*
- * Find a tag record in the bootinfo structure
- * The bootinfo structure is located right after the kernel bss
- * Returns: d0: size (-1 if not found)
- *          a0: data pointer (end-of-records if not found)
- */
-Lget_bi_record:
-	lea	%pc@(SYMBOL_NAME(_end)),%a0
-1:	tstw	%a0@(BIR_tag)
-	jeq	3f
-	cmpw	%a0@(BIR_tag),%d0
-	jeq	2f
-	addw	%a0@(BIR_size),%a0
-	jra	1b
-2:	moveq	#0,%d0
-	movew	%a0@(BIR_size),%d0
-	lea	%a0@(BIR_data),%a0
-	rts
-3:	moveq	#-1,%d0
-	lea	%a0@(BIR_size),%a0
-	rts
 
 /*
  * Debug output support
@@ -1112,11 +2463,49 @@
  * from the MFP or a serial port of the SCC
  */
 
+#ifdef CONFIG_MAC
+
+.Lscc_initable_mac:
+	.byte	9,12		/* Reset */
+	.byte	4,0x44		/* x16, 1 stopbit, no parity */
+	.byte	3,0xc0		/* receiver: 8 bpc */
+	.byte	5,0xe2		/* transmitter: 8 bpc, assert dtr/rts */
+	.byte	9,0		/* no interrupts */
+	.byte	10,0		/* NRZ */
+	.byte	11,0x50		/* use baud rate generator */
+	.byte	12,10,13,0	/* 9600 baud */
+	.byte	14,1		/* Baud rate generator enable */
+	.byte	3,0xc1		/* enable receiver */
+	.byte	5,0xea		/* enable transmitter */
+	.byte	-1
+	.even
+#endif
+
 #ifdef CONFIG_ATARI
 /* #define USE_PRINTER */
-/* #define USE_SCC */
+/* #define USE_SCC_B */
+/* #define USE_SCC_A */
 #define USE_MFP
 
+#if defined(USE_SCC_A) || defined(USE_SCC_B)
+#define USE_SCC
+/* Initialisation table for SCC */
+.Lscc_initable:
+	.byte	9,12		/* Reset */
+	.byte	4,0x44		/* x16, 1 stopbit, no parity */
+	.byte	3,0xc0		/* receiver: 8 bpc */
+	.byte	5,0xe2		/* transmitter: 8 bpc, assert dtr/rts */
+	.byte	9,0		/* no interrupts */
+	.byte	10,0		/* NRZ */
+	.byte	11,0x50		/* use baud rate generator */
+	.byte	12,24,13,0	/* 9600 baud */
+	.byte	14,2,14,3	/* use master clock for BRG, enable */
+	.byte	3,0xc1		/* enable receiver */
+	.byte	5,0xea		/* enable transmitter */
+	.byte	-1
+	.even
+#endif
+
 #ifdef USE_PRINTER
 
 LPSG_SELECT	= 0xff8800
@@ -1129,13 +2518,18 @@
 LSTMFP_DDR	= 0xfffa05
 LSTMFP_IERB	= 0xfffa09
 
-#elif defined(USE_SCC)
- 
-LSCC_CTRL_B	= 0xff8c85
-LSCC_DATA_B	= 0xff8c87
+#elif defined(USE_SCC_B)
+
+LSCC_CTRL	= 0xff8c85
+LSCC_DATA	= 0xff8c87
+
+#elif defined(USE_SCC_A)
+
+LSCC_CTRL	= 0xff8c81
+LSCC_DATA	= 0xff8c83
 
 /* Initialisation table for SCC */
-scc_initable:
+.Lscc_initable:
 	.byte	9,12		/* Reset */
 	.byte	4,0x44		/* x16, 1 stopbit, no parity */
 	.byte	3,0xc0		/* receiver: 8 bpc */
@@ -1159,45 +2553,48 @@
 LMFP_UDR     = 0xfffa2f
 
 #endif
-#endif
-
-#if defined (CONFIG_BVME6000)
-BVME_SCC_CTRL_A = 0xffb0000b
-BVME_SCC_DATA_A = 0xffb0000f
-#endif
+#endif	/* CONFIG_ATARI */
 
 /*
  * Serial port output support.
  */
-LSERPER		= 0xdff032
-LSERDAT		= 0xdff030
-LSERDATR	= 0xdff018
-LSERIAL_CNTRL	= 0xbfd000
-LSERIAL_DTR	= 7
 
 /*
  * Initialize serial port hardware for 9600/8/1
- * a0 thrashed
- * Amiga d0 trashed
- * Atari d0 trashed (a1 in case of SCC)
  */
-	.even
-Lserial_init:
+func_start	serial_init,%d0/%d1/%a0/%a1
+	/*
+	 *	Some of the register usage that follows
+	 *	CONFIG_AMIGA
+	 *		a0 = pointer to boot info record
+	 *		d0 = boot info offset
+	 *	CONFIG_ATARI
+	 *		a0 = address of SCC
+	 *		a1 = Liobase address/address of scc_initable
+	 *		d0 = init data for serial port
+	 *	CONFIG_MAC
+	 *		a0 = address of SCC
+	 *		a1 = address of scc_initable_mac
+	 *		d0 = init data for serial port
+	 */
+
 #ifdef CONFIG_AMIGA
-	cmpil	#MACH_AMIGA,%d4
-	jne	1f
-	bclr	#LSERIAL_DTR,LSERIAL_CNTRL
-	movew	#BI_AMIGA_SERPER,%d0
-	jbsr	Lget_bi_record
-	movew	%a0@,LSERPER
-	jra	9f
+#define SERIAL_DTR	7
+#define SERIAL_CNTRL	CIABBASE+C_PRA
+
+	is_not_amiga(1f)
+	lea	%pc@(.Lcustom),%a0
+	movel	#-ZTWOBASE,%a0@
+	bclr	#SERIAL_DTR,SERIAL_CNTRL-ZTWOBASE
+	get_bi_record	BI_AMIGA_SERPER
+	movew	%a0@,CUSTOMBASE+C_SERPER-ZTWOBASE
+|	movew	#61,CUSTOMBASE+C_SERPER-ZTWOBASE
 1:
 #endif
 #ifdef CONFIG_ATARI
-	cmpil   #MACH_ATARI,%d4
-	jne	4f
-	movel	%pc@(Liobase),%a1
-#ifdef USE_PRINTER
+	is_not_atari(4f)
+	movel	%pc@(.Liobase),%a1
+#if defined(USE_PRINTER)
 	bclr	#0,%a1@(LSTMFP_IERB)
 	bclr	#0,%a1@(LSTMFP_DDR)
 	moveb	#LPSG_CONTROL,%a1@(LPSG_SELECT)
@@ -1209,8 +2606,8 @@
 	bset	#5,%d0
 	moveb	%d0,%a1@(LPSG_WRITE)
 #elif defined(USE_SCC)
-	lea	%a1@(LSCC_CTRL_B),%a0
-	lea	%pc@(scc_initable:w),%a1
+	lea	%a1@(LSCC_CTRL),%a0
+	lea	%pc@(.Lscc_initable),%a1
 2:	moveb	%a1@+,%d0
 	jmi	3f
 	moveb	%d0,%a0@
@@ -1225,174 +2622,845 @@
 	orb	#1,%a1@(LMFP_TDCDR)
 	bset	#1,%a1@(LMFP_TSR)
 #endif
+	jra	.Lserial_init_done
 4:
 #endif
-9:
-	rts
+#ifdef CONFIG_MAC
+	is_not_mac(.Lserial_init_not_mac)
+#ifdef MAC_SERIAL_DEBUG
+#if !defined(MAC_USE_SCC_A) && !defined(MAC_USE_SCC_B)
+#define MAC_USE_SCC_B
+#endif
+#define mac_scc_cha_b_ctrl_offset	0x0
+#define mac_scc_cha_a_ctrl_offset	0x2
+#define mac_scc_cha_b_data_offset	0x4
+#define mac_scc_cha_a_data_offset	0x6
+
+#ifdef MAC_USE_SCC_A
+	/* Initialize channel A */
+	movel	%pc@(.Lmac_sccbase),%a0
+	lea	%pc@(.Lscc_initable_mac),%a1
+5:	moveb	%a1@+,%d0
+	jmi	6f
+	moveb	%d0,%a0@(mac_scc_cha_a_ctrl_offset)
+	moveb	%a1@+,%a0@(mac_scc_cha_a_ctrl_offset)
+	jra	5b
+6:
+#endif	/* MAC_USE_SCC_A */
+
+#ifdef MAC_USE_SCC_B
+	/* Initialize channel B */
+#ifndef MAC_USE_SCC_A	/* Load mac_sccbase only if needed */
+	movel	%pc@(.Lmac_sccbase),%a0
+#endif	/* MAC_USE_SCC_A */
+	lea	%pc@(.Lscc_initable_mac),%a1
+7:	moveb	%a1@+,%d0
+	jmi	8f
+	moveb	%d0,%a0@(mac_scc_cha_b_ctrl_offset)
+	moveb	%a1@+,%a0@(mac_scc_cha_b_ctrl_offset)
+	jra	7b
+8:
+#endif	/* MAC_USE_SCC_B */
+#endif	/* MAC_SERIAL_DEBUG */
+
+	jra	.Lserial_init_done
+.Lserial_init_not_mac:
+#endif	/* CONFIG_MAC */
+
+.Lserial_init_done:
+func_return	serial_init
 
-#ifdef CONFIG_HP300
-/* Set LEDs to %d7 */
-	.even
-Lset_leds:
-	moveml	%a0/%a1,%sp@-
-	movel	%pc@(Lcustom),%a1
-	moveb	%d7,%a1@(0x1ffff)
-	moveml	%sp@+,%a0/%a1
-	rts
-#endif
-	
 /*
- * Output character in d7 on serial port.
- * d7 thrashed.
+ * Output character on serial port.
  */
-Lserial_putc:
-	moveml	%a0/%a1,%sp@-
-#if defined(CONFIG_MVME16x)
-	cmpil	#MACH_MVME16x,%d4
-	jne	2f
-	moveb	%d7,%sp@-
-	.long	0x4e4f0020
-	jra	9f
-2:
-#endif
-#ifdef CONFIG_BVME6000
-	cmpil	#MACH_BVME6000,%d4
-	jne	2f
-1:	btst	#2,BVME_SCC_CTRL_A
-	jeq	1b
-	moveb	%d7,BVME_SCC_DATA_A
-	jra	9f
-2:
-#endif
+func_start	serial_putc,%d0/%d1/%a0/%a1
+
+	movel	ARG1,%d0
+	cmpib	#'\n',%d0
+	jbne	1f
+
+	/* A little safe recursion is good for the soul */
+	serial_putc	#'\r'
+1:
+
 #ifdef CONFIG_AMIGA
-	cmpil	#MACH_AMIGA,%d4
-	jne	2f
-	andw	#0x00ff,%d7
-	oriw	#0x0100,%d7
-	movel	%pc@(Lcustom),%a1
-	movew	%d7,%a1@(LSERDAT)
-1:	movew	%a1@(LSERDATR),%d7
-	andw	#0x2000,%d7
+	is_not_amiga(2f)
+	andw	#0x00ff,%d0
+	oriw	#0x0100,%d0
+	movel	%pc@(.Lcustom),%a0
+	movew	%d0,%a0@(CUSTOMBASE+C_SERDAT)
+1:	movew	%a0@(CUSTOMBASE+C_SERDATR),%d0
+	andw	#0x2000,%d0
 	jeq	1b
-	jra	9f
+	jra	.Lserial_putc_done
 2:
 #endif
+
+#ifdef CONFIG_MAC
+	is_not_mac(5f)
+
+#ifdef CONSOLE
+	console_putc	%d0
+#endif /* CONSOLE */
+
+#ifdef MAC_SERIAL_DEBUG
+
+#ifdef MAC_USE_SCC_A
+	movel	%pc@(.Lmac_sccbase),%a1
+3:	btst	#2,%a1@(mac_scc_cha_a_ctrl_offset)
+	jeq	3b
+	moveb	%d0,%a1@(mac_scc_cha_a_data_offset)
+#endif	/* MAC_USE_SCC_A */
+
+#ifdef MAC_USE_SCC_B
+#ifndef MAC_USE_SCC_A	/* Load mac_sccbase only if needed */
+	movel	%pc@(.Lmac_sccbase),%a1
+#endif	/* MAC_USE_SCC_A */
+4:	btst	#2,%a1@(mac_scc_cha_b_ctrl_offset)
+	jeq	4b
+	moveb	%d0,%a1@(mac_scc_cha_b_data_offset)
+#endif	/* MAC_USE_SCC_B */
+
+#endif	/* MAC_SERIAL_DEBUG */
+
+	jra	.Lserial_putc_done
+5:
+#endif	/* CONFIG_MAC */
+
 #ifdef CONFIG_ATARI
-	cmpil   #MACH_ATARI,%d4
-	jne	4f
-	movel	%pc@(Liobase),%a1
-#ifdef USE_PRINTER
+	is_not_atari(4f)
+	movel	%pc@(.Liobase),%a1
+#if defined(USE_PRINTER)
 3:	btst	#0,%a1@(LSTMFP_GPIP)
 	jne	3b
 	moveb	#LPSG_IO_B,%a1@(LPSG_SELECT)
-	moveb	%d7,%a1@(LPSG_WRITE)
+	moveb	%d0,%a1@(LPSG_WRITE)
 	moveb	#LPSG_IO_A,%a1@(LPSG_SELECT)
-	moveb	%a1@(LPSG_READ),%d7
-	bclr	#5,%d7
-	moveb	%d7,%a1@(LPSG_WRITE)
+	moveb	%a1@(LPSG_READ),%d0
+	bclr	#5,%d0
+	moveb	%d0,%a1@(LPSG_WRITE)
 	nop
 	nop
-	bset	#5,%d7
-	moveb	%d7,%a1@(LPSG_WRITE)
+	bset	#5,%d0
+	moveb	%d0,%a1@(LPSG_WRITE)
 #elif defined(USE_SCC)
-3:	btst	#2,%a1@(LSCC_CTRL_B)
+3:	btst	#2,%a1@(LSCC_CTRL)
 	jeq	3b
-	moveb	%d7,%a1@(LSCC_DATA_B)
+	moveb	%d0,%a1@(LSCC_DATA)
 #elif defined(USE_MFP)
 3:	btst	#7,%a1@(LMFP_TSR)
 	jeq	3b
-	moveb	%d7,%a1@(LMFP_UDR)
+	moveb	%d0,%a1@(LMFP_UDR)
 #endif
+	jra	.Lserial_putc_done
 4:
+#endif	/* CONFIG_ATARI */
+
+#ifdef CONFIG_MVME16x
+	is_not_mvme16x(2f)
+	/*
+	 * The VME 16x class has PROM support for serial output
+	 * of some kind;  the TRAP table is still valid.
+	 */
+	moveml	%d0-%d7/%a2-%a6,%sp@-
+	moveb	%d0,%sp@-
+	.long	0x4e4f0020	/* TRAP 0x020 */
+	moveml	%sp@+,%d0-%d7/%a2-%a6
+	jbra	.Lserial_putc_done
+2:
+#endif CONFIG_MVME162 | CONFIG_MVME167
+
+#ifdef CONFIG_BVME6000
+	is_not_bvme6000(2f)
+	/*
+	 * The BVME6000 machine has a serial port ...
+	 */
+1:	btst	#2,BVME_SCC_CTRL_A
+	jeq	1b
+	moveb	%d0,BVME_SCC_DATA_A
+	jbra	.Lserial_putc_done
+2:
 #endif
-9:
-	moveml	%sp@+,%a0/%a1
-	rts
+
+.Lserial_putc_done:
+func_return	serial_putc
 
 /*
- * Output string pointed to by a0 to serial port.
- * a0 trashed.
+ * Output a string.
  */
-Lserial_puts:
-	movel	%d7,%sp@-
-1:	moveb	%a0@+,%d7
-	jeq	2f
-	jbsr	Lserial_putc
-	jra	1b
-2:	movel	%sp@+,%d7
-	rts
+func_start	puts,%d0/%a0
+
+	movel	ARG1,%a0
+	jra	2f
+1:
+#ifdef CONSOLE
+	console_putc	%d0
+#endif 
+#ifdef SERIAL_DEBUG
+	serial_putc	%d0
+#endif
+2:	moveb	%a0@+,%d0
+	jne	1b
+
+func_return	puts
 
 /*
- * Output number in d7 in hex notation on serial port.
+ * Output number in hex notation.
  */
 
-Lserial_putnum:
-	moveml	%d0-%d2/%d7,%sp@-
-	movel	%d7,%d1
-	moveq	#4,%d0
-	moveq	#7,%d2
-L1:	roll	%d0,%d1
-	moveb	%d1,%d7
-	andb	#0x0f,%d7
-	cmpb	#0x0a,%d7
-	jcc	1f
-	addb	#'0',%d7
+func_start	putn,%d0-%d2
+
+	putc	' '
+
+	movel	ARG1,%d0
+	moveq	#7,%d1
+1:	roll	#4,%d0
+	move	%d0,%d2
+	andb	#0x0f,%d2
+	addb	#'0',%d2
+	cmpb	#'9',%d2
+	jls	2f
+	addb	#'A'-('9'+1),%d2
+2:
+#ifdef CONSOLE
+	console_putc	%d2
+#endif 
+#ifdef SERIAL_DEBUG
+	serial_putc	%d2
+#endif
+	dbra	%d1,1b
+
+func_return	putn
+
+#ifdef CONFIG_MAC
+/*
+ *	mac_serial_print
+ *
+ *	This routine takes its parameters on the stack.  It then
+ *	turns around and calls the internal routine.  This routine
+ *	is used until the Linux console driver initializes itself.
+ *
+ *	The calling parameters are:
+ *		void mac_serial_print(const char *str);
+ *
+ *	This routine does NOT understand variable arguments only
+ *	simple strings!
+ */
+ENTRY(mac_serial_print)
+	moveml	%d0/%a0,%sp@-
+#if 1
+	move	%sr,%sp@-
+	ori	#0x0700,%sr
+#endif
+	movel	%sp@(10),%a0		/* fetch parameter */
 	jra	2f
-1:	addb	#'A'-10,%d7
-2:	jbsr	Lserial_putc
-	dbra	%d2,L1
-	moveq	#32,%d7
-	jbsr	Lserial_putc
-	moveml	%sp@+,%d0-%d2/%d7
+1:	serial_putc	%d0
+2:	moveb	%a0@+,%d0
+	jne	1b
+#if 1
+	move	%sp@+,%sr
+#endif
+	moveml	%sp@+,%d0/%a0
+	rts
+#endif /* CONFIG_MAC */
+
+#ifdef CONSOLE
+/*
+ *	For continuity, see the data alignment
+ *	to which this structure is tied.
+ */
+#define Lconsole_struct_cur_column	0
+#define Lconsole_struct_cur_row		4
+#define Lconsole_struct_num_columns	8
+#define Lconsole_struct_num_rows	12
+#define Lconsole_struct_left_edge	16
+#define Lconsole_struct_penguin_putc	20
+
+.Lconsole_init:
+	/*
+	 *	Some of the register usage that follows
+	 *		a0 = pointer to boot_info
+	 *		a1 = pointer to screen
+	 *		a2 = pointer to Lconsole_globals
+	 *		d3 = pixel width of screen
+	 *		d4 = pixel height of screen
+	 *		(d3,d4) ~= (x,y) of a point just below
+	 *			and to the right of the screen
+	 *			NOT on the screen!
+	 *		d5 = number of bytes per scan line
+	 *		d6 = number of bytes on the entire screen
+	 */
+	moveml	%a0-%a4/%d0-%d7,%sp@-
+
+	lea	%pc@(SYMBOL_NAME(.Lconsole_globals)),%a2
+	lea	%pc@(.Lmac_videobase),%a0
+	movel	%a0@,%a1
+	lea	%pc@(.Lmac_rowbytes),%a0
+	movel	%a0@,%d5
+	lea	%pc@(.Lmac_dimensions),%a0
+	movel	%a0@,%d3	/* -> low byte */
+	movel	%d3,%d4
+	swap	%d4		/* -> high byte */
+	andl	#0xffff,%d3	/* d3 = screen width in pixels */
+	andl	#0xffff,%d4	/* d4 = screen height in pixels */
+
+	movel	%d5,%d6
+	subl	#20,%d6
+	mulul	%d4,%d6		/* scan line bytes x num scan lines */
+	divul	#8,%d6		/* we'll clear 8 bytes at a time */
+	subq	#1,%d6
+
+console_clear_loop:
+	movel	#0xffffffff,%a1@+	/* Mac_black */
+	movel	#0xffffffff,%a1@+	/* Mac_black */
+	dbra	%d6,console_clear_loop
+
+	/* Calculate font size */
+
+#if   defined(FONT_8x8)
+	lea	%pc@(SYMBOL_NAME(font_vga_8x8)), %a0
+#elif defined(FONT_8x16)
+	lea	%pc@(SYMBOL_NAME(font_vga_8x16)),%a0
+#elif defined(FONT_6x11)
+	lea	%pc@(SYMBOL_NAME(font_vga_6x11)),%a0
+#else	/*   (FONT_8x8) default */
+	lea	%pc@(SYMBOL_NAME(font_vga_8x8)), %a0
+#endif
+
+	/*
+	 *	At this point we make a shift in register usage
+	 *	a1 = address of Lconsole_font pointer
+	 */
+	lea	%pc@(SYMBOL_NAME(.Lconsole_font)),%a1
+	movel	%a0,%a1@	/* store pointer to struct fbcon_font_desc in Lconsole_font */
+
+	/*
+	 *	Calculate global maxs
+	 *	Note - we can use either an
+	 *	8 x 16 or 8 x 8 character font
+	 *	6 x 11 also supported
+	 */
+		/* ASSERT: a0 = contents of Lconsole_font */
+	movel	%d3,%d0			/* screen width in pixels */
+	divul	%a0@(FBCON_FONT_DESC_WIDTH),%d0		/* d0 = max num chars per row */
+
+	movel	%d4,%d1			 /* screen height in pixels */
+	divul	%a0@(FBCON_FONT_DESC_HEIGHT),%d1	 /* d1 = max num rows */
+
+	movel	%d0,%a2@(Lconsole_struct_num_columns)
+	movel	%d1,%a2@(Lconsole_struct_num_rows)
+
+	/*
+	 *	Clear the current row and column
+	 */
+	clrl	%a2@(Lconsole_struct_cur_column)
+	clrl	%a2@(Lconsole_struct_cur_row)
+	clrl	%a2@(Lconsole_struct_left_edge)
+
+	/*
+	 * Initialization is complete
+	 */
+	moveml	%sp@+,%a0-%a4/%d0-%d7
+	rts
+
+.Lconsole_put_stats:
+	/*
+	 *	Some of the register usage that follows
+	 *		a0 = pointer to boot_info
+	 *		d7 = value of boot_info fields
+	 */
+	moveml	%a0/%d7,%sp@-
+
+	puts	"\nMacLinux\n\n"
+
+#ifdef SERIAL_DEBUG
+	puts	" vidaddr:"
+	putn	%pc@(.Lmac_videobase)		/* video addr. */
+
+	puts	"\n  _stext:"
+	lea	%pc@(SYMBOL_NAME(_stext)),%a0
+	putn	%a0
+
+	puts	"\nbootinfo:"
+	lea	%pc@(SYMBOL_NAME(_end)),%a0
+	putn	%a0
+
+	puts	"\ncpuid:"
+	putn	%pc@(.Lcputype)
+	putc	'\n'
+
+#  if defined(MMU_PRINT)
+	jbsr	mmu_print_machine_cpu_types
+#  endif /* MMU_PRINT */
+#endif /* SERIAL_DEBUG */
+
+	moveml	%sp@+,%a0/%d7
+	rts
+
+#ifdef CONSOLE_PENGUIN
+.Lconsole_put_penguin:
+	/*
+	 *	Get 'that_penguin' onto the screen in the upper right corner
+	 *	penguin is 64 x 74 pixels, align against right edge of screen
+	 */
+	moveml	%a0-%a1/%d0-%d7,%sp@-
+
+	lea	%pc@(.Lmac_dimensions),%a0
+	movel	%a0@,%d0
+	andil	#0xffff,%d0
+	subil	#64,%d0		/* snug up against the right edge */
+	clrl	%d1		/* start at the top */
+	movel	#73,%d7
+	lea	%pc@(SYMBOL_NAME(that_penguin)),%a1
+console_penguin_row:
+	movel	#31,%d6
+console_penguin_pixel_pair:
+	moveb	%a1@,%d2
+	lsrb	#4,%d2
+	jbsr	console_plot_pixel
+	addq	#1,%d0
+	moveb	%a1@+,%d2
+	jbsr	console_plot_pixel
+	addq	#1,%d0
+	dbra	%d6,console_penguin_pixel_pair
+
+	subil	#64,%d0
+	addq	#1,%d1
+	dbra	%d7,console_penguin_row
+
+	moveml	%sp@+,%a0-%a1/%d0-%d7
+	rts
+#endif
+
+console_scroll:
+	moveml	%a0-%a4/%d0-%d7,%sp@-
+
+	/*
+	 * Calculate source and destination addresses
+	 *	output	a1 = dest
+	 *		a2 = source
+	 */
+	lea	%pc@(.Lmac_videobase),%a0
+	movel	%a0@,%a1
+	movel	%a1,%a2
+	lea	%pc@(.Lmac_rowbytes),%a0
+	movel	%a0@,%d5
+	movel	%pc@(SYMBOL_NAME(.Lconsole_font)),%a0
+	mulul	%a0@(FBCON_FONT_DESC_HEIGHT),%d5	/* account for # scan lines per character */
+	addal	%d5,%a2
+
+	/*
+	 * Get dimensions
+	 */
+	lea	%pc@(.Lmac_dimensions),%a0
+	movel	%a0@,%d3
+	movel	%d3,%d4
+	swap	%d4
+	andl	#0xffff,%d3	/* d3 = screen width in pixels */
+	andl	#0xffff,%d4	/* d4 = screen height in pixels */
+
+	/*
+	 * Calculate number of bytes to move
+	 */
+	lea	%pc@(.Lmac_rowbytes),%a0
+	movel	%a0@,%d6
+	movel	%pc@(SYMBOL_NAME(.Lconsole_font)),%a0
+	subl	%a0@(FBCON_FONT_DESC_HEIGHT),%d4	/* we're not scrolling the top row! */
+	mulul	%d4,%d6		/* scan line bytes x num scan lines */
+	divul	#32,%d6		/* we'll move 8 longs at a time */
+	subq	#1,%d6
+
+console_scroll_loop:
+	movel	%a2@+,%a1@+
+	movel	%a2@+,%a1@+
+	movel	%a2@+,%a1@+
+	movel	%a2@+,%a1@+
+	movel	%a2@+,%a1@+
+	movel	%a2@+,%a1@+
+	movel	%a2@+,%a1@+
+	movel	%a2@+,%a1@+
+	dbra	%d6,console_scroll_loop
+
+	lea	%pc@(.Lmac_rowbytes),%a0
+	movel	%a0@,%d6
+	movel	%pc@(SYMBOL_NAME(.Lconsole_font)),%a0
+	mulul	%a0@(FBCON_FONT_DESC_HEIGHT),%d6	/* scan line bytes x font height */
+	divul	#32,%d6			/* we'll move 8 words at a time */
+	subq	#1,%d6
+
+	moveq	#-1,%d0
+console_scroll_clear_loop:
+	movel	%d0,%a1@+
+	movel	%d0,%a1@+
+	movel	%d0,%a1@+
+	movel	%d0,%a1@+
+	movel	%d0,%a1@+
+	movel	%d0,%a1@+
+	movel	%d0,%a1@+
+	movel	%d0,%a1@+
+	dbra	%d6,console_scroll_clear_loop
+
+	moveml	%sp@+,%a0-%a4/%d0-%d7
+	rts
+
+
+func_start	console_putc,%a0/%a1/%d0-%d7
+
+	is_not_mac(console_exit)
+
+	/* Output character in d7 on console.
+	 */
+	movel	ARG1,%d7
+	cmpib	#'\n',%d7
+	jbne	1f
+
+	/* A little safe recursion is good for the soul */
+	console_putc	#'\r'
+1:
+	lea	%pc@(.Lconsole_globals),%a0
+
+	cmpib	#10,%d7
+	jne	console_not_lf
+	movel	%a0@(Lconsole_struct_cur_row),%d0
+	addil	#1,%d0
+	movel	%d0,%a0@(Lconsole_struct_cur_row)
+	movel	%a0@(Lconsole_struct_num_rows),%d1
+	cmpl	%d1,%d0
+	jcs	1f
+	subil	#1,%d0
+	movel	%d0,%a0@(Lconsole_struct_cur_row)
+	jbsr	console_scroll
+1:
+	jra	console_exit
+
+console_not_lf:
+	cmpib	#13,%d7
+	jne	console_not_cr
+	clrl	%a0@(Lconsole_struct_cur_column)
+	jra	console_exit
+
+console_not_cr:
+	cmpib	#1,%d7
+	jne	console_not_home
+	clrl	%a0@(Lconsole_struct_cur_row)
+	clrl	%a0@(Lconsole_struct_cur_column)
+	jra	console_exit
+
+/*
+ *	At this point we know that the %d7 character is going to be
+ *	rendered on the screen.  Register usage is -
+ *		a0 = pointer to console globals
+ *		a1 = font data
+ *		d0 = cursor column
+ *		d1 = cursor row to draw the character
+ *		d7 = character number
+ */
+console_not_home:
+	movel	%a0@(Lconsole_struct_cur_column),%d0
+	addil	#1,%a0@(Lconsole_struct_cur_column)
+	movel	%a0@(Lconsole_struct_num_columns),%d1
+	cmpl	%d1,%d0
+	jcs	1f
+	putc	'\n'	/* recursion is OK! */
+1:
+	movel	%a0@(Lconsole_struct_cur_row),%d1
+
+	/*
+	 *	At this point we make a shift in register usage
+	 *	a0 = address of pointer to font data (fbcon_font_desc)
+	 */
+	movel	%pc@(SYMBOL_NAME(.Lconsole_font)),%a0
+	movel	%a0@(FBCON_FONT_DESC_DATA),%a1	/* Load fbcon_font_desc.data into a1 */
+	andl	#0x000000ff,%d7
+		/* ASSERT: a0 = contents of Lconsole_font */
+	mulul	%a0@(FBCON_FONT_DESC_HEIGHT),%d7	/* d7 = index into font data */
+	addl	%d7,%a1			/* a1 = points to char image */
+
+	/*
+	 *	At this point we make a shift in register usage
+	 *	d0 = pixel coordinate, x
+	 *	d1 = pixel coordinate, y
+	 *	d2 = (bit 0) 1/0 for white/black (!) pixel on screen
+	 *	d3 = font scan line data (8 pixels)
+	 *	d6 = count down for the font's pixel width (8)
+	 *	d7 = count down for the font's pixel count in height
+	 */
+		/* ASSERT: a0 = contents of Lconsole_font */
+	mulul	%a0@(FBCON_FONT_DESC_WIDTH),%d0
+	mulul	%a0@(FBCON_FONT_DESC_HEIGHT),%d1
+	movel	%a0@(FBCON_FONT_DESC_HEIGHT),%d7	/* Load fbcon_font_desc.height into d7 */
+	subq	#1,%d7
+console_read_char_scanline:
+	moveb	%a1@+,%d3
+
+		/* ASSERT: a0 = contents of Lconsole_font */
+	movel	%a0@(FBCON_FONT_DESC_WIDTH),%d6	/* Load fbcon_font_desc.width into d6 */
+	subql	#1,%d6
+
+console_do_font_scanline:
+	lslb	#1,%d3
+	scsb	%d2		/* convert 1 bit into a byte */
+	jbsr	console_plot_pixel
+	addq	#1,%d0
+	dbra	%d6,console_do_font_scanline
+
+		/* ASSERT: a0 = contents of Lconsole_font */
+	subl	%a0@(FBCON_FONT_DESC_WIDTH),%d0
+	addq	#1,%d1
+	dbra	%d7,console_read_char_scanline
+
+console_exit:
+
+func_return	console_putc
+
+console_plot_pixel:
+	/*
+	 *	Input:
+	 *		d0 = x coordinate
+	 *		d1 = y coordinate
+	 *		d2 = (bit 0) 1/0 for white/black (!)
+	 *	All registers are preserved
+	 */
+	moveml	%a0-%a1/%d0-%d4,%sp@-
+
+	lea	%pc@(.Lmac_videobase),%a0
+	movel	%a0@,%a1
+	lea	%pc@(.Lmac_videodepth),%a0
+	movel	%a0@,%d3
+	lea	%pc@(.Lmac_rowbytes),%a0
+	mulul	%a0@,%d1
+
+	/*
+	 *	Register usage:
+	 *		d0 = x coord becomes byte offset into frame buffer
+	 *		d1 = y coord
+	 *		d2 = black or white (0/1)
+	 *		d3 = video depth
+	 *		d4 = temp of x (d0) for many bit depths
+	 *		d5 = unused
+	 *		d6 = unused
+	 *		d7 = unused
+	 */
+test_1bit:
+	cmpb	#1,%d3
+	jbne	test_2bit
+	movel	%d0,%d4		/* we need the low order 3 bits! */
+	divul	#8,%d0
+	addal	%d0,%a1
+	addal	%d1,%a1
+	andb	#7,%d4
+	eorb	#7,%d4		/* reverse the x-coordinate w/ screen-bit # */
+	andb	#1,%d2
+	jbne	white_1
+	bsetb	%d4,%a1@
+	jbra	console_plot_pixel_exit
+white_1:
+	bclrb	%d4,%a1@
+	jbra	console_plot_pixel_exit
+
+test_2bit:
+	cmpb	#2,%d3
+	jbne	test_4bit
+	movel	%d0,%d4		/* we need the low order 2 bits! */
+	divul	#4,%d0
+	addal	%d0,%a1
+	addal	%d1,%a1
+	andb	#3,%d4
+	eorb	#3,%d4		/* reverse the x-coordinate w/ screen-bit # */
+	lsll	#1,%d4		/* ! */
+	andb	#1,%d2
+	jbne	white_2
+	bsetb	%d4,%a1@
+	addq	#1,%d4
+	bsetb	%d4,%a1@
+	jbra	console_plot_pixel_exit
+white_2:
+	bclrb	%d4,%a1@
+	addq	#1,%d4
+	bclrb	%d4,%a1@
+	jbra	console_plot_pixel_exit
+
+test_4bit:
+	cmpb	#4,%d3
+	jbne	test_8bit
+	movel	%d0,%d4		/* we need the low order bit! */
+	divul	#2,%d0
+	addal	%d0,%a1
+	addal	%d1,%a1
+	andb	#1,%d4
+	eorb	#1,%d4
+	lsll	#2,%d4		/* ! */
+	andb	#1,%d2
+	jbne	white_4
+	bsetb	%d4,%a1@
+	addq	#1,%d4
+	bsetb	%d4,%a1@
+	addq	#1,%d4
+	bsetb	%d4,%a1@
+	addq	#1,%d4
+	bsetb	%d4,%a1@
+	jbra	console_plot_pixel_exit
+white_4:
+	bclrb	%d4,%a1@
+	addq	#1,%d4
+	bclrb	%d4,%a1@
+	addq	#1,%d4
+	bclrb	%d4,%a1@
+	addq	#1,%d4
+	bclrb	%d4,%a1@
+	jbra	console_plot_pixel_exit
+
+test_8bit:
+	cmpb	#8,%d3
+	jbne	test_16bit
+	addal	%d0,%a1
+	addal	%d1,%a1
+	andb	#1,%d2
+	jbne	white_8
+	moveb	#0xff,%a1@
+	jbra	console_plot_pixel_exit
+white_8:
+	clrb	%a1@
+	jbra	console_plot_pixel_exit
+
+test_16bit:
+	cmpb	#16,%d3
+	jbne	console_plot_pixel_exit
+	addal	%d0,%a1
+	addal	%d0,%a1
+	addal	%d1,%a1
+	andb	#1,%d2
+	jbne	white_16
+	clrw	%a1@
+	jbra	console_plot_pixel_exit
+white_16:
+	movew	#0x0fff,%a1@
+	jbra	console_plot_pixel_exit
+
+console_plot_pixel_exit:
+	moveml	%sp@+,%a0-%a1/%d0-%d4
 	rts
+#endif /* CONSOLE */
 
 #if 0
-Lshowtest:
+/*
+ * This is some old code lying around.  I don't believe
+ * it's used or important anymore.  My guess is it contributed
+ * to getting to this point, but it's done for now.
+ * It was still in the 2.1.77 head.S, so it's still here.
+ * (And still not used!)
+ */
+.Lshowtest:
 	moveml	%a0/%d7,%sp@-
-	putc('A')
-	putc('=')
-	putn(%a1)
-
-	ptestr	#5,%a1@,#7,%a0
-
-	putc('D')
-	putc('A')
-	putc('=')
-	putn(%a0)
-
-	putc('D')
-	putc('=')
-	putn(%a0@)
-
-	putc('S')
-	putc('=')
-	lea	%pc@(Lmmu),%a0
-	pmove	%psr,%a0@
+	puts	"A="
+	putn	%a1
+
+	.long	0xf0119f15		| ptestr	#5,%a1@,#7,%a0
+
+	puts	"DA="
+	putn	%a0
+
+	puts	"D="
+	putn	%a0@
+
+	puts	"S="
+	lea	%pc@(.Lmmu),%a0
+	.long	0xf0106200		| pmove		%psr,%a0@
 	clrl	%d7
 	movew	%a0@,%d7
-	jbsr	Lserial_putnum
+	putn	%d7
 
-	putr()
+	putc	'\n'
 	moveml	%sp@+,%a0/%d7
 	rts
+#endif	/* 0 */
+
+__INITDATA
+	.align	4
+
+#if defined(CONFIG_ATARI) || defined(CONFIG_AMIGA)
+.Lcustom:
+.Liobase:
+	.long 0
+#endif
+
+#ifdef CONFIG_MAC
+.Lconsole_video_virtual:
+	.long	0
+#endif	/* CONFIG_MAC */
+
+#if defined(CONSOLE)
+.Lconsole_globals:
+	.long	0		/* cursor column */
+	.long	0		/* cursor row */
+	.long	0		/* max num columns */
+	.long	0		/* max num rows */
+	.long	0		/* left edge */
+	.long	0		/* mac putc */
+.Lconsole_font:
+	.long	0		/* pointer to console font (struct fbcon_font_desc) */
+#endif /* CONSOLE */
+
+#if defined(MMU_PRINT)
+.Lmmu_print_data:
+	.long	0		/* valid flag */
+	.long	0		/* start logical */
+	.long	0		/* next logical */
+	.long	0		/* start physical */
+	.long	0		/* next physical */
+#endif /* MMU_PRINT */
+
+.Lcputype:
+	.long	0
+.Lmmu_cached_pointer_tables:
+	.long	0
+.Lmmu_num_pointer_tables:
+	.long	0
+.Lphys_kernel_start:
+	.long	0
+.Lkernel_end:
+	.long	0
+.Lmemory_start:
+	.long	0
+.Lkernel_pgdir_ptr:
+	.long	0
+.Ltemp_mmap_mem:
+	.long	0
+
+
+#if defined (CONFIG_BVME6000)
+BVME_SCC_CTRL_A	= 0xffb0000b
+BVME_SCC_DATA_A	= 0xffb0000f
+#endif
+
+#if defined(CONFIG_MAC)
+.Lmac_booter_data:
+	.long	0
+.Lmac_videobase:
+	.long	0
+.Lmac_videodepth:
+	.long	0
+.Lmac_dimensions:
+	.long	0
+.Lmac_rowbytes:
+	.long	0
+#ifdef MAC_SERIAL_DEBUG
+.Lmac_sccbase:
+	.long	0
+#endif /* MAC_SERIAL_DEBUG */
 #endif
+
+__FINIT
 	.data
-	.even
-Lcustom:
-Liobase:
-	.long 0
-Lmmu:	.quad 0
-SYMBOL_NAME_LABEL(kpt)
-	.long 0
+	.align	4
+
 SYMBOL_NAME_LABEL(availmem)
-	.long 0
+	.long	0
 SYMBOL_NAME_LABEL(m68k_pgtable_cachemode)
-	.long 0
-#ifdef CONFIG_060_WRITETHROUGH
+	.long	0
 SYMBOL_NAME_LABEL(m68k_supervisor_cachemode)
-	.long 0
-#endif
+	.long	0
 #if defined(CONFIG_MVME16x)
 SYMBOL_NAME_LABEL(mvme_bdid_ptr)
-	.long 0
+	.long	0
 #endif
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/arch/m68k/kernel/m68k_defs.c linux-2.2-p68k/arch/m68k/kernel/m68k_defs.c
--- linux-2.2-p68k.org/arch/m68k/kernel/m68k_defs.c	Wed Jan  6 00:39:40 1999
+++ linux-2.2-p68k/arch/m68k/kernel/m68k_defs.c	Sat Jan  9 17:50:59 1999
@@ -10,14 +10,78 @@
 
 #include <linux/stddef.h>
 #include <linux/sched.h>
+#include <linux/kernel_stat.h>
+#include <asm/bootinfo.h>
+#include <asm/irq.h>
+#include <asm/amigahw.h>
+#include <video/font.h>
 
 #define DEFINE(sym, val) \
 	asm volatile("\n#define " #sym " %c0" : : "i" (val))
 
 int main(void)
 {
-	DEFINE(TS_TSS, offsetof(struct task_struct, tss));
-	DEFINE(TS_ESP0, offsetof(struct task_struct, tss.esp0));
-	DEFINE(TS_FPU, offsetof(struct task_struct, tss.fp));
+	/* offsets into the task struct */
+	DEFINE(TASK_STATE, offsetof(struct task_struct, state));
+	DEFINE(TASK_FLAGS, offsetof(struct task_struct, flags));
+	DEFINE(TASK_SIGPENDING, offsetof(struct task_struct, sigpending));
+	DEFINE(TASK_NEEDRESCHED, offsetof(struct task_struct, need_resched));
+	DEFINE(TASK_TSS, offsetof(struct task_struct, tss));
+	DEFINE(TASK_MM, offsetof(struct task_struct, mm));
+
+	/* offsets into the thread struct */
+	DEFINE(TSS_KSP, offsetof(struct thread_struct, ksp));
+	DEFINE(TSS_USP, offsetof(struct thread_struct, usp));
+	DEFINE(TSS_SR, offsetof(struct thread_struct, sr));
+	DEFINE(TSS_FS, offsetof(struct thread_struct, fs));
+	DEFINE(TSS_CRP, offsetof(struct thread_struct, crp));
+	DEFINE(TSS_ESP0, offsetof(struct thread_struct, esp0));
+	DEFINE(TSS_FPREG, offsetof(struct thread_struct, fp));
+	DEFINE(TSS_FPCNTL, offsetof(struct thread_struct, fpcntl));
+	DEFINE(TSS_FPSTATE, offsetof(struct thread_struct, fpstate));
+
+	/* offsets into the pt_regs */
+	DEFINE(PT_D0, offsetof(struct pt_regs, d0));
+	DEFINE(PT_ORIG_D0, offsetof(struct pt_regs, orig_d0));
+	DEFINE(PT_SR, offsetof(struct pt_regs, sr));
+
+	/* bitfields are a bit difficult */
+	DEFINE(PT_VECTOR, offsetof(struct pt_regs, pc) + 4);
+
+	/* offsets into the irq_handler struct */
+	DEFINE(IRQ_HANDLER, offsetof(struct irq_node, handler));
+	DEFINE(IRQ_DEVID, offsetof(struct irq_node, dev_id));
+	DEFINE(IRQ_NEXT, offsetof(struct irq_node, next));
+
+	/* offsets into the kernel_stat struct */
+	DEFINE(STAT_IRQ, offsetof(struct kernel_stat, irqs));
+
+	/* offsets into the bi_record struct */
+	DEFINE(BIR_TAG, offsetof(struct bi_record, tag));
+	DEFINE(BIR_SIZE, offsetof(struct bi_record, size));
+	DEFINE(BIR_DATA, offsetof(struct bi_record, data));
+
+	/* offsets into fbcon_font_desc (video/font.h) */
+	DEFINE(FBCON_FONT_DESC_IDX, offsetof(struct fbcon_font_desc, idx));
+	DEFINE(FBCON_FONT_DESC_NAME, offsetof(struct fbcon_font_desc, name));
+	DEFINE(FBCON_FONT_DESC_WIDTH, offsetof(struct fbcon_font_desc, width));
+	DEFINE(FBCON_FONT_DESC_HEIGHT, offsetof(struct fbcon_font_desc, height));
+	DEFINE(FBCON_FONT_DESC_DATA, offsetof(struct fbcon_font_desc, data));
+	DEFINE(FBCON_FONT_DESC_PREF, offsetof(struct fbcon_font_desc, pref));
+
+	/* offsets into the custom struct */
+	DEFINE(CUSTOMBASE, &custom);
+	DEFINE(C_INTENAR, offsetof(struct CUSTOM, intenar));
+	DEFINE(C_INTREQR, offsetof(struct CUSTOM, intreqr));
+	DEFINE(C_INTENA, offsetof(struct CUSTOM, intena));
+	DEFINE(C_INTREQ, offsetof(struct CUSTOM, intreq));
+	DEFINE(C_SERDATR, offsetof(struct CUSTOM, serdatr));
+	DEFINE(C_SERDAT, offsetof(struct CUSTOM, serdat));
+	DEFINE(C_SERPER, offsetof(struct CUSTOM, serper));
+	DEFINE(CIAABASE, &ciaa);
+	DEFINE(CIABBASE, &ciab);
+	DEFINE(C_PRA, offsetof(struct CIA, pra));
+	DEFINE(ZTWOBASE, zTwoBase);
+
 	return 0;
 }
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/arch/m68k/kernel/m68k_ksyms.c linux-2.2-p68k/arch/m68k/kernel/m68k_ksyms.c
--- linux-2.2-p68k.org/arch/m68k/kernel/m68k_ksyms.c	Wed Jan  6 22:39:27 1999
+++ linux-2.2-p68k/arch/m68k/kernel/m68k_ksyms.c	Sun Jan 10 19:18:06 1999
@@ -13,6 +13,7 @@
 #include <asm/machdep.h>
 #include <asm/pgtable.h>
 #include <asm/irq.h>
+#include <asm/io.h>
 #include <asm/semaphore.h>
 #include <asm/checksum.h>
 #include <asm/hardirq.h>
@@ -37,8 +38,10 @@
 EXPORT_SYMBOL(mm_end_of_chunk);
 #endif
 EXPORT_SYMBOL(mm_vtop_fallback);
+EXPORT_SYMBOL(m68k_realnum_memory);
 EXPORT_SYMBOL(m68k_memory);
-EXPORT_SYMBOL(kernel_map);
+EXPORT_SYMBOL(__ioremap);
+EXPORT_SYMBOL(iounmap);
 EXPORT_SYMBOL(m68k_debug_device);
 EXPORT_SYMBOL(dump_fpu);
 EXPORT_SYMBOL(dump_thread);
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/arch/m68k/kernel/setup.c linux-2.2-p68k/arch/m68k/kernel/setup.c
--- linux-2.2-p68k.org/arch/m68k/kernel/setup.c	Sat Oct 31 01:44:58 1998
+++ linux-2.2-p68k/arch/m68k/kernel/setup.c	Sat Jan  9 01:48:36 1999
@@ -48,6 +48,7 @@
 extern unsigned long availmem;
 
 int m68k_num_memory = 0;
+int m68k_realnum_memory = 0;
 struct mem_info m68k_memory[NUM_MEMINFO];
 
 static struct mem_info m68k_ramdisk = { 0, 0 };
@@ -62,8 +63,6 @@
 int (*mach_keyb_init) (void) __initdata;
 int (*mach_kbdrate) (struct kbd_repeat *) = NULL;
 void (*mach_kbd_leds) (unsigned int) = NULL;
-/* machine dependent "kbd-reset" setup function */
-void (*kbd_reset_setup) (char *, int) __initdata = NULL;
 /* machine dependent irq functions */
 void (*mach_init_IRQ) (void) __initdata;
 void (*(*mach_default_handler)[]) (int, void *, struct pt_regs *) = NULL;
@@ -159,6 +158,7 @@
 	record = (struct bi_record *)((u_long)record+record->size);
     }
 
+    m68k_realnum_memory = m68k_num_memory;
 #ifdef CONFIG_SINGLE_MEMORY_CHUNK
     if (m68k_num_memory > 1) {
 	printk("Ignoring last %i chunks of physical memory\n",
@@ -398,9 +398,9 @@
 }
 #endif
 
-__initfunc(unsigned long arch_kbd_init(void))
+/* for "kbd-reset" cmdline param */
+void __init kbd_reset_setup(char *str, int *ints)
 {
-	return mach_keyb_init();
 }
 
 void arch_gettod(int *year, int *mon, int *day, int *hour,
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/arch/m68k/mac/config.c linux-2.2-p68k/arch/m68k/mac/config.c
--- linux-2.2-p68k.org/arch/m68k/mac/config.c	Wed Jan  6 22:25:36 1999
+++ linux-2.2-p68k/arch/m68k/mac/config.c	Sun Jan 10 15:27:42 1999
@@ -55,9 +55,6 @@
 
 void *mac_env;		/* Loaded by the boot asm */
 
-/* The logical video addr. determined by head.S - testing */
-extern unsigned long mac_videobase;
-
 /* The phys. video addr. - might be bogus on some machines */
 unsigned long mac_orig_videoaddr;
 
@@ -65,7 +62,6 @@
 extern int mac_keyb_init(void);
 extern int mac_kbdrate(struct kbd_repeat *k);
 extern void mac_kbd_leds(unsigned int leds);
-extern void mac_kbd_reset_setup(char*, int);
 
 /* Mac specific irq functions */
 extern void mac_init_IRQ (void);
@@ -241,9 +237,7 @@
 	    mac_bi_data.id = *data;
 	    break;
 	case BI_MAC_VADDR:
-	    /* save booter supplied videobase; use the one mapped in head.S! */
-	    mac_orig_videoaddr = *data;
-	    mac_bi_data.videoaddr = mac_videobase;
+	    mac_bi_data.videoaddr = VIDEOMEMBASE + (*data & ~VIDEOMEMMASK);
 	    break;
 	case BI_MAC_VDEPTH:
 	    mac_bi_data.videodepth = *data;
@@ -307,7 +301,6 @@
     mach_keyb_init       = mac_keyb_init;
     mach_kbdrate         = mac_kbdrate;
     mach_kbd_leds        = mac_kbd_leds;
-    kbd_reset_setup      = mac_kbd_reset_setup;
     mach_init_IRQ        = mac_init_IRQ;
     mach_request_irq     = mac_request_irq;
     mach_free_irq        = mac_free_irq;
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/arch/m68k/mac/debug.c linux-2.2-p68k/arch/m68k/mac/debug.c
--- linux-2.2-p68k.org/arch/m68k/mac/debug.c	Wed Jan  6 22:25:36 1999
+++ linux-2.2-p68k/arch/m68k/mac/debug.c	Sat Jan  9 16:36:42 1999
@@ -39,7 +39,7 @@
 extern void mac_serial_print(char *);
 
 #define DEBUG_HEADS
-#define DEBUG_SCREEN
+#undef DEBUG_SCREEN
 #define DEBUG_SERIAL
 
 /*
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/arch/m68k/mac/mackeyb.c linux-2.2-p68k/arch/m68k/mac/mackeyb.c
--- linux-2.2-p68k.org/arch/m68k/mac/mackeyb.c	Wed Jan  6 00:39:55 1999
+++ linux-2.2-p68k/arch/m68k/mac/mackeyb.c	Wed Jan  6 23:19:06 1999
@@ -51,6 +51,8 @@
 #include <linux/kbd_kern.h>
 #include <linux/kbd_ll.h>
 
+#include <config/adbmouse.h>
+
 static void kbd_repeat(unsigned long);
 static struct timer_list repeat_timer = { NULL, NULL, 0, 0, kbd_repeat };
 static int last_keycode;
@@ -759,9 +761,4 @@
 	printk("keyboard init done\n");
 
 	return 0;
-}
-
-/* for "kbd-reset" cmdline param */
-__initfunc(void mac_kbd_reset_setup(char *str, int *ints))
-{
 }
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/arch/m68k/mm/init.c linux-2.2-p68k/arch/m68k/mm/init.c
--- linux-2.2-p68k.org/arch/m68k/mm/init.c	Sat Oct 31 01:45:04 1998
+++ linux-2.2-p68k/arch/m68k/mm/init.c	Sun Jan 10 18:47:50 1999
@@ -28,8 +28,9 @@
 #include <asm/atari_stram.h>
 #endif
 
+#undef DEBUG
+
 extern void die_if_kernel(char *,struct pt_regs *,long);
-extern void init_kpointer_table(void);
 extern void show_net_buffers(void);
 
 int do_check_pgt_cache(int low, int high)
@@ -122,17 +123,14 @@
 unsigned long mm_cachebits = 0;
 #endif
 
-pte_t *kernel_page_table (unsigned long *memavailp)
+static pte_t *__init kernel_page_table(unsigned long *memavailp)
 {
 	pte_t *ptablep;
 
-	if (memavailp) {
-		ptablep = (pte_t *)*memavailp;
-		*memavailp += PAGE_SIZE;
-	}
-	else
-		ptablep = (pte_t *)__get_free_page(GFP_KERNEL);
+	ptablep = (pte_t *)*memavailp;
+	*memavailp += PAGE_SIZE;
 
+	clear_page((unsigned long)ptablep);
 	flush_page_to_ram((unsigned long) ptablep);
 	flush_tlb_kernel_page((unsigned long) ptablep);
 	nocache_page ((unsigned long)ptablep);
@@ -140,199 +138,163 @@
 	return ptablep;
 }
 
-__initfunc(static unsigned long
-map_chunk (unsigned long addr, unsigned long size, unsigned long *memavailp))
-{
-#define ONEMEG	(1024*1024)
-#define L3TREESIZE (256*1024)
+static pmd_t *last_pgtable __initdata = NULL;
 
-	static unsigned long mem_mapped = 0;
-	static unsigned long virtaddr = 0;
-	static pte_t *ktablep = NULL;
-	unsigned long *kpointerp;
-	unsigned long physaddr;
-	extern pte_t *kpt;
-	int pindex;   /* index into pointer table */
-	pgd_t *page_dir = pgd_offset_k (virtaddr);
-
-	if (!pgd_present (*page_dir)) {
-		/* we need a new pointer table */
-		kpointerp = (unsigned long *) get_kpointer_table ();
-		pgd_set (page_dir, (pmd_t *) kpointerp);
-		memset (kpointerp, 0, PTRS_PER_PMD * sizeof (pmd_t));
-	}
-	else
-		kpointerp = (unsigned long *) pgd_page (*page_dir);
+static pmd_t *__init kernel_ptr_table(unsigned long *memavailp)
+{
+	if (!last_pgtable) {
+		unsigned long pmd, last;
+		int i;
 
-	/*
-	 * pindex is the offset into the pointer table for the
-	 * descriptors for the current virtual address being mapped.
-	 */
-	pindex = (virtaddr >> 18) & 0x7f;
+		last = (unsigned long)kernel_pg_dir;
+		for (i = 0; i < PTRS_PER_PGD; i++) {
+			if (!pgd_val(kernel_pg_dir[i]))
+				continue;
+			pmd = (unsigned long)phys_to_virt(pgd_val(kernel_pg_dir[i]));
+			if (pmd > last)
+				last = pmd;
+		}
 
+		last_pgtable = (pmd_t *)(last & -sizeof(pmd_table));
 #ifdef DEBUG
-	printk ("mm=%ld, kernel_pg_dir=%p, kpointerp=%p, pindex=%d\n",
-		mem_mapped, kernel_pg_dir, kpointerp, pindex);
+		printk("kernel_ptr_init: %p\n", last_pgtable);
 #endif
+	}
 
-	/*
-	 * if this is running on an '040, we already allocated a page
-	 * table for the first 4M.  The address is stored in kpt by
-	 * arch/head.S
-	 *
-	 */
-	if (CPU_IS_040_OR_060 && mem_mapped == 0)
-		ktablep = kpt;
-
-	for (physaddr = addr;
-	     physaddr < addr + size;
-	     mem_mapped += L3TREESIZE, virtaddr += L3TREESIZE) {
+	if (((unsigned long)last_pgtable & ~PAGE_MASK) / sizeof(pmd_table) == 7) {
+		last_pgtable = (pmd_t *)*memavailp;
+		*memavailp += PAGE_SIZE;
 
-#ifdef DEBUG
-		printk ("pa=%#lx va=%#lx ", physaddr, virtaddr);
-#endif
+		clear_page((unsigned long)last_pgtable);
+		flush_page_to_ram((unsigned long)last_pgtable);
+		flush_tlb_kernel_page((unsigned long)last_pgtable);
+		nocache_page((unsigned long)last_pgtable);
+	} else
+		last_pgtable += PTRS_PER_PMD;
 
-		if (pindex > 127 && mem_mapped >= 32*ONEMEG) {
-			/* we need a new pointer table every 32M */
-#ifdef DEBUG
-			printk ("[new pointer]");
-#endif
+	return last_pgtable;
+}
 
-			kpointerp = (unsigned long *)get_kpointer_table ();
-			pgd_set(pgd_offset_k(virtaddr), (pmd_t *)kpointerp);
-			pindex = 0;
-		}
+static unsigned long __init
+map_chunk (unsigned long addr, long size, unsigned long *memavailp)
+{
+#define PTRTREESIZE (256*1024)
+#define ROOTTREESIZE (32*1024*1024)
+	static unsigned long virtaddr = 0;
+	unsigned long physaddr;
+	pgd_t *pgd_dir;
+	pmd_t *pmd_dir;
+	pte_t *pte_dir;
 
-		if (CPU_IS_040_OR_060) {
-			int i;
-			unsigned long ktable;
-
-			/* Don't map the first 4 MB again. The pagetables
-			 * for this range have already been initialized
-			 * in boot/head.S. Otherwise the pages used for
-			 * tables would be reinitialized to copyback mode.
-			 */
+	physaddr = addr | m68k_supervisor_cachemode |
+		_PAGE_PRESENT | _PAGE_ACCESSED;
+	if (CPU_IS_040_OR_060)
+		physaddr |= _PAGE_GLOBAL040;
 
-			if (mem_mapped < 4 * ONEMEG)
-			{
+	while (size > 0) {
+#ifdef DEBUG
+		if (!(virtaddr & (PTRTREESIZE-1)))
+			printk ("\npa=%#lx va=%#lx ", physaddr, virtaddr);
+#endif
+		pgd_dir = pgd_offset_k(virtaddr);
+		if (virtaddr && CPU_IS_020_OR_030) {
+			if (!(virtaddr & (ROOTTREESIZE-1)) &&
+			    size >= ROOTTREESIZE) {
 #ifdef DEBUG
-				printk ("Already initialized\n");
+				printk ("[very early term]");
 #endif
-				physaddr += L3TREESIZE;
-				pindex++;
+				pgd_val(*pgd_dir) = physaddr;
+				size -= ROOTTREESIZE;
+				virtaddr += ROOTTREESIZE;
+				physaddr += ROOTTREESIZE;
 				continue;
 			}
+		}
+		if (!pgd_present(*pgd_dir)) {
+			pmd_dir = kernel_ptr_table(memavailp);
 #ifdef DEBUG
-			printk ("[setup table]");
+			printk ("[new pointer %p]", pmd_dir);
 #endif
+			pgd_set(pgd_dir, pmd_dir);
+		} else
+			pmd_dir = pmd_offset(pgd_dir, virtaddr);
 
-			/*
-			 * 68040, use page tables pointed to by the
-			 * kernel pointer table.
-			 */
-
-			if ((pindex & 15) == 0) {
-				/* Need new page table every 4M on the '040 */
+		if (CPU_IS_020_OR_030) {
+			if (virtaddr) {
 #ifdef DEBUG
-				printk ("[new table]");
+				printk ("[early term]");
 #endif
-				ktablep = kernel_page_table (memavailp);
-			}
-
-			ktable = virt_to_phys(ktablep);
-
-			/*
-			 * initialize section of the page table mapping
-			 * this 256K portion.
-			 */
-			for (i = 0; i < 64; i++) {
-				pte_val(ktablep[i]) = physaddr | _PAGE_PRESENT
-				  | m68k_supervisor_cachemode | _PAGE_GLOBAL040
-					| _PAGE_ACCESSED;
+				pmd_dir->pmd[(virtaddr/PTRTREESIZE)&-16] = physaddr;
+				physaddr += PTRTREESIZE;
+			} else {
+				int i;
+#ifdef DEBUG
+				printk ("[zero map]");
+#endif
+				pte_dir = (pte_t *)kernel_ptr_table(memavailp);
+				pmd_dir->pmd[0] = virt_to_phys(pte_dir) |
+					_PAGE_TABLE | _PAGE_ACCESSED;
+				pte_val(*pte_dir++) = 0;
 				physaddr += PAGE_SIZE;
+				for (i = 1; i < 64; physaddr += PAGE_SIZE, i++)
+					pte_val(*pte_dir++) = physaddr;
 			}
-			ktablep += 64;
-
-			/*
-			 * make the kernel pointer table point to the
-			 * kernel page table.  Each entries point to a
-			 * 64 entry section of the page table.
-			 */
-
-			kpointerp[pindex++] = ktable | _PAGE_TABLE | _PAGE_ACCESSED;
+			size -= PTRTREESIZE;
+			virtaddr += PTRTREESIZE;
 		} else {
-			/*
-			 * 68030, use early termination page descriptors.
-			 * Each one points to 64 pages (256K).
-			 */
-#ifdef DEBUG
-			printk ("[early term] ");
-#endif
-			if (virtaddr == 0UL) {
-				/* map the first 256K using a 64 entry
-				 * 3rd level page table.
-				 * UNMAP the first entry to trap
-				 * zero page (NULL pointer) references
-				 */
-				int i;
-				unsigned long *tbl;
-				
-				tbl = (unsigned long *)get_kpointer_table();
-
-				kpointerp[pindex++] = virt_to_phys(tbl) | _PAGE_TABLE |_PAGE_ACCESSED;
-
-				for (i = 0; i < 64; i++, physaddr += PAGE_SIZE)
-					tbl[i] = physaddr | _PAGE_PRESENT | _PAGE_ACCESSED;
-				
-				/* unmap the zero page */
-				tbl[0] = 0;
-			} else {
-				/* not the first 256K */
-				kpointerp[pindex++] = physaddr | _PAGE_PRESENT | _PAGE_ACCESSED;
+			if (!pmd_present(*pmd_dir)) {
 #ifdef DEBUG
-				printk ("%lx=%lx ", virt_to_phys(&kpointerp[pindex-1]),
-					kpointerp[pindex-1]);
+				printk ("[new table]");
 #endif
-				physaddr += 64 * PAGE_SIZE;
+				pte_dir = kernel_page_table(memavailp);
+				pmd_set(pmd_dir, pte_dir);
 			}
+			pte_dir = pte_offset(pmd_dir, virtaddr);
+
+			if (virtaddr) {
+				if (!pte_present(*pte_dir))
+					pte_val(*pte_dir) = physaddr;
+			} else
+				pte_val(*pte_dir) = 0;
+			size -= PAGE_SIZE;
+			virtaddr += PAGE_SIZE;
+			physaddr += PAGE_SIZE;
 		}
+
+	}
 #ifdef DEBUG
-		printk ("\n");
+	printk("\n");
 #endif
-	}
 
-	return mem_mapped;
+	return virtaddr;
 }
 
 extern unsigned long free_area_init(unsigned long, unsigned long);
+extern void init_pointer_table(unsigned long ptable);
 
 /* References to section boundaries */
 
 extern char _text, _etext, _edata, __bss_start, _end;
 extern char __init_begin, __init_end;
 
-extern pgd_t swapper_pg_dir[PTRS_PER_PGD];
-
 /*
  * paging_init() continues the virtual memory environment setup which
  * was begun by the code in arch/head.S.
  */
-__initfunc(unsigned long paging_init(unsigned long start_mem,
-				     unsigned long end_mem))
+unsigned long __init paging_init(unsigned long start_mem,
+				 unsigned long end_mem)
 {
 	int chunk;
 	unsigned long mem_avail = 0;
 
 #ifdef DEBUG
 	{
-		extern pte_t *kpt;
-		printk ("start of paging_init (%p, %p, %lx, %lx, %lx)\n",
-			kernel_pg_dir, kpt, availmem, start_mem, end_mem);
+		extern unsigned long availmem;
+		printk ("start of paging_init (%p, %lx, %lx, %lx)\n",
+			kernel_pg_dir, availmem, start_mem, end_mem);
 	}
 #endif
 
-	init_kpointer_table();
-
 	/* Fix the cache mode in the page descriptors for the 680[46]0.  */
 	if (CPU_IS_040_OR_060) {
 		int i;
@@ -366,6 +328,7 @@
 				       m68k_memory[chunk].size, &start_mem);
 
 	}
+
 	flush_tlb_all();
 #ifdef DEBUG
 	printk ("memory available is %ldKB\n", mem_avail >> 10);
@@ -385,18 +348,6 @@
 	start_mem += PAGE_SIZE;
 	memset((void *)empty_zero_page, 0, PAGE_SIZE);
 
-#if 0
-	/* 
-	 * allocate the "swapper" page directory and
-	 * record in task 0 (swapper) tss 
-	 */
-	swapper_pg_dir = (pgd_t *)get_kpointer_table();
-
-	init_mm.pgd = swapper_pg_dir;
-#endif
-
-	memset (swapper_pg_dir, 0, sizeof(pgd_t)*PTRS_PER_PGD);
-
 	/* setup CPU root pointer for swapper task */
 	task[0]->tss.crp[0] = 0x80000000 | _PAGE_TABLE;
 	task[0]->tss.crp[1] = virt_to_phys (swapper_pg_dir);
@@ -430,16 +381,16 @@
 #ifdef DEBUG
 	printk ("before free_area_init\n");
 #endif
-
-	return PAGE_ALIGN(free_area_init (start_mem, end_mem));
+	return PAGE_ALIGN(free_area_init(start_mem, end_mem));
 }
 
-__initfunc(void mem_init(unsigned long start_mem, unsigned long end_mem))
+void __init mem_init(unsigned long start_mem, unsigned long end_mem)
 {
 	int codepages = 0;
 	int datapages = 0;
 	int initpages = 0;
 	unsigned long tmp;
+	int i;
 
 	end_mem &= PAGE_MASK;
 	high_memory = (void *) end_mem;
@@ -480,6 +431,15 @@
 #endif
 			free_page(tmp);
 	}
+
+	/* insert pointer tables allocated so far into the tablelist */
+	init_pointer_table((unsigned long)kernel_pg_dir);
+	for (i = 0; i < PTRS_PER_PGD; i++) {
+		if (pgd_val(kernel_pg_dir[i]))
+			init_pointer_table((unsigned long)
+				phys_to_virt(pgd_val(kernel_pg_dir[i])));
+	}
+
 	printk("Memory: %luk/%luk available (%dk kernel code, %dk data, %dk init)\n",
 	       (unsigned long) nr_free_pages << (PAGE_SHIFT-10),
 	       max_mapnr << (PAGE_SHIFT-10),
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/arch/m68k/mm/kmap.c linux-2.2-p68k/arch/m68k/mm/kmap.c
--- linux-2.2-p68k.org/arch/m68k/mm/kmap.c	Sat Oct 31 01:45:06 1998
+++ linux-2.2-p68k/arch/m68k/mm/kmap.c	Sun Jan 10 18:47:35 1999
@@ -2,6 +2,9 @@
  *  linux/arch/m68k/mm/kmap.c
  *
  *  Copyright (C) 1997 Roman Hodek
+ *
+ *  10/01/99 cleaned up the code and changing to the same interface
+ *	     used by other architectures		/Roman Zippel
  */
 
 #include <linux/mm.h>
@@ -9,250 +12,88 @@
 #include <linux/string.h>
 #include <linux/types.h>
 #include <linux/malloc.h>
+#include <linux/vmalloc.h>
 
 #include <asm/setup.h>
 #include <asm/segment.h>
 #include <asm/page.h>
 #include <asm/pgtable.h>
+#include <asm/io.h>
 #include <asm/system.h>
 
+#undef DEBUG
 
-extern pte_t *kernel_page_table (unsigned long *memavailp);
-
-/* Granularity of kernel_map() allocations */
-#define KMAP_STEP	(256*1024)
-
-/* Size of pool of KMAP structures; that is needed, because kernel_map() can
- * be called at times where kmalloc() isn't initialized yet. */
-#define	KMAP_POOL_SIZE	16
-
-/* structure for maintainance of kmap regions */
-typedef struct kmap {
-	struct kmap *next, *prev;	/* linking of list */
-	unsigned long addr;			/* start address of region */
-	unsigned long mapaddr;		/* address returned to user */
-	unsigned long size;			/* size of region */
-	unsigned free : 1;			/* flag whether free or allocated */
-	unsigned kmalloced : 1;		/* flag whether got this from kmalloc() */
-	unsigned pool_alloc : 1;	/* flag whether got this is alloced in pool */
-} KMAP;
-
-KMAP kmap_pool[KMAP_POOL_SIZE] = {
-	{ NULL, NULL, KMAP_START, KMAP_START, KMAP_END-KMAP_START, 1, 0, 1 },
-	{ NULL, NULL, 0, 0, 0, 0, 0, 0 },
-};
+#define PTRTREESIZE	(256*1024)
 
 /*
- * anchor of kmap region list
- *
- * The list is always ordered by addresses, and regions are always adjacent,
- * i.e. there must be no holes between them!
+ * For 040/060 we can use the virtual memory area like other architectures,
+ * but for 020/030 we want to use early termination page descriptor and we
+ * can't mix this with normal page descriptors, so we have to copy that code
+ * (mm/vmalloc.c) and return appriorate aligned addresses.
  */
-KMAP *kmap_regions = &kmap_pool[0];
-
-/* for protecting the kmap_regions list against races */
-static struct semaphore kmap_sem = MUTEX;
 
+#ifdef CPU_M68040_OR_M68060_ONLY
 
+#define IO_SIZE		PAGE_SIZE
 
-/*
- * Low-level allocation and freeing of KMAP structures
- */
-static KMAP *alloc_kmap( int use_kmalloc )
+static inline struct vm_struct *get_io_area(unsigned long size)
 {
-	KMAP *p;
-	int i;
-
-	/* first try to get from the pool if possible */
-	for( i = 0; i < KMAP_POOL_SIZE; ++i ) {
-		if (!kmap_pool[i].pool_alloc) {
-			kmap_pool[i].kmalloced = 0;
-			kmap_pool[i].pool_alloc = 1;
-			return( &kmap_pool[i] );
-		}
-	}
-	
-	if (use_kmalloc && (p = (KMAP *)kmalloc( sizeof(KMAP), GFP_KERNEL ))) {
-		p->kmalloced = 1;
-		return( p );
-	}
-	
-	return( NULL );
-}
-
-static void free_kmap( KMAP *p )
-{
-	if (p->kmalloced)
-		kfree( p );
-	else
-		p->pool_alloc = 0;
+	return get_vm_area(size);
 }
 
 
-/*
- * Get a free region from the kmap address range
- */
-static KMAP *kmap_get_region( unsigned long size, int use_kmalloc )
+static inline void free_io_area(void *addr)
 {
-	KMAP *p, *q;
-
-	/* look for a suitable free region */
-	for( p = kmap_regions; p; p = p->next )
-		if (p->free && p->size >= size)
-			break;
-	if (!p) {
-		printk( KERN_ERR "kernel_map: address space for "
-				"allocations exhausted\n" );
-		return( NULL );
-	}
-	
-	if (p->size > size) {
-		/* if free region is bigger than we need, split off the rear free part
-		 * into a new region */
-		if (!(q = alloc_kmap( use_kmalloc ))) {
-			printk( KERN_ERR "kernel_map: out of memory\n" );
-			return( NULL );
-		}
-		q->addr = p->addr + size;
-		q->size = p->size - size;
-		p->size = size;
-		q->free = 1;
-
-		q->prev = p;
-		q->next = p->next;
-		p->next = q;
-		if (q->next) q->next->prev = q;
-	}
-	
-	p->free = 0;
-	return( p );
+	return vfree((void *)(PAGE_MASK & (unsigned long)addr));
 }
 
+#else
 
-/*
- * Free a kernel_map region again
- */
-static void kmap_put_region( KMAP *p )
-{
-	KMAP *q;
-
-	p->free = 1;
-
-	/* merge with previous region if possible */
-	q = p->prev;
-	if (q && q->free) {
-		if (q->addr + q->size != p->addr) {
-			printk( KERN_ERR "kernel_malloc: allocation list destroyed\n" );
-			return;
-		}
-		q->size += p->size;
-		q->next = p->next;
-		if (p->next) p->next->prev = q;
-		free_kmap( p );
-		p = q;
-	}
-
-	/* merge with following region if possible */
-	q = p->next;
-	if (q && q->free) {
-		if (p->addr + p->size != q->addr) {
-			printk( KERN_ERR "kernel_malloc: allocation list destroyed\n" );
-			return;
-		}
-		p->size += q->size;
-		p->next = q->next;
-		if (q->next) q->next->prev = p;
-		free_kmap( q );
-	}
-}
+#define IO_SIZE		(256*1024)
 
+static struct vm_struct *iolist = NULL;
 
-/*
- * kernel_map() helpers
- */
-static inline pte_t *
-pte_alloc_kernel_map(pmd_t *pmd, unsigned long address,
-		     unsigned long *memavailp)
+static struct vm_struct *get_io_area(unsigned long size)
 {
-	address = (address >> PAGE_SHIFT) & (PTRS_PER_PTE - 1);
-	if (pmd_none(*pmd)) {
-		pte_t *page = kernel_page_table(memavailp);
-		if (pmd_none(*pmd)) {
-			if (page) {
-				pmd_set(pmd, page);
-				memset( page, 0, PAGE_SIZE );
-				return page + address;
-			}
-			pmd_set(pmd, BAD_PAGETABLE);
-			return NULL;
-		}
-		if (memavailp)
-			panic("kernel_map: slept during init?!?");
-		cache_page((unsigned long) page);
-		free_page((unsigned long) page);
-	}
-	if (pmd_bad(*pmd)) {
-		printk( KERN_ERR "Bad pmd in pte_alloc_kernel_map: %08lx\n",
-		       pmd_val(*pmd));
-		pmd_set(pmd, BAD_PAGETABLE);
+	unsigned long addr;
+	struct vm_struct **p, *tmp, *area;
+
+	area = (struct vm_struct *)kmalloc(sizeof(*area), GFP_KERNEL);
+	if (!area)
 		return NULL;
+	addr = KMAP_START;
+	for (p = &iolist; (tmp = *p) ; p = &tmp->next) {
+		if (size + addr < (unsigned long)tmp->addr)
+			break;
+		if (addr > KMAP_END-size)
+			return NULL;
+		addr = tmp->size + (unsigned long)tmp->addr;
 	}
-	return (pte_t *) pmd_page(*pmd) + address;
+	area->addr = (void *)addr;
+	area->size = size + IO_SIZE;
+	area->next = *p;
+	*p = area;
+	return area;
 }
 
-static inline void
-kernel_map_pte(pte_t *pte, unsigned long address, unsigned long size,
-	       unsigned long phys_addr, pgprot_t prot)
+static inline void free_io_area(void *addr)
 {
-	unsigned long end;
+	struct vm_struct **p, *tmp;
 
-	address &= ~PMD_MASK;
-	end = address + size;
-	if (end > PMD_SIZE)
-		end = PMD_SIZE;
-	do {
-		pte_val(*pte) = phys_addr + pgprot_val(prot);
-		address += PAGE_SIZE;
-		phys_addr += PAGE_SIZE;
-		pte++;
-	} while (address < end);
-}
-
-static inline int
-kernel_map_pmd (pmd_t *pmd, unsigned long address, unsigned long size,
-		unsigned long phys_addr, pgprot_t prot,
-		unsigned long *memavailp)
-{
-	unsigned long end;
-
-	address &= ~PGDIR_MASK;
-	end = address + size;
-	if (end > PGDIR_SIZE)
-		end = PGDIR_SIZE;
-	phys_addr -= address;
-
-	if (CPU_IS_040_OR_060) {
-		do {
-			pte_t *pte = pte_alloc_kernel_map(pmd, address, memavailp);
-			if (!pte)
-				return -ENOMEM;
-			kernel_map_pte(pte, address, end - address,
-				       address + phys_addr, prot);
-			address = (address + PMD_SIZE) & PMD_MASK;
-			pmd++;
-		} while (address < end);
-	} else {
-		/* On the 68030 we use early termination page descriptors.
-		   Each one points to 64 pages (256K). */
-		int i = (address >> (PMD_SHIFT-4)) & 15;
-		do {
-			(&pmd_val(*pmd))[i++] = (address + phys_addr) | pgprot_val(prot);
-			address += PMD_SIZE / 16;
-		} while (address < end);
+	if (!addr)
+		return;
+	addr = (void *)((unsigned long)addr & -IO_SIZE);
+	for (p = &iolist ; (tmp = *p) ; p = &tmp->next) {
+		if (tmp->addr == addr) {
+			*p = tmp->next;
+			__iounmap(tmp->addr, tmp->size);
+			kfree(tmp);
+			return;
+		}
 	}
-	return 0;
 }
 
+#endif
 
 /*
  * Map some physical address range into the kernel address space. The
@@ -260,304 +101,245 @@
  */
 /* Rewritten by Andreas Schwab to remove all races. */
 
-unsigned long kernel_map(unsigned long phys_addr, unsigned long size,
-			 int cacheflag, unsigned long *memavailp)
+void *__ioremap(unsigned long physaddr, unsigned long size, int cacheflag)
 {
-	unsigned long retaddr, from, end;
-	pgd_t *dir;
-	pgprot_t prot;
-	KMAP *kmap;
-
-	/* Round down 'phys_addr' to 256 KB and adjust size */
-	retaddr = phys_addr & (KMAP_STEP-1);
-	size += retaddr;
-	phys_addr &= ~(KMAP_STEP-1);
-	/* Round up the size to 256 KB. It doesn't hurt if too much is
-	   mapped... */
-	size = (size + KMAP_STEP - 1) & ~(KMAP_STEP-1);
-	
-	down( &kmap_sem );
-	kmap = kmap_get_region(size, memavailp == NULL);
-	if (!kmap) {
-		up(&kmap_sem);
-		return 0;
-	}
-	from = kmap->addr;
-	retaddr += from;
-	kmap->mapaddr = retaddr;
-	end = from + size;
-	up( &kmap_sem );
+	struct vm_struct *area;
+	unsigned long virtaddr, retaddr;
+	long offset;
+	pgd_t *pgd_dir;
+	pmd_t *pmd_dir;
+	pte_t *pte_dir;
+
+	/*
+	 * Don't allow mappings that wrap..
+	 */
+	if (!size || size > physaddr + size)
+		return NULL;
 
+#ifdef DEBUG
+	printk("ioremap: 0x%lx,0x%lx(%d) - ", physaddr, size, cacheflag);
+#endif
+	/*
+	 * Mappings have to be aligned
+	 */
+	offset = physaddr & (IO_SIZE - 1);
+	physaddr &= -IO_SIZE;
+	size = (size + offset + IO_SIZE - 1) & -IO_SIZE;
+
+	/*
+	 * Ok, go for it..
+	 */
+	area = get_io_area(size);
+	if (!area)
+		return NULL;
+
+	virtaddr = (unsigned long)area->addr;
+	retaddr = virtaddr + offset;
+#ifdef DEBUG
+	printk("0x%lx,0x%lx,0x%lx", physaddr, virtaddr, retaddr);
+#endif
+
+	/*
+	 * add cache and table flags to physical address
+	 */
 	if (CPU_IS_040_OR_060) {
-		pgprot_val(prot) = (_PAGE_PRESENT | _PAGE_GLOBAL040 |
-				    _PAGE_ACCESSED | _PAGE_DIRTY);
+		physaddr |= (_PAGE_PRESENT | _PAGE_GLOBAL040 |
+			     _PAGE_ACCESSED | _PAGE_DIRTY);
 		switch (cacheflag) {
-		case KERNELMAP_FULL_CACHING:
-			pgprot_val(prot) |= _PAGE_CACHE040;
+		case IOMAP_FULL_CACHING:
+			physaddr |= _PAGE_CACHE040;
 			break;
-		case KERNELMAP_NOCACHE_SER:
+		case IOMAP_NOCACHE_SER:
 		default:
-			pgprot_val(prot) |= _PAGE_NOCACHE_S;
+			physaddr |= _PAGE_NOCACHE_S;
 			break;
-		case KERNELMAP_NOCACHE_NONSER:
-			pgprot_val(prot) |= _PAGE_NOCACHE;
+		case IOMAP_NOCACHE_NONSER:
+			physaddr |= _PAGE_NOCACHE;
 			break;
-		case KERNELMAP_NO_COPYBACK:
-			pgprot_val(prot) |= _PAGE_CACHE040W;
+		case IOMAP_WRITETHROUGH:
+			physaddr |= _PAGE_CACHE040W;
 			break;
 		}
-	} else
-		pgprot_val(prot) = (_PAGE_PRESENT | _PAGE_ACCESSED |
-				    _PAGE_DIRTY |
-				    ((cacheflag == KERNELMAP_FULL_CACHING ||
-				      cacheflag == KERNELMAP_NO_COPYBACK)
-				     ? 0 : _PAGE_NOCACHE030));
-
-	phys_addr -= from;
-	dir = pgd_offset_k(from);
-	while (from < end) {
-		pmd_t *pmd = pmd_alloc_kernel(dir, from);
-
-		if (kernel_map_pmd(pmd, from, end - from, phys_addr + from,
-				   prot, memavailp)) {
-			printk( KERN_ERR "kernel_map: out of memory\n" );
-			return 0UL;
+	} else {
+		physaddr |= (_PAGE_PRESENT | _PAGE_ACCESSED | _PAGE_DIRTY);
+		switch (cacheflag) {
+		case IOMAP_NOCACHE_SER:
+		case IOMAP_NOCACHE_NONSER:
+		default:
+			physaddr |= _PAGE_NOCACHE030;
+			break;
+		case IOMAP_FULL_CACHING:
+		case IOMAP_WRITETHROUGH:
+			break;
 		}
-		from = (from + PGDIR_SIZE) & PGDIR_MASK;
-		dir++;
 	}
 
-	return retaddr;
-}
-
+	while (size > 0) {
+#ifdef DEBUG
+		if (!(virtaddr & (PTRTREESIZE-1)))
+			printk ("\npa=%#lx va=%#lx ", physaddr, virtaddr);
+#endif
+		pgd_dir = pgd_offset_k(virtaddr);
+		pmd_dir = pmd_alloc_kernel(pgd_dir, virtaddr);
+		if (!pmd_dir) {
+			printk("ioremap: no mem for pmd_dir\n");
+			return NULL;
+		}
 
-/*
- * kernel_unmap() helpers
- */
-static inline void pte_free_kernel_unmap( pmd_t *pmd )
-{
-	unsigned long page = pmd_page(*pmd);
-	mem_map_t *pagemap = &mem_map[MAP_NR(page)];
-	
-	pmd_clear(pmd);
-	cache_page(page);
-
-	if (PageReserved( pagemap )) {
-		/* need to unreserve pages that were allocated with memavailp != NULL;
-		 * this works only if 'page' is page-aligned */
-		if (page & ~PAGE_MASK)
-			return;
-		clear_bit( PG_reserved, &pagemap->flags );
-		atomic_set( &pagemap->count, 1 );
-	}
-	free_page( page );
-}
+		if (CPU_IS_020_OR_030) {
+			pmd_dir->pmd[(virtaddr/PTRTREESIZE)&-16] = physaddr;
+			physaddr += PTRTREESIZE;
+			virtaddr += PTRTREESIZE;
+			size -= PTRTREESIZE;
+		} else {
+			pte_dir = pte_alloc_kernel(pmd_dir, virtaddr);
+			if (!pte_dir) {
+				printk("ioremap: no mem for pte_dir\n");
+				return NULL;
+			}
 
-/*
- * This not only unmaps the requested region, but also loops over the whole
- * pmd to determine whether the other pte's are clear (so that the page can be
- * freed.) If so, it returns 1, 0 otherwise.
- */
-static inline int
-kernel_unmap_pte_range(pmd_t * pmd, unsigned long address, unsigned long size)
-{
-	pte_t *pte;
-	unsigned long addr2, end, end2;
-	int all_clear = 1;
-
-	if (pmd_none(*pmd))
-		return( 0 );
-	if (pmd_bad(*pmd)) {
-		printk( KERN_ERR "kernel_unmap_pte_range: bad pmd (%08lx)\n",
-				pmd_val(*pmd) );
-		pmd_clear(pmd);
-		return( 0 );
-	}
-	address &= ~PMD_MASK;
-	addr2 = 0;
-	pte = pte_offset(pmd, addr2);
-	end = address + size;
-	if (end > PMD_SIZE)
-		end = PMD_SIZE;
-	end2 = addr2 + PMD_SIZE;
-	while( addr2 < end2 ) {
-		if (!pte_none(*pte)) {
-			if (address <= addr2 && addr2 < end)
-				pte_clear(pte);
-			else
-				all_clear = 0;
+			pte_val(*pte_dir) = physaddr;
+			virtaddr += PAGE_SIZE;
+			physaddr += PAGE_SIZE;
+			size -= PAGE_SIZE;
 		}
-		++pte;
-		addr2 += PAGE_SIZE;
 	}
-	return( all_clear );
-}
-
-static inline void
-kernel_unmap_pmd_range(pgd_t * dir, unsigned long address, unsigned long size)
-{
-	pmd_t * pmd;
-	unsigned long end;
+#ifdef DEBUG
+	printk("\n");
+#endif
+	flush_tlb_all();
 
-	if (pgd_none(*dir))
-		return;
-	if (pgd_bad(*dir)) {
-		printk( KERN_ERR "kernel_unmap_pmd_range: bad pgd (%08lx)\n",
-				pgd_val(*dir) );
-		pgd_clear(dir);
-		return;
-	}
-	pmd = pmd_offset(dir, address);
-	address &= ~PGDIR_MASK;
-	end = address + size;
-	if (end > PGDIR_SIZE)
-		end = PGDIR_SIZE;
-	
-	if (CPU_IS_040_OR_060) {
-		do {
-			if (kernel_unmap_pte_range(pmd, address, end - address))
-				pte_free_kernel_unmap( pmd );
-			address = (address + PMD_SIZE) & PMD_MASK;
-			pmd++;
-		} while (address < end);
-	} else {
-		/* On the 68030 clear the early termination descriptors */
-		int i = (address >> (PMD_SHIFT-4)) & 15;
-		do {
-			(&pmd_val(*pmd))[i++] = 0;
-			address += PMD_SIZE / 16;
-		} while (address < end);
-	}
+	return (void *)retaddr;
 }
 
 /*
- * Unmap a kernel_map()ed region again
+ * Unmap a ioremap()ed region again
  */
-void kernel_unmap( unsigned long addr )
+void iounmap(void *addr)
 {
-	unsigned long end;
-	pgd_t *dir;
-	KMAP *p;
-
-	down( &kmap_sem );
-	
-	/* find region for 'addr' in list; must search for mapaddr! */
-	for( p = kmap_regions; p; p = p->next )
-		if (!p->free && p->mapaddr == addr)
-			break;
-	if (!p) {
-		printk( KERN_ERR "kernel_unmap: trying to free invalid region\n" );
-		return;
-	}
-	addr = p->addr;
-	end = addr + p->size;
-	kmap_put_region( p );
-
-	dir = pgd_offset_k( addr );
-	while( addr < end ) {
-		kernel_unmap_pmd_range( dir, addr, end - addr );
-		addr = (addr + PGDIR_SIZE) & PGDIR_MASK;
-		dir++;
-	}
-	
-	up( &kmap_sem );
-	/* flushing for a range would do, but there's no such function for kernel
-	 * address space... */
-	flush_tlb_all();
+	free_io_area(addr);
 }
 
-
 /*
- * kernel_set_cachemode() helpers
+ * __iounmap unmaps nearly everything, so be careful
+ * it doesn't free currently pointer/page tables anymore but it
+ * wans't used anyway and might be added later.
  */
-static inline void set_cmode_pte( pmd_t *pmd, unsigned long address,
-				  unsigned long size, unsigned cmode )
-{	pte_t *pte;
-	unsigned long end;
-
-	if (pmd_none(*pmd))
-		return;
-
-	pte = pte_offset( pmd, address );
-	address &= ~PMD_MASK;
-	end = address + size;
-	if (end >= PMD_SIZE)
-		end = PMD_SIZE;
-
-	for( ; address < end; pte++ ) {
-		pte_val(*pte) = (pte_val(*pte) & ~_PAGE_NOCACHE) | cmode;
-		address += PAGE_SIZE;
-	}
-}
+void __iounmap(void *addr, unsigned long size)
+{
+	unsigned long virtaddr = (unsigned long)addr;
+	pgd_t *pgd_dir;
+	pmd_t *pmd_dir;
+	pte_t *pte_dir;
 
+	while (size > 0) {
+		pgd_dir = pgd_offset_k(virtaddr);
+		if (pgd_bad(*pgd_dir)) {
+			printk("iounmap: bad pgd(%08lx)\n", pgd_val(*pgd_dir));
+			pgd_clear(pgd_dir);
+			return;
+		}
+		pmd_dir = pmd_offset(pgd_dir, virtaddr);
 
-static inline void set_cmode_pmd( pgd_t *dir, unsigned long address,
-				  unsigned long size, unsigned cmode )
-{
-	pmd_t *pmd;
-	unsigned long end;
+		if (CPU_IS_020_OR_030) {
+			int pmd_off = (virtaddr/PTRTREESIZE) & -16;
 
-	if (pgd_none(*dir))
-		return;
+			if ((pmd_dir->pmd[pmd_off] & _DESCTYPE_MASK) == _PAGE_PRESENT) {
+				pmd_dir->pmd[pmd_off] = 0;
+				virtaddr += PTRTREESIZE;
+				size -= PTRTREESIZE;
+				continue;
+			}
+		}
 
-	pmd = pmd_offset( dir, address );
-	address &= ~PGDIR_MASK;
-	end = address + size;
-	if (end > PGDIR_SIZE)
-		end = PGDIR_SIZE;
-
-	if ((pmd_val(*pmd) & _DESCTYPE_MASK) == _PAGE_PRESENT) {
-		/* 68030 early termination descriptor */
-		pmd_val(*pmd) = (pmd_val(*pmd) & ~_PAGE_NOCACHE) | cmode;
-		return;
-	}
-	else {
-		/* "normal" tables */
-		for( ; address < end; pmd++ ) {
-			set_cmode_pte( pmd, address, end - address, cmode );
-			address = (address + PMD_SIZE) & PMD_MASK;
+		if (pmd_bad(*pmd_dir)) {
+			printk("iounmap: bad pmd (%08lx)\n", pmd_val(*pmd_dir));
+			pmd_clear(pmd_dir);
+			return;
 		}
+		pte_dir = pte_offset(pmd_dir, virtaddr);
+
+		pte_val(*pte_dir) = 0;
+		virtaddr += PAGE_SIZE;
+		size -= PAGE_SIZE;
 	}
-}
 
+	flush_tlb_all();
+}
 
 /*
  * Set new cache mode for some kernel address space.
  * The caller must push data for that range itself, if such data may already
  * be in the cache.
  */
-void kernel_set_cachemode( unsigned long address, unsigned long size,
-						   unsigned cmode )
+void kernel_set_cachemode(void *addr, unsigned long size, int cmode)
 {
-	pgd_t *dir = pgd_offset_k( address );
-	unsigned long end = address + size;
-	
+	unsigned long virtaddr = (unsigned long)addr;
+	pgd_t *pgd_dir;
+	pmd_t *pmd_dir;
+	pte_t *pte_dir;
+
 	if (CPU_IS_040_OR_060) {
-		switch( cmode ) {
-		  case KERNELMAP_FULL_CACHING:
+		switch (cmode) {
+		case IOMAP_FULL_CACHING:
 			cmode = _PAGE_CACHE040;
 			break;
-		  case KERNELMAP_NOCACHE_SER:
-		  default:
+		case IOMAP_NOCACHE_SER:
+		default:
 			cmode = _PAGE_NOCACHE_S;
 			break;
-		  case KERNELMAP_NOCACHE_NONSER:
+		case IOMAP_NOCACHE_NONSER:
 			cmode = _PAGE_NOCACHE;
 			break;
-		  case KERNELMAP_NO_COPYBACK:
+		case IOMAP_WRITETHROUGH:
 			cmode = _PAGE_CACHE040W;
 			break;
 		}
-	} else
-		cmode = ((cmode == KERNELMAP_FULL_CACHING ||
-				  cmode == KERNELMAP_NO_COPYBACK)    ?
-			 0 : _PAGE_NOCACHE030);
-
-	for( ; address < end; dir++ ) {
-		set_cmode_pmd( dir, address, end - address, cmode );
-		address = (address + PGDIR_SIZE) & PGDIR_MASK;
+	} else {
+		switch (cmode) {
+		case IOMAP_NOCACHE_SER:
+		case IOMAP_NOCACHE_NONSER:
+		default:
+			cmode = _PAGE_NOCACHE030;
+			break;
+		case IOMAP_FULL_CACHING:
+		case IOMAP_WRITETHROUGH:
+			cmode = 0;
+		}
+	}
+
+	while (size > 0) {
+		pgd_dir = pgd_offset_k(virtaddr);
+		if (pgd_bad(*pgd_dir)) {
+			printk("iocachemode: bad pgd(%08lx)\n", pgd_val(*pgd_dir));
+			pgd_clear(pgd_dir);
+			return;
+		}
+		pmd_dir = pmd_offset(pgd_dir, virtaddr);
+
+		if (CPU_IS_020_OR_030) {
+			int pmd_off = (virtaddr/PTRTREESIZE) & -16;
+
+			if ((pmd_dir->pmd[pmd_off] & _DESCTYPE_MASK) == _PAGE_PRESENT) {
+				pmd_dir->pmd[pmd_off] = (pmd_dir->pmd[pmd_off] &
+							 ~_CACHEMASK040) | cmode;
+				virtaddr += PTRTREESIZE;
+				size -= PTRTREESIZE;
+				continue;
+			}
+		}
+
+		if (pmd_bad(*pmd_dir)) {
+			printk("iocachemode: bad pmd (%08lx)\n", pmd_val(*pmd_dir));
+			pmd_clear(pmd_dir);
+			return;
+		}
+		pte_dir = pte_offset(pmd_dir, virtaddr);
+
+		pte_val(*pte_dir) = (pte_val(*pte_dir) & ~_CACHEMASK040) | cmode;
+		virtaddr += PAGE_SIZE;
+		size -= PAGE_SIZE;
 	}
-	/* flushing for a range would do, but there's no such function for kernel
-	 * address space... */
+
 	flush_tlb_all();
 }
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/arch/m68k/mm/memory.c linux-2.2-p68k/arch/m68k/mm/memory.c
--- linux-2.2-p68k.org/arch/m68k/mm/memory.c	Sat Oct 31 02:34:25 1998
+++ linux-2.2-p68k/arch/m68k/mm/memory.c	Sat Jan  9 23:31:30 1999
@@ -10,6 +10,7 @@
 #include <linux/string.h>
 #include <linux/types.h>
 #include <linux/malloc.h>
+#include <linux/init.h>
 
 #include <asm/setup.h>
 #include <asm/segment.h>
@@ -97,6 +98,31 @@
 
 #define PTABLE_SIZE (PTRS_PER_PMD * sizeof(pmd_t))
 
+void __init init_pointer_table(unsigned long ptable)
+{
+	ptable_desc *dp;
+	unsigned long page = (unsigned long)ptable & PAGE_MASK;
+	unsigned char mask = 1 << (((unsigned long)ptable - page)/PTABLE_SIZE);
+
+	dp = PAGE_PD(page);
+	if (!(PD_MARKBITS(dp) & mask)) {
+		PD_MARKBITS(dp) = 0xff;
+		(dp->prev = ptable_list.prev)->next = dp;
+		(dp->next = &ptable_list)->prev = dp;
+	}
+
+	PD_MARKBITS(dp) &= ~mask;
+#ifdef DEBUG
+	printk("init_pointer_table: %lx, %x\n", ptable, PD_MARKBITS(dp));
+#endif
+
+	/* unreserve the page so it's possible to free that page */
+	dp->flags &= ~(1 << PG_reserved);
+	atomic_set(&dp->count, 1);
+
+	return;
+}
+
 pmd_t *get_pointer_table (void)
 {
 	ptable_desc *dp = ptable_list.next;
@@ -176,103 +202,6 @@
 	return 0;
 }
 
-/* maximum pages used for kpointer tables */
-#define KPTR_PAGES      4
-/* # of reserved slots */
-#define RESERVED_KPTR	4
-extern pmd_tablepage kernel_pmd_table; /* reserved in head.S */
-
-static struct kpointer_pages {
-        pmd_tablepage *page[KPTR_PAGES];
-        u_char alloced[KPTR_PAGES];
-} kptr_pages;
-
-void init_kpointer_table(void) {
-	short i = KPTR_PAGES-1;
-
-	/* first page is reserved in head.S */
-	kptr_pages.page[i] = &kernel_pmd_table;
-	kptr_pages.alloced[i] = ~(0xff>>RESERVED_KPTR);
-	for (i--; i>=0; i--) {
-		kptr_pages.page[i] = NULL;
-		kptr_pages.alloced[i] = 0;
-	}
-}
-
-pmd_t *get_kpointer_table (void)
-{
-	/* For pointer tables for the kernel virtual address space,
-	 * use the page that is reserved in head.S that can hold up to
-	 * 8 pointer tables. 3 of these tables are always reserved
-	 * (kernel_pg_dir, swapper_pg_dir and kernel pointer table for
-	 * the first 16 MB of RAM). In addition, the 4th pointer table
-	 * in this page is reserved. On Amiga and Atari, it is used to
-	 * map in the hardware registers. It may be used for other
-	 * purposes on other 68k machines. This leaves 4 pointer tables
-	 * available for use by the kernel. 1 of them are usually used
-	 * for the vmalloc tables. This allows mapping of 3 * 32 = 96 MB
-	 * of physical memory. But these pointer tables are also used
-	 * for other purposes, like kernel_map(), so further pages can
-	 * now be allocated.
-	 */
-	pmd_tablepage *page;
-	pmd_table *table;
-	long nr, offset = -8;
-	short i;
-
-	for (i=KPTR_PAGES-1; i>=0; i--) {
-		asm volatile("bfffo %1{%2,#8},%0"
-			: "=d" (nr)
-			: "d" ((u_char)~kptr_pages.alloced[i]), "d" (offset));
-		if (nr)
-			break;
-	}
-	if (i < 0) {
-		printk("No space for kernel pointer table!\n");
-		return NULL;
-	}
-	if (!(page = kptr_pages.page[i])) {
-		if (!(page = (pmd_tablepage *)get_free_page(GFP_KERNEL))) {
-			printk("No space for kernel pointer table!\n");
-			return NULL;
-		}
-		flush_tlb_kernel_page((unsigned long) page);
-		nocache_page((u_long)(kptr_pages.page[i] = page));
-	}
-	asm volatile("bfset %0@{%1,#1}"
-		: /* no output */
-		: "a" (&kptr_pages.alloced[i]), "d" (nr-offset));
-	table = &(*page)[nr-offset];
-	memset(table, 0, sizeof(pmd_table));
-	return ((pmd_t *)table);
-}
-
-void free_kpointer_table (pmd_t *pmdp)
-{
-	pmd_table *table = (pmd_table *)pmdp;
-	pmd_tablepage *page = (pmd_tablepage *)((u_long)table & PAGE_MASK);
-	long nr;
-	short i;
-
-	for (i=KPTR_PAGES-1; i>=0; i--) {
-		if (kptr_pages.page[i] == page)
-			break;
-	}
-	nr = ((u_long)table - (u_long)page) / sizeof(pmd_table);
-	if (!table || i < 0 || (i == KPTR_PAGES-1 && nr < RESERVED_KPTR)) {
-		printk("Attempt to free invalid kernel pointer table: %p\n", table);
-		return;
-	}
-	asm volatile("bfclr %0@{%1,#1}"
-		: /* no output */
-		: "a" (&kptr_pages.alloced[i]), "d" (nr));
-	if (!kptr_pages.alloced[i]) {
-		kptr_pages.page[i] = 0;
-		cache_page ((u_long)page);
-		free_page ((u_long)page);
-	}
-}
-
 static unsigned long transp_transl_matches( unsigned long regval,
 					    unsigned long vaddr )
 {
@@ -308,7 +237,6 @@
  */
 unsigned long mm_vtop (unsigned long vaddr)
 {
-#ifndef CONFIG_SINGLE_MEMORY_CHUNK
 	int i=0;
 	unsigned long voff = vaddr;
 	unsigned long offset = 0;
@@ -324,10 +252,6 @@
 			offset += m68k_memory[i].size;
 		i++;
 	}while (i < m68k_num_memory);
-#else
-	if (vaddr < m68k_memory[0].size)
-		return m68k_memory[0].addr + vaddr;
-#endif
 
 	return mm_vtop_fallback(vaddr);
 }
@@ -449,7 +373,6 @@
 #ifndef CONFIG_SINGLE_MEMORY_CHUNK
 unsigned long mm_ptov (unsigned long paddr)
 {
-#ifndef CONFIG_SINGLE_MEMORY_CHUNK
 	int i = 0;
 	unsigned long offset = 0;
 
@@ -466,11 +389,6 @@
 			offset += m68k_memory[i].size;
 		i++;
 	}while (i < m68k_num_memory);
-#else
-	unsigned long base = m68k_memory[0].addr;
-	if (paddr >= base && paddr < (base + m68k_memory[0].size))
-		return (paddr - base);
-#endif
 
 	/*
 	 * assume that the kernel virtual address is the same as the
@@ -560,7 +478,7 @@
  *	Jes was worried about performance (urhh ???) so its optional
  */
  
-extern void (*mach_l2_flush)(int) = NULL;
+void (*mach_l2_flush)(int) = NULL;
 #endif
  
 /*
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/arch/ppc/kernel/apus_setup.c linux-2.2-p68k/arch/ppc/kernel/apus_setup.c
--- linux-2.2-p68k.org/arch/ppc/kernel/apus_setup.c	Wed Jan  6 00:39:19 1999
+++ linux-2.2-p68k/arch/ppc/kernel/apus_setup.c	Fri Jan  8 22:11:21 1999
@@ -285,11 +285,11 @@
 
 	switch (cmode)
 	{
-	case KERNELMAP_FULL_CACHING:
+	case IOMAP_FULL_CACHING:
 		mask = ~(_PAGE_NO_CACHE | _PAGE_GUARDED);
 		flags = 0;
 		break;
-	case KERNELMAP_NOCACHE_SER:
+	case IOMAP_NOCACHE_SER:
 		mask = ~0;
 		flags = (_PAGE_NO_CACHE | _PAGE_GUARDED);
 		break;
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/drivers/block/acsi.c linux-2.2-p68k/drivers/block/acsi.c
--- linux-2.2-p68k.org/drivers/block/acsi.c	Wed Jan  6 22:25:36 1999
+++ linux-2.2-p68k/drivers/block/acsi.c	Sat Jan  9 18:00:46 1999
@@ -492,7 +492,7 @@
 #endif
 	
 	rwflag = rwflag ? 0x100 : 0;
-	paddr = VTOP( buffer );
+	paddr = virt_to_phys( buffer );
 
 	acsi_delay_end(COMMAND_DELAY);
 	DISABLE_IRQ();
@@ -600,7 +600,7 @@
 	if (!acsicmd_nodma( reqsense_cmd, 0 )) return( 0 );
 	if (!acsi_wait_for_IRQ( 10 )) return( 0 );
 	acsi_getstatus();
-	dma_cache_maintenance( VTOP(buffer), 16, 0 );
+	dma_cache_maintenance( virt_to_phys(buffer), 16, 0 );
 	
 	return( 1 );
 }	
@@ -799,7 +799,7 @@
 		return;
 	}
 
-	dma_cache_maintenance( VTOP(CurrentBuffer), CurrentNSect*512, 0 );
+	dma_cache_maintenance( virt_to_phys(CurrentBuffer), CurrentNSect*512, 0 );
 	if (CurrentBuffer == acsi_buffer)
 		copy_from_acsibuffer();
 
@@ -1020,7 +1020,7 @@
 	 * consecutive buffers and thus can be done with a single command.
 	 */
 	buffer      = CURRENT->buffer;
-	pbuffer     = VTOP(buffer);
+	pbuffer     = virt_to_phys(buffer);
 	nsect       = CURRENT->current_nr_sectors;
 	CurrentNReq = 1;
 
@@ -1042,7 +1042,7 @@
 			unsigned long pendadr, pnewadr;
 			pendadr = pbuffer + nsect*512;
 			while( (bh = bh->b_reqnext) ) {
-				pnewadr = VTOP(bh->b_data);
+				pnewadr = virt_to_phys(bh->b_data);
 				if (!STRAM_ADDR(pnewadr) || pendadr != pnewadr) break;
 				nsect += bh->b_size >> 9;
 				pendadr = pnewadr + bh->b_size;
@@ -1805,7 +1805,7 @@
 		unregister_blkdev( MAJOR_NR, "ad" );
 		return -ENOMEM;
 	}
-	phys_acsi_buffer = VTOP( acsi_buffer );
+	phys_acsi_buffer = virt_to_phys( acsi_buffer );
 	STramMask = ATARIHW_PRESENT(EXTD_DMA) ? 0x00000000 : 0xff000000;
 	
 	blk_dev[MAJOR_NR].request_fn = DEVICE_REQUEST;
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/drivers/block/acsi_slm.c linux-2.2-p68k/drivers/block/acsi_slm.c
--- linux-2.2-p68k.org/drivers/block/acsi_slm.c	Wed Jan  6 22:24:37 1999
+++ linux-2.2-p68k/drivers/block/acsi_slm.c	Sat Jan  9 18:01:09 1999
@@ -413,8 +413,8 @@
 
 	CMDSET_TARG_LUN( slmprint_cmd, sip->target, sip->lun );
 	cmd = slmprint_cmd;
-	paddr = VTOP( SLMBuffer );
-	dma_cache_maintenance( paddr, VTOP(BufferP)-paddr, 1 );
+	paddr = virt_to_phys( SLMBuffer );
+	dma_cache_maintenance( paddr, virt_to_phys(BufferP)-paddr, 1 );
 	DISABLE_IRQ();
 
 	/* Low on A1 */
@@ -466,7 +466,7 @@
 	addr = get_dma_addr();
 	stat = acsi_getstatus();
 	SLMError = (stat < 0)             ? SLMSTAT_ACSITO :
-		       (addr < VTOP(BufferP)) ? SLMSTAT_NOTALL :
+		       (addr < virt_to_phys(BufferP)) ? SLMSTAT_NOTALL :
 									    stat;
 
 	dma_wd.dma_mode_status = 0x80;
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/drivers/block/ataflop.c linux-2.2-p68k/drivers/block/ataflop.c
--- linux-2.2-p68k.org/drivers/block/ataflop.c	Wed Jan  6 22:25:36 1999
+++ linux-2.2-p68k/drivers/block/ataflop.c	Sat Jan  9 17:57:30 1999
@@ -892,7 +892,7 @@
 	DPRINT(("fd_rwsec(), Sec=%d, Access=%c\n",ReqSector, ReqCmd == WRITE ? 'w' : 'r' ));
 	if (ReqCmd == WRITE) {
 		if (ATARIHW_PRESENT(EXTD_DMA)) {
-			paddr = (unsigned long)VTOP(ReqData);
+			paddr = virt_to_phys(ReqData);
 		}
 		else {
 			copy_buffer( ReqData, DMABuffer );
@@ -905,7 +905,8 @@
 		if (read_track)
 			paddr = PhysTrackBuffer;
 		else
-			paddr = ATARIHW_PRESENT(EXTD_DMA) ? VTOP(ReqData) : PhysDMABuffer;
+			paddr = ATARIHW_PRESENT(EXTD_DMA) ? 
+				virt_to_phys(ReqData) : PhysDMABuffer;
 		rwflag = 0;
 	}
 
@@ -1137,7 +1138,7 @@
 		if (!read_track) {
 			void *addr;
 			addr = ATARIHW_PRESENT( EXTD_DMA ) ? ReqData : DMABuffer;
-			dma_cache_maintenance( VTOP(addr), 512, 0 );
+			dma_cache_maintenance( virt_to_phys(addr), 512, 0 );
 			if (!ATARIHW_PRESENT( EXTD_DMA ))
 				copy_buffer (addr, ReqData);
 		} else {
@@ -2042,8 +2043,8 @@
 		return -ENOMEM;
 	}
 	TrackBuffer = DMABuffer + 512;
-	PhysDMABuffer = (unsigned long) VTOP(DMABuffer);
-	PhysTrackBuffer = (unsigned long) VTOP(TrackBuffer);
+	PhysDMABuffer = virt_to_phys(DMABuffer);
+	PhysTrackBuffer = virt_to_phys(TrackBuffer);
 	BufferDrive = BufferSide = BufferTrack = -1;
 
 	for (i = 0; i < FD_MAX_UNITS; i++) {
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/drivers/block/z2ram.c linux-2.2-p68k/drivers/block/z2ram.c
--- linux-2.2-p68k.org/drivers/block/z2ram.c	Wed Jan  6 22:43:30 1999
+++ linux-2.2-p68k/drivers/block/z2ram.c	Sat Jan  9 23:37:55 1999
@@ -45,8 +45,8 @@
 #include <linux/zorro.h>
 
 
-extern int num_memory;
-extern struct mem_info memory[NUM_MEMINFO];
+extern int m68k_realnum_memory;
+extern struct mem_info m68k_memory[NUM_MEMINFO];
 
 #define TRUE                  (1)
 #define FALSE                 (0)
@@ -189,14 +189,14 @@
 		int index = device - Z2MINOR_MEMLIST1 + 1;
 		unsigned long size, paddr, vaddr;
 
-		if (index >= num_memory) {
+		if (index >= m68k_realnum_memory) {
 			printk( KERN_ERR DEVICE_NAME
 				": no such entry in z2ram_map\n" );
 			return -ENOMEM;
 		}
 
-		paddr = memory[index].addr;
-		size = memory[index].size & ~(Z2RAM_CHUNKSIZE-1);
+		paddr = m68k_memory[index].addr;
+		size = m68k_memory[index].size & ~(Z2RAM_CHUNKSIZE-1);
 
 #ifdef __powerpc__
 		/* FIXME: ioremap doesn't build correct memory tables. */
@@ -210,8 +210,7 @@
 						   _PAGE_WRITETHRU);
 
 #else
-		vaddr = kernel_map (paddr, size, KERNELMAP_FULL_CACHING,
-				    NULL);
+		vaddr = (unsigned long)ioremap(paddr, size);
 #endif
 		z2ram_map = 
 			kmalloc((size/Z2RAM_CHUNKSIZE)*sizeof(z2ram_map[0]),
@@ -314,9 +313,7 @@
 	blk_size[ MAJOR_NR ] = z2_sizes;
     }
 
-#if defined(MODULE)
     MOD_INC_USE_COUNT;
-#endif
 
     return 0;
 }
@@ -329,9 +326,11 @@
 
     sync_dev( inode->i_rdev );
 
-#if defined(MODULE)
+    /*
+     * FIXME: unmap memory
+     */
+
     MOD_DEC_USE_COUNT;
-#endif
 
     return 0;
 }
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/drivers/char/amiga_ser.c linux-2.2-p68k/drivers/char/amiga_ser.c
--- linux-2.2-p68k.org/drivers/char/amiga_ser.c	Wed Jan  6 22:25:36 1999
+++ linux-2.2-p68k/drivers/char/amiga_ser.c	Wed Jan  6 23:19:15 1999
@@ -43,6 +43,8 @@
 #include <asm/irq.h>
 #include <asm/atomic.h>
 
+#include <config/kgdb.h>
+
 /* some serial hardware definitions */
 #define SDR_OVRUN   (1<<15)
 #define SDR_RBF     (1<<14)
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/drivers/char/amikeyb.c linux-2.2-p68k/drivers/char/amikeyb.c
--- linux-2.2-p68k.org/drivers/char/amikeyb.c	Sat Oct 31 00:50:41 1998
+++ linux-2.2-p68k/drivers/char/amikeyb.c	Wed Jan  6 23:19:15 1999
@@ -341,8 +341,3 @@
     
     return( 0 );
 }
-
-/* for "kbd-reset" cmdline param */
-__initfunc(void amiga_kbd_reset_setup(char *str, int *ints))
-{
-}
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/drivers/char/atari_SCC.c linux-2.2-p68k/drivers/char/atari_SCC.c
--- linux-2.2-p68k.org/drivers/char/atari_SCC.c	Wed Jan  6 22:25:36 1999
+++ linux-2.2-p68k/drivers/char/atari_SCC.c	Sat Jan  9 18:01:43 1999
@@ -828,7 +828,7 @@
 				}
 
 				for (i=0; i<SCCA_DMA_BUFFERS; i++)
-				  scca_dma_buf[i].pbuf = (char *)VTOP((int)scca_dma_buf[i].buf);
+				  scca_dma_buf[i].pbuf = (char *)virt_to_phys((int)scca_dma_buf[i].buf);
 
 				tt_mfp.int_en_a &= ~0x20;
 				tt_mfp.int_pn_a = ~0x20;
@@ -1046,7 +1046,7 @@
 static inline void dma_start (void)
 {
 	if ((dmaSize = SCCA_DMA_BUFSIZE - scca_dma_head->inbuf) > 0) {
-		dmaStartAddr = (ulong)(scca_dma_head->pbuf + scca_dma_head->inbuf); /* needs no VTOP() */
+		dmaStartAddr = (ulong)(scca_dma_head->pbuf + scca_dma_head->inbuf); /* needs no virt_to_phys() */
 #if DEBUG & DEBUG_DMA
 		debugString ("[start@0x");
 		debugHex (dmaStartAddr & 0xffff);
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/drivers/net/82596.c linux-2.2-p68k/drivers/net/82596.c
--- linux-2.2-p68k.org/drivers/net/82596.c	Wed Jan  6 22:25:36 1999
+++ linux-2.2-p68k/drivers/net/82596.c	Fri Jan  8 22:06:23 1999
@@ -1098,7 +1098,7 @@
 
 	cache_push(virt_to_phys((void *)(dev->mem_start)), 4096);
 	cache_clear(virt_to_phys((void *)(dev->mem_start)), 4096);
-	kernel_set_cachemode(dev->mem_start, 4096, KERNELMAP_NOCACHE_SER);
+	kernel_set_cachemode(dev->mem_start, 4096, IOMAP_NOCACHE_SER);
 
 	lp->scb.command = 0;
 	lp->scb.cmd = (struct i596_cmd *) I596_NULL;
@@ -1481,12 +1481,12 @@
 {
 	unregister_netdev(&dev_82596);
 
-	/* XXX This assumes default cache mode to be KERNELMAP_FULL_CACHING,
+	/* XXX This assumes default cache mode to be IOMAP_FULL_CACHING,
 	 * XXX which may be invalid (CONFIG_060_WRITETHROUGH)
 	 */
 
 	kernel_set_cachemode((u32)(dev_82596.mem_start), 4096,
-			KERNELMAP_FULL_CACHING);
+			IOMAP_FULL_CACHING);
 	free_page ((u32)(dev_82596.mem_start));
 	dev_82596.priv = NULL;
 #ifdef CONFIG_APRICOT_INTEL
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/drivers/net/8390.c linux-2.2-p68k/drivers/net/8390.c
--- linux-2.2-p68k.org/drivers/net/8390.c	Wed Jan  6 22:24:31 1999
+++ linux-2.2-p68k/drivers/net/8390.c	Sun Jan 10 01:53:42 1999
@@ -424,16 +424,21 @@
 	 
 	spin_lock(&ei_local->page_lock);
 
-	if (dev->interrupt || ei_local->irqlock) 
-	{
-#if 1 /* This might just be an interrupt for a PCI device sharing this line */
+	if (ei_local->irqlock) {
 		/* The "irqlock" check is only for testing. */
-		printk(ei_local->irqlock
-			   ? "%s: Interrupted while interrupts are masked! isr=%#2x imr=%#2x.\n"
-			   : "%s: Reentering the interrupt handler! isr=%#2x imr=%#2x.\n",
+#if 0	/* This might just be an interrupt for a PCI device sharing this line */
+		printk("%s: Interrupted while interrupts are masked! "
+			"isr=%#2x imr=%#2x.\n", dev->name,
+			inb_p(e8390_base + EN0_ISR), inb_p(e8390_base + EN0_IMR));
+#endif
+		spin_unlock(&ei_local->page_lock);
+		return;
+	}
+
+	if (dev->interrupt) {
+		printk("%s: Reentering the interrupt handler! isr=%#2x imr=%#2x.\n",
 			   dev->name, inb_p(e8390_base + EN0_ISR),
 			   inb_p(e8390_base + EN0_IMR));
-#endif
 		spin_unlock(&ei_local->page_lock);
 		return;
 	}
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/drivers/net/ariadne2.c linux-2.2-p68k/drivers/net/ariadne2.c
--- linux-2.2-p68k.org/drivers/net/ariadne2.c	Wed Jan  6 22:25:36 1999
+++ linux-2.2-p68k/drivers/net/ariadne2.c	Sun Jan 10 13:28:07 1999
@@ -192,7 +192,9 @@
     ((struct ei_device *)dev->priv)->priv = key;
 
     for(i = 0; i < ETHER_ADDR_LEN; i++) {
+#ifdef DEBUG
 	printk(" %2.2x", SA_prom[i]);
+#endif
 	dev->dev_addr[i] = SA_prom[i];
     }
 
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/drivers/net/atari_bionet.c linux-2.2-p68k/drivers/net/atari_bionet.c
--- linux-2.2-p68k.org/drivers/net/atari_bionet.c	Sat Oct 31 00:12:38 1998
+++ linux-2.2-p68k/drivers/net/atari_bionet.c	Sat Jan  9 18:02:07 1999
@@ -446,7 +446,7 @@
 	}
 	else {
 		int length = ETH_ZLEN < skb->len ? skb->len : ETH_ZLEN;
-		unsigned long buf = VTOP(skb->data);
+		unsigned long buf = virt_to_phys(skb->data);
 		int stat;
 
 		stdma_lock(bionet_intr, NULL);
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/drivers/net/atari_pamsnet.c linux-2.2-p68k/drivers/net/atari_pamsnet.c
--- linux-2.2-p68k.org/drivers/net/atari_pamsnet.c	Sat Oct 31 02:35:54 1998
+++ linux-2.2-p68k/drivers/net/atari_pamsnet.c	Sat Jan  9 18:02:25 1999
@@ -707,7 +707,7 @@
 	}
 	else {
 		int length = ETH_ZLEN < skb->len ? skb->len : ETH_ZLEN;
-		unsigned long buf = VTOP(skb->data);
+		unsigned long buf = virt_to_phys(skb->data);
 		int stat;
 
 		stdma_lock(pamsnet_intr, NULL);
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/drivers/scsi/53c7xx.c linux-2.2-p68k/drivers/scsi/53c7xx.c
--- linux-2.2-p68k.org/drivers/scsi/53c7xx.c	Wed Jan  6 22:25:37 1999
+++ linux-2.2-p68k/drivers/scsi/53c7xx.c	Fri Jan  8 22:08:29 1999
@@ -1213,7 +1213,7 @@
     memset((void *)instance->hostdata[0], 0, 8192);
     cache_push(virt_to_phys((void *)(instance->hostdata[0])), 8192);
     cache_clear(virt_to_phys((void *)(instance->hostdata[0])), 8192);
-    kernel_set_cachemode(instance->hostdata[0], 8192, KERNELMAP_NOCACHE_SER);
+    kernel_set_cachemode(instance->hostdata[0], 8192, IOMAP_NOCACHE_SER);
 
     /* FIXME : if we ever support an ISA NCR53c7xx based board, we
        need to check if the chip is running in a 16 bit mode, and if so 
@@ -3035,10 +3035,10 @@
 static void
 my_free_page (void *addr, int dummy)
 {
-    /* XXX This assumes default cache mode to be KERNELMAP_FULL_CACHING, which
+    /* XXX This assumes default cache mode to be IOMAP_FULL_CACHING, which
      * XXX may be invalid (CONFIG_060_WRITETHROUGH)
      */
-    kernel_set_cachemode((u32)addr, 4096, KERNELMAP_FULL_CACHING);
+    kernel_set_cachemode((u32)addr, 4096, IOMAP_FULL_CACHING);
     free_page ((u32)addr);
 }
 
@@ -3094,7 +3094,7 @@
         memset((void *)real, 0, 4096);
         cache_push(virt_to_phys((void *)real), 4096);
         cache_clear(virt_to_phys((void *)real), 4096);
-        kernel_set_cachemode(real, 4096, KERNELMAP_NOCACHE_SER);
+        kernel_set_cachemode(real, 4096, IOMAP_NOCACHE_SER);
 	tmp = ROUNDUP(real, void *);
 #ifdef FORCE_DSA_ALIGNMENT
 	{
@@ -6098,10 +6098,10 @@
     if (hostdata->events) 
 	vfree ((void *)hostdata->events);
 
-    /* XXX This assumes default cache mode to be KERNELMAP_FULL_CACHING, which
+    /* XXX This assumes default cache mode to be IOMAP_FULL_CACHING, which
      * XXX may be invalid (CONFIG_060_WRITETHROUGH)
      */
-    kernel_set_cachemode((u32)hostdata, 8192, KERNELMAP_FULL_CACHING);
+    kernel_set_cachemode((u32)hostdata, 8192, IOMAP_FULL_CACHING);
     free_pages ((u32)hostdata, 1);
     return 1;
 }
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/drivers/scsi/amiga7xx.c linux-2.2-p68k/drivers/scsi/amiga7xx.c
--- linux-2.2-p68k.org/drivers/scsi/amiga7xx.c	Wed Jan  6 22:25:37 1999
+++ linux-2.2-p68k/drivers/scsi/amiga7xx.c	Fri Jan  8 01:10:49 1999
@@ -20,6 +20,7 @@
 #include <asm/pgtable.h>
 #include <asm/amigaints.h>
 #include <asm/amigahw.h>
+#include <asm/io.h>
 #include <asm/irq.h>
 
 #include "scsi.h"
@@ -57,8 +58,8 @@
 	cd = zorro_get_board(key);
 /*
 	unsigned long address;
-	address = (unsigned long)kernel_map((unsigned long)cd->cd_BoardAddr,
-		cd->cd_BoardSize, KERNELMAP_NOCACHE_SER, NULL);
+	address = (unsigned long)ioremap_nocache((unsigned long)cd->cd_BoardAddr,
+						cd->cd_BoardSize);
 */
 	options = OPTION_MEMORY_MAPPED|OPTION_DEBUG_TEST1|OPTION_INTFLY|OPTION_SYNCHRONOUS|OPTION_ALWAYS_SYNCHRONOUS|OPTION_DISCONNECT;
 
@@ -78,8 +79,8 @@
     {
 	unsigned long address;
 	cd = zorro_get_board(key);
-	address = (unsigned long)kernel_map((unsigned long)cd->cd_BoardAddr,
-		cd->cd_BoardSize, KERNELMAP_NOCACHE_SER, NULL);
+	address = (unsigned long)ioremap_nocache((unsigned long)cd->cd_BoardAddr,
+						cd->cd_BoardSize);
 
 	options = OPTION_MEMORY_MAPPED|OPTION_DEBUG_TEST1|OPTION_INTFLY|OPTION_SYNCHRONOUS|OPTION_ALWAYS_SYNCHRONOUS|OPTION_DISCONNECT;
 
@@ -114,8 +115,8 @@
     {
 	unsigned long address;
 	cd = zorro_get_board(key);
-	address = (unsigned long)kernel_map((unsigned long)cd->cd_BoardAddr,
-		cd->cd_BoardSize, KERNELMAP_NOCACHE_SER, NULL);
+	address = (unsigned long)ioremap_nocache((unsigned long)cd->cd_BoardAddr,
+						cd->cd_BoardSize);
 
     	options = OPTION_MEMORY_MAPPED|OPTION_DEBUG_TEST1|OPTION_INTFLY|OPTION_SYNCHRONOUS|OPTION_ALWAYS_SYNCHRONOUS|OPTION_DISCONNECT;
 
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/drivers/scsi/atari_NCR5380.c linux-2.2-p68k/drivers/scsi/atari_NCR5380.c
--- linux-2.2-p68k.org/drivers/scsi/atari_NCR5380.c	Wed Jan  6 22:25:37 1999
+++ linux-2.2-p68k/drivers/scsi/atari_NCR5380.c	Sat Jan  9 18:02:59 1999
@@ -472,9 +472,9 @@
     int		  cnt = 1;
 #endif
 
-    for (endaddr = VTOP(cmd->SCp.ptr + cmd->SCp.this_residual - 1) + 1;
+    for (endaddr = virt_to_phys(cmd->SCp.ptr + cmd->SCp.this_residual - 1) + 1;
 	 cmd->SCp.buffers_residual &&
-	 VTOP(cmd->SCp.buffer[1].address) == endaddr; ) {
+	 virt_to_phys(cmd->SCp.buffer[1].address) == endaddr; ) {
 	
 	MER_PRINTK("VTOP(%p) == %08lx -> merging\n",
 		   cmd->SCp.buffer[1].address, endaddr);
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/drivers/scsi/atari_scsi.c linux-2.2-p68k/drivers/scsi/atari_scsi.c
--- linux-2.2-p68k.org/drivers/scsi/atari_scsi.c	Wed Jan  6 22:25:37 1999
+++ linux-2.2-p68k/drivers/scsi/atari_scsi.c	Sat Jan  9 18:03:21 1999
@@ -666,7 +666,7 @@
 					"double buffer\n" );
 			return( 0 );
 		}
-		atari_dma_phys_buffer = VTOP( atari_dma_buffer );
+		atari_dma_phys_buffer = virt_to_phys( atari_dma_buffer );
 		atari_dma_orig_addr = 0;
 	}
 #endif
@@ -898,7 +898,7 @@
 unsigned long atari_scsi_dma_setup( struct Scsi_Host *instance, void *data,
 				   unsigned long count, int dir )
 {
-	unsigned long addr = VTOP( data );
+	unsigned long addr = virt_to_phys( data );
 
 	DMA_PRINTK("scsi%d: setting up dma, data = %p, phys = %lx, count = %ld, "
 		   "dir = %d\n", instance->host_no, data, addr, count, dir);
@@ -1082,7 +1082,7 @@
 	}
 	
 	/* Last step: apply the hard limit on DMA transfers */
-	limit = (atari_dma_buffer && !STRAM_ADDR( VTOP(cmd->SCp.ptr) )) ?
+	limit = (atari_dma_buffer && !STRAM_ADDR( virt_to_phys(cmd->SCp.ptr) )) ?
 		    STRAM_BUFFER_SIZE : 255*512;
 	if (possible_len > limit)
 		possible_len = limit;
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/drivers/scsi/fastlane.c linux-2.2-p68k/drivers/scsi/fastlane.c
--- linux-2.2-p68k.org/drivers/scsi/fastlane.c	Sat Nov 14 01:28:07 1998
+++ linux-2.2-p68k/drivers/scsi/fastlane.c	Fri Jan  8 01:11:06 1999
@@ -38,6 +38,7 @@
 
 #include <linux/zorro.h>
 #include <asm/irq.h>
+#include <asm/io.h>
 #include <asm/amigaints.h>
 #include <asm/amigahw.h>
 
@@ -137,10 +138,8 @@
 
 		/* Map the physical address space into virtual kernel space */
 		address = (unsigned long)
-			kernel_map((unsigned long)esp_dev->cd_BoardAddr,
-				   esp_dev->cd_BoardSize,
-				   KERNELMAP_NOCACHE_SER,
-				   NULL);
+			ioremap_nocache((unsigned long)esp_dev->cd_BoardAddr,
+					esp_dev->cd_BoardSize);
 
 		if(!address){
 			printk("Could not remap Fastlane controller memory!");
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/drivers/scsi/mac_NCR5380.c linux-2.2-p68k/drivers/scsi/mac_NCR5380.c
--- linux-2.2-p68k.org/drivers/scsi/mac_NCR5380.c	Sat Oct 31 00:51:12 1998
+++ linux-2.2-p68k/drivers/scsi/mac_NCR5380.c	Sat Jan  9 18:03:45 1999
@@ -490,9 +490,9 @@
     int		  cnt = 1;
 #endif
 
-    for (endaddr = VTOP(cmd->SCp.ptr + cmd->SCp.this_residual - 1) + 1;
+    for (endaddr = virt_to_phys(cmd->SCp.ptr + cmd->SCp.this_residual - 1) + 1;
 	 cmd->SCp.buffers_residual &&
-	 VTOP(cmd->SCp.buffer[1].address) == endaddr; ) {
+	 virt_to_phys(cmd->SCp.buffer[1].address) == endaddr; ) {
 	
 	MER_PRINTK("VTOP(%p) == %08lx -> merging\n",
 		   cmd->SCp.buffer[1].address, endaddr);
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/drivers/scsi/mac_scsi.c linux-2.2-p68k/drivers/scsi/mac_scsi.c
--- linux-2.2-p68k.org/drivers/scsi/mac_scsi.c	Sat Oct 31 00:51:13 1998
+++ linux-2.2-p68k/drivers/scsi/mac_scsi.c	Sat Jan  9 18:04:01 1999
@@ -685,7 +685,7 @@
 unsigned long mac_scsi_dma_setup( struct Scsi_Host *instance, void *data,
 				   unsigned long count, int dir )
 {
-	unsigned long addr = VTOP( data );
+	unsigned long addr = virt_to_phys( data );
 
 	DMA_PRINTK("scsi%d: setting up dma, data = %p, phys = %lx, count = %ld, "
 		   "dir = %d\n", instance->host_no, data, addr, count, dir);
@@ -846,7 +846,7 @@
 	}
 
 	/* Last step: apply the hard limit on DMA transfers */
-	limit = (atari_dma_buffer && !STRAM_ADDR( VTOP(cmd->SCp.ptr) )) ?
+	limit = (atari_dma_buffer && !STRAM_ADDR( virt_to_phys(cmd->SCp.ptr) )) ?
 		    STRAM_BUFFER_SIZE : 255*512;
 	if (possible_len > limit)
 		possible_len = limit;
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/drivers/sound/dmasound.c linux-2.2-p68k/drivers/sound/dmasound.c
--- linux-2.2-p68k.org/drivers/sound/dmasound.c	Wed Jan  6 22:24:39 1999
+++ linux-2.2-p68k/drivers/sound/dmasound.c	Sat Jan  9 18:04:24 1999
@@ -2557,8 +2557,8 @@
 	start = sq_block_address(sq.front);
 	end = start+((sq.count == index) ? sq.rear_size : sq.block_size);
 	/* end might not be a legal virtual address. */
-	DMASNDSetEnd(VTOP(end - 1) + 1);
-	DMASNDSetBase(VTOP(start));
+	DMASNDSetEnd(virt_to_phys(end - 1) + 1);
+	DMASNDSetBase(virt_to_phys(start));
 	/* Since only an even number of samples per frame can
 	   be played, we might lose one byte here. (TO DO) */
 	sq.front = (sq.front+1) % sq.max_count;
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/drivers/video/amifb.c linux-2.2-p68k/drivers/video/amifb.c
--- linux-2.2-p68k.org/drivers/video/amifb.c	Sat Nov 21 01:21:30 1998
+++ linux-2.2-p68k/drivers/video/amifb.c	Sun Jan 10 15:01:05 1999
@@ -623,6 +623,7 @@
 
 static u_long videomemory, spritememory;
 static u_long videomemorysize;
+static u_long videomemory_phys;
 
 	/*
 	 * This is the earliest allowed start of fetching display data.
@@ -1479,8 +1480,7 @@
 			struct fb_fix_screeninfo fix;
 
 			ami_encode_fix(&fix, &par);
-			display->screen_base = 
-				phys_to_virt ((unsigned long) fix.smem_start);
+			display->screen_base = (char *)videomemory;
 			display->visual = fix.visual;
 			display->type = fix.type;
 			display->type_aux = fix.type_aux;
@@ -1877,6 +1877,18 @@
 	assignchunk(copdisplay.list[1][0], copins *, chipptr, COPLISTSIZE);
 	assignchunk(copdisplay.list[1][1], copins *, chipptr, COPLISTSIZE);
 
+	/*
+	 * access the videomem with writethrough cache
+	 */
+	videomemory_phys = (u_long)ZTWO_PADDR(videomemory);
+#if 1
+	videomemory = (u_long)ioremap_writethrough(videomemory_phys, videomemorysize);
+#endif
+	if (!videomemory) {
+		printk("amifb: WARNING! unable to map videomem cached writethrough\n");
+		videomemory = ZTWO_VADDR(videomemory_phys);
+	}
+
 	memset(dummysprite, 0, DUMMYSPRITEMEMSIZE);
 
 	/*
@@ -2126,7 +2138,7 @@
 {
 	memset(fix, 0, sizeof(struct fb_fix_screeninfo));
 	strcpy(fix->id, amifb_name);
-	fix->smem_start = (char*) virt_to_phys((void *)videomemory);
+	fix->smem_start = (char *)videomemory_phys;
 	fix->smem_len = videomemorysize;
 
 #ifdef FBCON_HAS_MFB
@@ -2742,16 +2754,16 @@
 		par->bpl1mod = par->bpl2mod;
 
 	if (par->yoffset) {
-		par->bplpt0 = ZTWO_PADDR((u_long)videomemory + par->next_line*par->yoffset + move);
+		par->bplpt0 = videomemory_phys + par->next_line*par->yoffset + move;
 		if (par->vmode & FB_VMODE_YWRAP) {
 			if (par->yoffset > par->vyres-par->yres) {
-				par->bplpt0wrap = ZTWO_PADDR((u_long)videomemory + move);
+				par->bplpt0wrap = videomemory_phys + move;
 				if (par->bplcon0 & BPC0_LACE && mod2(par->diwstrt_v+par->vyres-par->yoffset))
 					par->bplpt0wrap += par->next_line;
 			}
 		}
 	} else
-		par->bplpt0 = ZTWO_PADDR((u_long)videomemory + move);
+		par->bplpt0 = videomemory_phys + move;
 
 	if (par->bplcon0 & BPC0_LACE && mod2(par->diwstrt_v))
 		par->bplpt0 += par->next_line;
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/drivers/video/atafb.c linux-2.2-p68k/drivers/video/atafb.c
--- linux-2.2-p68k.org/drivers/video/atafb.c	Sat Oct 31 02:37:41 1998
+++ linux-2.2-p68k/drivers/video/atafb.c	Sat Jan  9 18:05:06 1999
@@ -62,6 +62,7 @@
 #include <asm/uaccess.h>
 #include <asm/pgtable.h>
 #include <asm/irq.h>
+#include <asm/io.h>
 
 #include <asm/atarihw.h>
 #include <asm/atariints.h>
@@ -2026,7 +2027,7 @@
 static void stste_set_screen_base(unsigned long s_base)
 {
 	unsigned long addr;
-	addr= VTOP(s_base);
+	addr= virt_to_phys(s_base);
 	/* Setup Screen Memory */
 	shifter.bas_hi=(unsigned char) ((addr & 0xff0000) >> 16);
   	shifter.bas_md=(unsigned char) ((addr & 0x00ff00) >> 8);
@@ -2297,7 +2298,7 @@
 static void set_screen_base(unsigned long s_base)
 {
 	unsigned long addr;
-	addr= VTOP(s_base);
+	addr= virt_to_phys(s_base);
 	/* Setup Screen Memory */
 	shifter.bas_hi=(unsigned char) ((addr & 0xff0000) >> 16);
   	shifter.bas_md=(unsigned char) ((addr & 0x00ff00) >> 8);
@@ -2819,9 +2820,9 @@
 		if (CPU_IS_040_OR_060) {
 			/* On a '040+, the cache mode of video RAM must be set to
 			 * write-through also for internal video hardware! */
-			cache_push( VTOP(screen_base), screen_len );
+			cache_push( virt_to_phys(screen_base), screen_len );
 			kernel_set_cachemode( screen_base, screen_len,
-								  KERNELMAP_NO_COPYBACK );
+					      IOMAP_WRITETHROUGH );
 		}
 #ifdef ATAFB_EXT
 	}
@@ -2829,11 +2830,9 @@
 		/* Map the video memory (physical address given) to somewhere
 		 * in the kernel address space.
 		 */
-		external_addr = kernel_map(external_addr, external_len,
-					   KERNELMAP_NO_COPYBACK, NULL);
+		external_addr = ioremap_writethrough(external_addr, external_len);
 		if (external_vgaiobase)
-			external_vgaiobase = kernel_map(external_vgaiobase,
-				0x10000, KERNELMAP_NOCACHE_SER, NULL);
+			external_vgaiobase = ioremap_nocache(external_vgaiobase, 0x10000 );
 		screen_base      =
 		real_screen_base = external_addr;
 		screen_len       = external_len & PAGE_MASK;
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/drivers/video/atyfb.c linux-2.2-p68k/drivers/video/atyfb.c
--- linux-2.2-p68k.org/drivers/video/atyfb.c	Wed Jan  6 00:44:15 1999
+++ linux-2.2-p68k/drivers/video/atyfb.c	Fri Jan  8 01:04:18 1999
@@ -3022,12 +3022,9 @@
 	 *  Map the video memory (physical address given) to somewhere in the
 	 *  kernel address space.
 	 */
-	info->frame_buffer = kernel_map(phys_vmembase[m64_num],
-					phys_size[m64_num],
-					KERNELMAP_NOCACHE_SER, NULL);
+	info->frame_buffer = ioremap_nocache(phys_vmembase[m64_num], phys_size[m64_num]);
 	info->frame_buffer_phys = info->frame_buffer;
-	info->ati_regbase = kernel_map(phys_guiregbase[m64_num], 0x10000,
-				       KERNELMAP_NOCACHE_SER, NULL)+0xFC00ul;
+	info->ati_regbase = ioremap_nocache(phys_guiregbase[m64_num], 0x10000)+0xFC00ul;
 	info->ati_regbase_phys = info->ati_regbase;
 
 	if (!aty_init(info, "ISA bus")) {
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/drivers/video/clgenfb.c linux-2.2-p68k/drivers/video/clgenfb.c
--- linux-2.2-p68k.org/drivers/video/clgenfb.c	Wed Jan  6 22:25:37 1999
+++ linux-2.2-p68k/drivers/video/clgenfb.c	Fri Jan  8 01:12:02 1999
@@ -16,6 +16,7 @@
 #include <asm/amigahw.h>
 #include <asm/pgtable.h>
 #include <asm/delay.h>
+#include <asm/io.h>
 
 #include <video/fbcon.h>
 #include <video/fbcon-mfb.h>
@@ -1533,15 +1534,13 @@
         /* begin of the board, but the begin of RAM. */
 	/* for P4, map in its address space in 2 chunks (### TEST! ) */
 	/* (note the ugly hardcoded 16M number) */
-	fb_info->regs = (unsigned char *)kernel_map(board_addr, 16777216, 
-	                                      KERNELMAP_NOCACHE_SER, NULL);
+	fb_info->regs = ioremap_nocache(board_addr, 16777216);
         DEBUG printk(KERN_INFO "clgen: Virtual address for board set to: $%p\n", fb_info->regs);
 	fb_info->regs += 0x600000;
 	fb_info->fbregs_phys = board_addr + 0x600000;
 
 	fb_info->fbmem_phys = board_addr + 16777216;
-	fb_info->fbmem = kernel_map(fb_info->fbmem_phys, 16777216, 
-			      KERNELMAP_NOCACHE_SER, NULL);
+	fb_info->fbmem = ioremap(fb_info->fbmem_phys, 16777216);
 	DEBUG printk(KERN_INFO "clgen: (RAM start set to: $%lx)\n", fb_info->fbmem);
     }
     else
@@ -1551,8 +1550,7 @@
 
 	fb_info->fbmem_phys = board_addr;
         if (board_addr > 0x01000000)
-	    fb_info->fbmem = kernel_map(board_addr, board_size, 
-				  KERNELMAP_NOCACHE_SER, NULL);
+	    fb_info->fbmem = ioremap_nocache(board_addr, board_size);
 	else
 	    fb_info->fbmem = ZTWO_VADDR(board_addr);
 
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/drivers/video/cvppcfb.c linux-2.2-p68k/drivers/video/cvppcfb.c
--- linux-2.2-p68k.org/drivers/video/cvppcfb.c	Sat Nov 21 01:21:53 1998
+++ linux-2.2-p68k/drivers/video/cvppcfb.c	Fri Jan  8 01:15:24 1999
@@ -513,8 +513,7 @@
 	video_size=CVPPC_SIZE;
 	video_phys=CVPPC_BASE;
 #ifdef CONFIG_APUS
-	video_base=(char* )
-		kernel_map(video_phys, video_size, KERNELMAP_NOCACHE_SER, NULL);
+	video_base=ioremap_nocache(video_phys, video_size);
 #else
 	video_base=ioremap(video_phys, video_size);
 #endif
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/drivers/video/cyberfb.c linux-2.2-p68k/drivers/video/cyberfb.c
--- linux-2.2-p68k.org/drivers/video/cyberfb.c	Wed Jan  6 00:44:14 1999
+++ linux-2.2-p68k/drivers/video/cyberfb.c	Fri Jan  8 01:06:25 1999
@@ -1146,8 +1146,7 @@
 	DPRINTK("board_addr=%08lx\n", board_addr);
 	DPRINTK("board_size=%08lx\n", board_size);
 
-	cv64_mem = kernel_map (board_addr, board_size, KERNELMAP_NOCACHE_SER,
-			       NULL);
+	cv64_mem = ioremap_nocache(board_addr, board_size);
 	cv64_regs = (volatile char *)(cv64_mem + 0x02000000);
 	cv64_fbmem = cv64_mem + 0x01400000;
 	DPRINTK("cv64_mem=%08lx cv64_regs=%08lx cv64_fbmem=%08lx\n",
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/drivers/video/fbcon-iplan2p2.c linux-2.2-p68k/drivers/video/fbcon-iplan2p2.c
--- linux-2.2-p68k.org/drivers/video/fbcon-iplan2p2.c	Fri Nov 27 23:38:32 1998
+++ linux-2.2-p68k/drivers/video/fbcon-iplan2p2.c	Wed Jan  6 23:19:15 1999
@@ -10,7 +10,6 @@
  *  more details.
  */
 
-#include <linux/config.h>
 #include <linux/module.h>
 #include <linux/tty.h>
 #include <linux/console.h>
@@ -18,6 +17,7 @@
 #include <linux/fb.h>
 
 #include <asm/byteorder.h>
+#include <asm/setup.h>
 
 #include <video/fbcon.h>
 #include <video/fbcon-iplan2p2.h>
@@ -43,7 +43,7 @@
 /* Perform the m68k movepw operation.  */
 static inline void movepw(u8 *d, u16 val)
 {
-#if defined __mc68000__ && !defined CONFIG_OPTIMIZE_060
+#if defined __mc68000__ && !defined CPU_M68060_ONLY
     asm volatile ("movepw %1,%0@(0)" : : "a" (d), "d" (val));
 #else
     d[0] = (val >> 16) & 0xff;
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/drivers/video/fbcon-iplan2p4.c linux-2.2-p68k/drivers/video/fbcon-iplan2p4.c
--- linux-2.2-p68k.org/drivers/video/fbcon-iplan2p4.c	Fri Nov 27 23:38:33 1998
+++ linux-2.2-p68k/drivers/video/fbcon-iplan2p4.c	Wed Jan  6 23:19:15 1999
@@ -10,7 +10,6 @@
  *  more details.
  */
 
-#include <linux/config.h>
 #include <linux/module.h>
 #include <linux/tty.h>
 #include <linux/console.h>
@@ -18,6 +17,7 @@
 #include <linux/fb.h>
 
 #include <asm/byteorder.h>
+#include <asm/setup.h>
 
 #include <video/fbcon.h>
 #include <video/fbcon-iplan2p4.h>
@@ -35,7 +35,7 @@
 /* Perform the m68k movepl operation.  */
 static inline void movepl(u8 *d, u32 val)
 {
-#if defined __mc68000__ && !defined CONFIG_OPTIMIZE_060
+#if defined __mc68000__ && !defined CPU_M68060_ONLY
     asm volatile ("movepl %1,%0@(0)" : : "a" (d), "d" (val));
 #else
     d[0] = (val >> 24) & 0xff;
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/drivers/video/fbcon-iplan2p8.c linux-2.2-p68k/drivers/video/fbcon-iplan2p8.c
--- linux-2.2-p68k.org/drivers/video/fbcon-iplan2p8.c	Fri Nov 27 23:38:34 1998
+++ linux-2.2-p68k/drivers/video/fbcon-iplan2p8.c	Wed Jan  6 23:19:15 1999
@@ -10,7 +10,6 @@
  *  more details.
  */
 
-#include <linux/config.h>
 #include <linux/module.h>
 #include <linux/tty.h>
 #include <linux/console.h>
@@ -18,6 +17,7 @@
 #include <linux/fb.h>
 
 #include <asm/byteorder.h>
+#include <asm/setup.h>
 
 #include <video/fbcon.h>
 #include <video/fbcon-iplan2p8.h>
@@ -40,7 +40,7 @@
 /* Perform the m68k movepl operation extended to 64 bits.  */
 static inline void movepl2(u8 *d, u32 val1, u32 val2)
 {
-#if defined __mc68000__ && !defined CONFIG_OPTIMIZE_060
+#if defined __mc68000__ && !defined CPU_M68060_ONLY
     asm volatile ("movepl %1,%0@(0); movepl %2,%0@(8)"
 		  : : "a" (d), "d" (val1), "d" (val2));
 #else
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/drivers/video/retz3fb.c linux-2.2-p68k/drivers/video/retz3fb.c
--- linux-2.2-p68k.org/drivers/video/retz3fb.c	Wed Jan  6 00:44:22 1999
+++ linux-2.2-p68k/drivers/video/retz3fb.c	Fri Jan  8 01:07:03 1999
@@ -1455,8 +1455,7 @@
 	board_addr = (unsigned long)cd->cd_BoardAddr;
 	board_size = (unsigned long)cd->cd_BoardSize;
 
-	zinfo->base = kernel_map (board_addr, board_size,
-				   KERNELMAP_NOCACHE_SER, NULL);
+	zinfo->base = ioremap_nocache(board_addr, board_size);
 	zinfo->regs = (unsigned char *)(zinfo->base);
 	zinfo->fbmem = zinfo->base + VIDEO_MEM_OFFSET;
 	/* Get memory size - for now we asume its a 4MB board */
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/drivers/video/virgefb.c linux-2.2-p68k/drivers/video/virgefb.c
--- linux-2.2-p68k.org/drivers/video/virgefb.c	Wed Jan  6 22:25:37 1999
+++ linux-2.2-p68k/drivers/video/virgefb.c	Fri Jan  8 01:08:20 1999
@@ -1073,16 +1073,12 @@
 	}
 	else
 	{
-		CyberVGARegs = kernel_map(board_addr +0x0c000000, 0x00010000,
-					       KERNELMAP_NOCACHE_SER, NULL);
+		CyberVGARegs = ioremap_nocache(board_addr +0x0c000000, 0x00010000);
 
 		CyberRegs_phys = board_addr + 0x05000000;
 		CyberMem_phys  = board_addr + 0x04800000;
-		CyberRegs = (char *)kernel_map(CyberRegs_phys,
-					       0x00010000,
-					       KERNELMAP_NOCACHE_SER, NULL);
-		CyberMem = kernel_map(CyberMem_phys, 0x00400000,
-				      KERNELMAP_NOCACHE_SER, NULL);
+		CyberRegs = ioremap_nocache(CyberRegs_phys, 0x00010000);
+		CyberMem = ioremap_nocache(CyberMem_phys, 0x00400000);
 		cv3d_on_zorro2 = 0;
 		printk("CV3D detected running in Z3 mode\n");
 	}
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/fs/msdos/namei.c linux-2.2-p68k/fs/msdos/namei.c
--- linux-2.2-p68k.org/fs/msdos/namei.c	Wed Jan  6 22:25:37 1999
+++ linux-2.2-p68k/fs/msdos/namei.c	Wed Jan  6 23:19:15 1999
@@ -7,7 +7,6 @@
 
 
 #define __NO_VERSION__
-#include <linux/config.h>
 #include <linux/module.h>
 
 #include <linux/sched.h>
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/include/asm-m68k/bootinfo.h linux-2.2-p68k/include/asm-m68k/bootinfo.h
--- linux-2.2-p68k.org/include/asm-m68k/bootinfo.h	Wed Jan  6 22:28:36 1999
+++ linux-2.2-p68k/include/asm-m68k/bootinfo.h	Sat Jan  9 17:37:34 1999
@@ -46,12 +46,6 @@
     unsigned long data[0];		/* data */
 };
 
-#else /* __ASSEMBLY__ */
-
-BIR_tag		= 0
-BIR_size	= BIR_tag+2
-BIR_data	= BIR_size+2
-
 #endif /* __ASSEMBLY__ */
 
 
@@ -287,14 +281,6 @@
 	unsigned long adbdelay;
 	unsigned long timedbra;
 };
-#else
-
-#define BI_videoaddr	BI_un
-#define BI_videorow	BI_videoaddr+4
-#define BI_videodepth	BI_videorow+4
-#define BI_dimensions	BI_videodepth+4
-#define BI_args		BI_dimensions+4
-#define BI_cpuid	BI_args+56
 
 #endif
 
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/include/asm-m68k/entry.h linux-2.2-p68k/include/asm-m68k/entry.h
--- linux-2.2-p68k.org/include/asm-m68k/entry.h	Wed Jan  6 22:32:30 1999
+++ linux-2.2-p68k/include/asm-m68k/entry.h	Sun Jan 10 02:34:19 1999
@@ -1,7 +1,11 @@
 #ifndef __M68K_ENTRY_H
 #define __M68K_ENTRY_H
 
-#include <linux/config.h>
+#include <config/atari.h>
+#ifdef CONFIG_ATARI
+#include <config/hades.h>
+#endif
+#include <config/kgdb.h>
 #include <asm/setup.h>
 #ifdef CONFIG_KGDB
 #include <asm/kgdb.h>
@@ -37,25 +41,8 @@
 
 #define curptr a2
 
-/*
- * these are offsets into the task-struct
- */
-LTASK_STATE	 =  0
-LTASK_FLAGS	 =  4
-LTASK_SIGPENDING =  8
-LTASK_ADDRLIMIT	 = 12
-LTASK_EXECDOMAIN = 16
-LTASK_NEEDRESCHED = 20
-
-LTSS_KSP	= 0
-LTSS_USP	= 4
-LTSS_SR		= 8
-LTSS_FS		= 10
-LTSS_CRP	= 12
-LTSS_FPCTXT	= 24
-
 /* the following macro is used when enabling interrupts */
-#if defined(CONFIG_ATARI_ONLY) && !defined(CONFIG_HADES)
+#if defined(MACH_ATARI_ONLY) && !defined(CONFIG_HADES)
 	/* block out HSYNC on the atari */
 #define ALLOWINT 0xfbff
 #define	MAX_NOINT_IPL	3
@@ -65,22 +52,20 @@
 #define	MAX_NOINT_IPL	0
 #endif /* machine compilation types */ 
 
-LPT_OFF_D0	  = 0x20
-LPT_OFF_ORIG_D0	  = 0x24
-LPT_OFF_SR	  = 0x2C
-LPT_OFF_FORMATVEC = 0x32
-
 LFLUSH_I_AND_D = 0x00000808
-LENOSYS = 38
 LSIGTRAP = 5
 
-LPF_TRACESYS_OFF = 3
-LPF_TRACESYS_BIT = 5
-LPF_PTRACED_OFF = 3
-LPF_PTRACED_BIT = 4
-LPF_DTRACE_OFF = 1
-LPF_DTRACE_BIT = 5
-
+/* process bits for task_struct.flags */
+PF_TRACESYS_OFF = 3
+PF_TRACESYS_BIT = 5
+PF_PTRACED_OFF = 3
+PF_PTRACED_BIT = 4
+PF_DTRACE_OFF = 1
+PF_DTRACE_BIT = 5
+
+#define SAVE_ALL_INT save_all_int
+#define SAVE_ALL_SYS save_all_sys
+#define RESTORE_ALL restore_all
 /*
  * This defines the normal kernel pt-regs layout.
  *
@@ -92,56 +77,68 @@
  * a -1 in the orig_d0 field signifies
  * that the stack frame is NOT for syscall
  */
-#define SAVE_ALL_INT				\
-	clrl	%sp@-;		/* stk_adj */	\
-	pea	-1:w;		/* orig d0 */	\
-	movel	%d0,%sp@-;	/* d0 */	\
+.macro	save_all_int
+	clrl	%sp@-		| stk_adj
+	pea	-1:w		| orig d0
+	movel	%d0,%sp@-	| d0
 	moveml	%d1-%d5/%a0-%a1/%curptr,%sp@-
+.endm
 
-#define SAVE_ALL_SYS				\
-	clrl	%sp@-;		/* stk_adj */	\
-	movel	%d0,%sp@-;	/* orig d0 */	\
-	movel	%d0,%sp@-;	/* d0 */	\
-	moveml  %d1-%d5/%a0-%a1/%curptr,%sp@-
+.macro	save_all_sys
+	clrl	%sp@-		| stk_adj
+	movel	%d0,%sp@-	| orig d0
+	movel	%d0,%sp@-	| d0
+	moveml	%d1-%d5/%a0-%a1/%curptr,%sp@-
+.endm
 #else
 /* Need to save the "missing" registers for kgdb...
  */
-#define SAVE_ALL_INT					\
-	clrl	%sp@-;		/* stk_adj */		\
-	pea	-1:w;		/* orig d0 */		\
-	movel	%d0,%sp@-;	/* d0 */		\
-	moveml	%d1-%d5/%a0-%a1/%curptr,%sp@-;		\
-	moveml	%d6-%d7,kgdb_registers+GDBOFFA_D6;	\
+.macro	save_all_int
+	clrl	%sp@-		| stk_adj
+	pea	-1:w		| orig d0
+	movel	%d0,%sp@-	| d0
+	moveml	%d1-%d5/%a0-%a1/%curptr,%sp@-
+	moveml	%d6-%d7,kgdb_registers+GDBOFFA_D6
 	moveml	%a3-%a6,kgdb_registers+GDBOFFA_A3
+.endm
 
-#define SAVE_ALL_SYS					\
-	clrl	%sp@-;		/* stk_adj */		\
-	movel	%d0,%sp@-;	/* orig d0 */		\
-	movel	%d0,%sp@-;	/* d0 */		\
-	moveml	%d1-%d5/%a0-%a1/%curptr,%sp@-;		\
-	moveml	%d6-%d7,kgdb_registers+GDBOFFA_D6;	\
+.macro	save_all_sys
+	clrl	%sp@-		| stk_adj
+	movel	%d0,%sp@-	| orig d0
+	movel	%d0,%sp@-	| d0
+	moveml	%d1-%d5/%a0-%a1/%curptr,%sp@-
+	moveml	%d6-%d7,kgdb_registers+GDBOFFA_D6
 	moveml	%a3-%a6,kgdb_registers+GDBOFFA_A3
+.endm
 #endif
 
-#define RESTORE_ALL			\
-	moveml	%sp@+,%a0-%a1/%curptr/%d1-%d5;	\
-	movel	%sp@+,%d0;		\
-	addql	#4,%sp;	 /* orig d0 */	\
-	addl	%sp@+,%sp; /* stk adj */	\
+.macro	restore_all
+	moveml	%sp@+,%a0-%a1/%curptr/%d1-%d5
+	movel	%sp@+,%d0
+	addql	#4,%sp		| orig d0
+	addl	%sp@+,%sp	| stk adj
 	rte
+.endm
 
 #define SWITCH_STACK_SIZE (6*4+4)	/* includes return address */
 
-#define SAVE_SWITCH_STACK \
+#define SAVE_SWITCH_STACK save_switch_stack
+#define RESTORE_SWITCH_STACK restore_switch_stack
+#define GET_CURRENT(tmp) get_current tmp
+
+.macro	save_switch_stack
 	moveml	%a3-%a6/%d6-%d7,%sp@-
+.endm
 
-#define RESTORE_SWITCH_STACK \
+.macro	restore_switch_stack
 	moveml	%sp@+,%a3-%a6/%d6-%d7
+.endm
 
-#define GET_CURRENT(tmp) \
-	movel	%sp,tmp; \
-	andw	&-8192,tmp; \
-	movel	tmp,%curptr;
+.macro	get_current reg=%d0
+	movel	%sp,\reg
+	andw	#-8192,\reg
+	movel	\reg,%curptr
+.endm
 
 #else /* C source */
 
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/include/asm-m68k/fpu.h linux-2.2-p68k/include/asm-m68k/fpu.h
--- linux-2.2-p68k.org/include/asm-m68k/fpu.h	Wed Jan  6 22:28:35 1999
+++ linux-2.2-p68k/include/asm-m68k/fpu.h	Sun Jan 10 02:30:20 1999
@@ -1,7 +1,10 @@
 #ifndef __M68K_FPU_H
 #define __M68K_FPU_H
 
-#include <linux/config.h>
+#include <config/m68020.h>
+#include <config/m68030.h>
+#include <config/m68040.h>
+#include <config/m68060.h>
 
 /*
  * MAX floating point unit state size (FSAVE/FRESTORE)
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/include/asm-m68k/ide.h linux-2.2-p68k/include/asm-m68k/ide.h
--- linux-2.2-p68k.org/include/asm-m68k/ide.h	Wed Jan  6 22:29:07 1999
+++ linux-2.2-p68k/include/asm-m68k/ide.h	Sun Jan 10 02:30:55 1999
@@ -31,7 +31,9 @@
 
 #ifdef __KERNEL__
 
-#include <linux/config.h>
+#include <config/amiga.h>
+#include <config/atari.h>
+#include <config/mac.h>
 
 #include <asm/setup.h>
 #include <asm/io.h>
@@ -449,7 +451,7 @@
  * an interrupt, and in that case it does nothing. Hope that is reasonable and
  * works. (Roman)
  */
-#ifdef CONFIG_ATARI_ONLY
+#ifdef MACH_ATARI_ONLY
 #define	ide__sti()					\
     do {						\
 	if (!in_interrupt()) __sti();			\
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/include/asm-m68k/init.h linux-2.2-p68k/include/asm-m68k/init.h
--- linux-2.2-p68k.org/include/asm-m68k/init.h	Sat Jan  9 16:00:29 1999
+++ linux-2.2-p68k/include/asm-m68k/init.h	Sat Jan  9 16:00:02 1999
@@ -1,7 +1,7 @@
 #ifndef _M68K_INIT_H
 #define _M68K_INIT_H
 
-#include <linux/config.h>
+#include <config/kgdb.h>
 
 #ifndef CONFIG_KGDB
 
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/include/asm-m68k/io.h linux-2.2-p68k/include/asm-m68k/io.h
--- linux-2.2-p68k.org/include/asm-m68k/io.h	Wed Jan  6 22:28:36 1999
+++ linux-2.2-p68k/include/asm-m68k/io.h	Sun Jan 10 02:30:21 1999
@@ -3,7 +3,7 @@
 
 #ifdef __KERNEL__
 
-#include <linux/config.h>
+#include <config/atari.h>
 
 #ifdef CONFIG_ATARI
 #include <asm/atarihw.h>
@@ -42,6 +42,30 @@
 
 #define outb(x,addr) ((void) writeb(x,addr))
 #define outb_p(x,addr) outb(x,addr)
+
+
+/* Values for nocacheflag and cmode */
+#define IOMAP_FULL_CACHING		0
+#define IOMAP_NOCACHE_SER		1
+#define IOMAP_NOCACHE_NONSER		2
+#define IOMAP_WRITETHROUGH		3
+
+extern void *__ioremap(unsigned long physaddr, unsigned long size, int cacheflag);
+extern void __iounmap(void *addr, unsigned long size);
+
+extern inline void *ioremap(unsigned long physaddr, unsigned long size)
+{
+	return __ioremap(physaddr, size, IOMAP_FULL_CACHING);
+}
+extern inline void *ioremap_nocache(unsigned long physaddr, unsigned long size)
+{
+	return __ioremap(physaddr, size, IOMAP_NOCACHE_SER);
+}
+extern inline void *ioremap_writethrough(unsigned long physaddr, unsigned long size)
+{
+	return __ioremap(physaddr, size, IOMAP_WRITETHROUGH);
+}
+extern void iounmap(void *addr);
 
 #endif /* __KERNEL__ */
 
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/include/asm-m68k/keyboard.h linux-2.2-p68k/include/asm-m68k/keyboard.h
--- linux-2.2-p68k.org/include/asm-m68k/keyboard.h	Wed Jan  6 22:29:38 1999
+++ linux-2.2-p68k/include/asm-m68k/keyboard.h	Fri Jan  8 01:20:42 1999
@@ -8,10 +8,11 @@
  *  This file contains the m68k architecture specific keyboard definitions
  */
 
-#include <linux/config.h> /* CONFIG_MAGIC_SYSRQ */
 #ifndef __M68K_KEYBOARD_H
 #define __M68K_KEYBOARD_H
 
+#include <config/magic/sysrq.h>
+
 #ifdef __KERNEL__
 
 #include <asm/machdep.h>
@@ -52,9 +53,9 @@
 
 #ifdef CONFIG_MAGIC_SYSRQ
 #define kbd_is_sysrq(keycode)	((keycode) == mach_sysrq_key && \
-								 (up_flag || \
-								  (shift_state & mach_sysrq_shift_mask) == \
-								  mach_sysrq_shift_state))
+				 (up_flag || \
+				  (shift_state & mach_sysrq_shift_mask) == \
+				  mach_sysrq_shift_state))
 #define kbd_sysrq_xlate			mach_sysrq_xlate
 #endif
 
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/include/asm-m68k/linux_logo.h linux-2.2-p68k/include/asm-m68k/linux_logo.h
--- linux-2.2-p68k.org/include/asm-m68k/linux_logo.h	Wed Jan  6 22:29:20 1999
+++ linux-2.2-p68k/include/asm-m68k/linux_logo.h	Sun Jan 10 02:31:06 1999
@@ -18,9 +18,9 @@
  * but should contain %s to display the version
  */
  
-#include <linux/config.h>
 #include <linux/init.h>
 #include <linux/version.h>
+#include <config/mac.h>
 
 #define linux_logo_banner "Linux/m68k version " UTS_RELEASE
 
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/include/asm-m68k/machdep.h linux-2.2-p68k/include/asm-m68k/machdep.h
--- linux-2.2-p68k.org/include/asm-m68k/machdep.h	Sat Oct 31 02:39:19 1998
+++ linux-2.2-p68k/include/asm-m68k/machdep.h	Wed Jan  6 23:33:04 1999
@@ -13,7 +13,6 @@
 extern int (*mach_keyb_init) (void);
 extern int (*mach_kbdrate) (struct kbd_repeat *);
 extern void (*mach_kbd_leds) (unsigned int);
-extern void (*kbd_reset_setup) (char *, int);
 /* machine dependent irq functions */
 extern void (*mach_init_IRQ) (void);
 extern void (*(*mach_default_handler)[]) (int, void *, struct pt_regs *);
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/include/asm-m68k/machw.h linux-2.2-p68k/include/asm-m68k/machw.h
--- linux-2.2-p68k.org/include/asm-m68k/machw.h	Sat Oct 31 01:14:30 1998
+++ linux-2.2-p68k/include/asm-m68k/machw.h	Sat Jan  9 17:48:17 1999
@@ -13,6 +13,16 @@
 #ifndef _ASM_MACHW_H_
 #define _ASM_MACHW_H_
 
+/*
+ * head.S maps the videomem to VIDEOMEMBASE
+ */
+
+#define VIDEOMEMBASE	0xf0000000
+#define VIDEOMEMSIZE	(4096*1024)
+#define VIDEOMEMMASK	(-4096*1024)
+
+#ifndef __ASSEMBLY__
+
 #include <linux/types.h>
 
 /* Mac SCSI Controller 5380 */
@@ -142,5 +152,7 @@
 } mac_hw_present;
 
 /* extern struct mac_hw_present mac_hw_present; */
+
+#endif /* __ASSEMBLY__ */
 
 #endif /* linux/machw.h */
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/include/asm-m68k/page.h linux-2.2-p68k/include/asm-m68k/page.h
--- linux-2.2-p68k.org/include/asm-m68k/page.h	Sat Oct 31 00:13:12 1998
+++ linux-2.2-p68k/include/asm-m68k/page.h	Wed Jan  6 23:19:15 1999
@@ -8,7 +8,7 @@
 
 #ifdef __KERNEL__
 
-#include<linux/config.h>
+#include <asm/setup.h>
 
 #define STRICT_MM_TYPECHECKS
 
@@ -18,7 +18,7 @@
 /*
  * We don't need to check for alignment etc.
  */
-#if defined(CONFIG_OPTIMIZE_040) || defined(CONFIG_OPTIMIZE_060)
+#ifdef CPU_M68040_OR_M68060_ONLY
 static inline void copy_page(unsigned long to, unsigned long from)
 {
   unsigned long tmp;
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/include/asm-m68k/pgtable.h linux-2.2-p68k/include/asm-m68k/pgtable.h
--- linux-2.2-p68k.org/include/asm-m68k/pgtable.h	Wed Jan  6 22:28:36 1999
+++ linux-2.2-p68k/include/asm-m68k/pgtable.h	Sun Jan 10 02:30:21 1999
@@ -1,8 +1,17 @@
 #ifndef _M68K_PGTABLE_H
 #define _M68K_PGTABLE_H
 
-#include <linux/config.h>
 #include <asm/setup.h>
+#include <config/advanced.h>
+#include <config/vme.h>
+#include <config/m68060.h>
+#ifdef CONFIG_ADVANCED
+#include <config/single/memory/chunk.h>
+#endif
+#if (defined(CONFIG_VME) && defined(CONFIG_M68060)) || \
+    (!defined(CONFIG_VME) && defined(CONFIG_M68060) && defined(CONFIG_ADVANCED))
+#include <config/060/writethrough.h>
+#endif
 
 #ifndef __ASSEMBLY__
 #include <asm/processor.h>
@@ -13,14 +22,7 @@
  * the m68k page table tree.
  */
 
-/* For virtual address to physical address conversion */
-extern unsigned long mm_vtop(unsigned long addr) __attribute__ ((const));
-extern unsigned long mm_ptov(unsigned long addr) __attribute__ ((const));
-
-#include<asm/virtconvert.h>
-
-#define VTOP(addr)  (mm_vtop((unsigned long)(addr)))
-#define PTOV(addr)  (mm_ptov((unsigned long)(addr)))
+#include <asm/virtconvert.h>
 
 /*
  * Cache handling functions
@@ -442,16 +444,6 @@
 		pmdp->pmd[i] = _PAGE_TABLE | _PAGE_ACCESSED | (unsigned long)ptep;
 }
 
-/* early termination version of the above */
-extern inline void pmd_set_et(pmd_t * pmdp, pte_t * ptep)
-{
-	int i;
-
-	ptep = (pte_t *) virt_to_phys(ptep);
-	for (i = 0; i < 16; i++, ptep += PTRS_PER_PTE/16)
-		pmdp->pmd[i] = _PAGE_PRESENT | _PAGE_ACCESSED | (unsigned long)ptep;
-}
-
 extern inline void pgd_set(pgd_t * pgdp, pmd_t * pmdp)
 { pgd_val(*pgdp) = _PAGE_TABLE | _PAGE_ACCESSED | virt_to_phys(pmdp); }
 
@@ -547,7 +539,7 @@
 	return mm->pgd + (address >> PGDIR_SHIFT);
 }
 
-extern pgd_t swapper_pg_dir[128];
+#define swapper_pg_dir kernel_pg_dir
 extern pgd_t kernel_pg_dir[128];
 
 extern inline pgd_t * pgd_offset_k(unsigned long address)
@@ -625,8 +617,6 @@
 
 extern pmd_t *get_pointer_table(void);
 extern int free_pointer_table(pmd_t *);
-extern pmd_t *get_kpointer_table(void);
-extern void free_kpointer_table(pmd_t *);
 
 extern __inline__ pte_t *get_pte_fast(void)
 {
@@ -754,29 +744,12 @@
 
 extern inline void pmd_free_kernel(pmd_t * pmd)
 {
-	free_kpointer_table(pmd);
+	free_pmd_fast(pmd);
 }
 
 extern inline pmd_t * pmd_alloc_kernel(pgd_t * pgd, unsigned long address)
 {
-	address = (address >> PMD_SHIFT) & (PTRS_PER_PMD - 1);
-	if (pgd_none(*pgd)) {
-		pmd_t *page = get_kpointer_table();
-		if (pgd_none(*pgd)) {
-			if (page) {
-				pgd_set(pgd, page);
-				return page + address;
-			}
-			pgd_set(pgd, (pmd_t *)BAD_PAGETABLE);
-			return NULL;
-		}
-		free_kpointer_table(page);
-	}
-	if (pgd_bad(*pgd)) {
-		__bad_pmd(pgd);
-		return NULL;
-	}
-	return (pmd_t *) pgd_page(*pgd) + address;
+	return pmd_alloc(pgd, address);
 }
 
 extern inline void pgd_free(pgd_t * pgd)
@@ -815,26 +788,7 @@
 int mm_end_of_chunk (unsigned long addr, int len);
 #endif
 
-/*
- * Map some physical address range into the kernel address space.
- */
-extern unsigned long kernel_map(unsigned long paddr, unsigned long size,
-				int nocacheflag, unsigned long *memavailp );
-/*
- * Unmap a region alloced by kernel_map().
- */
-extern void kernel_unmap( unsigned long addr );
-/*
- * Change the cache mode of some kernel address range.
- */
-extern void kernel_set_cachemode( unsigned long address, unsigned long size,
-				  unsigned cmode );
-
-/* Values for nocacheflag and cmode */
-#define	KERNELMAP_FULL_CACHING		0
-#define	KERNELMAP_NOCACHE_SER		1
-#define	KERNELMAP_NOCACHE_NONSER	2
-#define	KERNELMAP_NO_COPYBACK		3
+extern void kernel_set_cachemode(void *addr, unsigned long size, int cmode);
 
 /*
  * The m68k doesn't have any external MMU info: the kernel page
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/include/asm-m68k/semaphore.h linux-2.2-p68k/include/asm-m68k/semaphore.h
--- linux-2.2-p68k.org/include/asm-m68k/semaphore.h	Wed Jan  6 22:28:35 1999
+++ linux-2.2-p68k/include/asm-m68k/semaphore.h	Sun Jan 10 02:30:20 1999
@@ -1,10 +1,13 @@
 #ifndef _M68K_SEMAPHORE_H
 #define _M68K_SEMAPHORE_H
 
-#include <linux/config.h>
 #include <linux/linkage.h>
 #include <asm/system.h>
 #include <asm/atomic.h>
+#include <config/advanced.h>
+#ifdef CONFIG_ADVANCED
+#include <config/rmw/insns.h>
+#endif
 
 /*
  * SMP- and interrupt-safe semaphores..
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/include/asm-m68k/setup.h linux-2.2-p68k/include/asm-m68k/setup.h
--- linux-2.2-p68k.org/include/asm-m68k/setup.h	Wed Jan  6 22:28:35 1999
+++ linux-2.2-p68k/include/asm-m68k/setup.h	Sun Jan 10 02:30:20 1999
@@ -23,8 +23,22 @@
 #ifndef _M68K_SETUP_H
 #define _M68K_SETUP_H
 
-#include <linux/config.h>
-
+#include <config/amiga.h>
+#include <config/apollo.h>
+#include <config/atari.h>
+#include <config/hp300.h>
+#include <config/mac.h>
+#include <config/sun3.h>
+#include <config/vme.h>
+#ifdef CONFIG_VME
+#include <config/bvme6000.h>
+#include <config/mvme16x.h>
+#endif
+
+#include <config/m68020.h>
+#include <config/m68030.h>
+#include <config/m68040.h>
+#include <config/m68060.h>
 
     /*
      *  Linux/m68k Architectures
@@ -52,7 +66,7 @@
 	|| defined(CONFIG_MVME16x) || defined(CONFIG_BVME6000) || defined(CONFIG_HP300)
 #  define MACH_IS_AMIGA (m68k_machtype == MACH_AMIGA)
 #else
-#  define CONFIG_AMIGA_ONLY
+#  define MACH_AMIGA_ONLY
 #  define MACH_IS_AMIGA (1)
 #  define MACH_TYPE (MACH_AMIGA)
 #endif
@@ -63,7 +77,7 @@
 	|| defined(CONFIG_MVME16x) || defined(CONFIG_BVME6000) || defined(CONFIG_HP300)
 #  define MACH_IS_ATARI (m68k_machtype == MACH_ATARI)
 #else
-#  define CONFIG_ATARI_ONLY
+#  define MACH_ATARI_ONLY
 #  define MACH_IS_ATARI (1)
 #  define MACH_TYPE (MACH_ATARI)
 #endif
@@ -74,7 +88,7 @@
 	|| defined(CONFIG_HP300) || defined(CONFIG_MVME16x) || defined(CONFIG_BVME6000)
 #  define MACH_IS_MAC (m68k_machtype == MACH_MAC)
 #else
-#  define CONFIG_MAC_ONLY
+#  define MACH_MAC_ONLY
 #  define MACH_IS_MAC (1)
 #  define MACH_TYPE (MACH_MAC)
 #endif
@@ -91,7 +105,7 @@
 	|| defined(CONFIG_MVME16x) || defined(CONFIG_BVME6000) || defined(CONFIG_HP300)
 #  define MACH_IS_APOLLO (m68k_machtype == MACH_APOLLO)
 #else
-#  define CONFIG_APOLLO_ONLY
+#  define MACH_APOLLO_ONLY
 #  define MACH_IS_APOLLO (1)
 #  define MACH_TYPE (MACH_APOLLO)
 #endif
@@ -102,7 +116,7 @@
 	|| defined(CONFIG_APOLLO) || defined(CONFIG_BVME6000) || defined(CONFIG_HP300)
 #  define MACH_IS_MVME16x (m68k_machtype == MACH_MVME16x)
 #else
-#  define CONFIG_MVME16x_ONLY
+#  define MACH_MVME16x_ONLY
 #  define MACH_IS_MVME16x (1)
 #  define MACH_TYPE (MACH_MVME16x)
 #endif
@@ -113,7 +127,7 @@
 	|| defined(CONFIG_APOLLO) || defined(CONFIG_MVME16x) || defined(CONFIG_HP300)
 #  define MACH_IS_BVME6000 (m68k_machtype == MACH_BVME6000)
 #else
-#  define CONFIG_BVME6000_ONLY
+#  define MACH_BVME6000_ONLY
 #  define MACH_IS_BVME6000 (1)
 #  define MACH_TYPE (MACH_BVME6000)
 #endif
@@ -124,7 +138,7 @@
 	|| defined(CONFIG_APOLLO) || defined(CONFIG_MVME16x) || defined(CONFIG_BVME6000)
 #  define MAC_IS_HP300 (m68k_machtype == MACH_HP300)
 #else
-#  define CONFIG_HP300_ONLY
+#  define MACH_HP300_ONLY
 #  define MACH_IS_HP300 (1)
 #  define MACH_TYPE (MACH_HP300)
 #endif
@@ -260,6 +274,7 @@
 
 #define CPU_TYPE (m68k_cputype)
 
+
     /*
      *  Miscellaneous
      */
@@ -268,7 +283,8 @@
 #define CL_SIZE		256
 
 #ifndef __ASSEMBLY__
-extern int m68k_num_memory;		/* # of memory blocks found */
+extern int m68k_num_memory;		/* # of memory blocks found (and used) */
+extern int m68k_realnum_memory;		/* real # of memory blocks found */
 extern struct mem_info m68k_memory[NUM_MEMINFO];/* memory description */
 
 struct mem_info {
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/include/asm-m68k/system.h linux-2.2-p68k/include/asm-m68k/system.h
--- linux-2.2-p68k.org/include/asm-m68k/system.h	Wed Jan  6 22:28:35 1999
+++ linux-2.2-p68k/include/asm-m68k/system.h	Sun Jan 10 02:30:20 1999
@@ -1,9 +1,17 @@
 #ifndef _M68K_SYSTEM_H
 #define _M68K_SYSTEM_H
 
-#include <linux/config.h> /* get configuration macros */
 #include <linux/linkage.h>
 #include <asm/segment.h>
+#include <asm/setup.h>
+#include <config/atari.h>
+#ifdef CONFIG_ATARI
+#include <config/hades.h>
+#endif
+#include <config/advanced.h>
+#ifdef CONFIG_ADVANCED
+#include <config/rmw/insns.h>
+#endif
 
 extern inline unsigned long rdusp(void) {
   	unsigned long usp;
@@ -46,11 +54,8 @@
 #define switch_to(prev,next) { \
   register void *_prev __asm__ ("a0") = (prev); \
   register void *_next __asm__ ("a1") = (next); \
-  register int _tssoff __asm__ ("d1") = (int)&((struct task_struct *)0)->tss; \
-  register char _shared __asm__ ("d2") = ((prev)->mm == (next)->mm); \
-  __asm__ __volatile__("jbsr " SYMBOL_NAME_STR(resume) "\n\t" \
-		       : : "a" (_prev), "a" (_next), "d" (_tssoff), \
-		           "d" (_shared) \
+  __asm__ __volatile__("jbsr " SYMBOL_NAME_STR(resume) \
+		       : : "a" (_prev), "a" (_next) \
 		       : "d0", "d1", "d2", "d3", "d4", "d5", "a0", "a1"); \
 }
 
@@ -60,7 +65,7 @@
 struct __xchg_dummy { unsigned long a[100]; };
 #define __xg(x) ((volatile struct __xchg_dummy *)(x))
 
-#if defined(CONFIG_ATARI) && !defined(CONFIG_AMIGA) && !defined(CONFIG_MAC) && !defined(CONFIG_HADES) && !defined(CONFIG_VME) && !defined(CONFIG_APOLLO)
+#if defined(MACH_ATARI_ONLY) && !defined(CONFIG_HADES)
 /* block out HSYNC on the atari */
 #define __sti() __asm__ __volatile__ ("andiw #0xfbff,%/sr": : : "memory")
 #else /* portable version */
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/include/asm-m68k/traps.h linux-2.2-p68k/include/asm-m68k/traps.h
--- linux-2.2-p68k.org/include/asm-m68k/traps.h	Sat Oct 31 00:13:12 1998
+++ linux-2.2-p68k/include/asm-m68k/traps.h	Wed Jan  6 23:19:15 1999
@@ -11,10 +11,14 @@
 #ifndef _M68K_TRAPS_H
 #define _M68K_TRAPS_H
 
+#ifndef __ASSEMBLY__
+
 typedef void (*e_vector)(void);
 
 extern e_vector vectors[];
 
+#endif
+
 #define VEC_BUSERR  (2)
 #define VEC_ADDRERR (3)
 #define VEC_ILLEGAL (4)
@@ -63,9 +67,12 @@
 #define VEC_FPUNSUP (55)
 #define	VEC_UNIMPEA (60)
 #define	VEC_UNIMPII (61)
+#define VEC_USER    (64)
 
 #define VECOFF(vec) ((vec)<<2)
 
+#ifndef __ASSEMBLY__
+
 /* Status register bits */
 #define PS_T  (0x8000)
 #define PS_S  (0x2000)
@@ -237,5 +244,7 @@
 	    } fmtb;
     } un;
 };
+
+#endif /* __ASSEMBLY__ */
 
 #endif /* _M68K_TRAPS_H */
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/include/asm-m68k/virtconvert.h linux-2.2-p68k/include/asm-m68k/virtconvert.h
--- linux-2.2-p68k.org/include/asm-m68k/virtconvert.h	Wed Jan  6 22:28:36 1999
+++ linux-2.2-p68k/include/asm-m68k/virtconvert.h	Sun Jan 10 02:30:21 1999
@@ -7,8 +7,16 @@
 
 #ifdef __KERNEL__
 
-#include <linux/config.h>
 #include <asm/setup.h>
+#include <config/amiga.h>
+#include <config/atari.h>
+#ifdef CONFIG_ATARI
+#include <config/hades.h>
+#endif
+#include <config/advanced.h>
+#ifdef CONFIG_ADVANCED
+#include <config/single/memory/chunk.h>
+#endif
 
 #ifdef CONFIG_AMIGA
 #include <asm/amigahw.h>
@@ -18,7 +26,7 @@
  * Change virtual addresses to physical addresses and vv.
  */
 extern unsigned long mm_vtop(unsigned long addr) __attribute__ ((const));
-extern unsigned long mm_vtop_fallback (unsigned long);
+extern unsigned long mm_vtop_fallback (unsigned long) __attribute__ ((const));
 extern unsigned long mm_ptov(unsigned long addr) __attribute__ ((const));
 
 #ifdef CONFIG_SINGLE_MEMORY_CHUNK
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/include/asm-ppc/io.h linux-2.2-p68k/include/asm-ppc/io.h
--- linux-2.2-p68k.org/include/asm-ppc/io.h	Wed Jan  6 00:47:34 1999
+++ linux-2.2-p68k/include/asm-ppc/io.h	Fri Jan  8 22:25:01 1999
@@ -130,6 +130,15 @@
 extern unsigned long mm_ptov(unsigned long addr) __attribute__ ((const));
 #endif
 
+/* Values for nocacheflag and cmode */
+/* These are not used by the APUS kernel_map, but prevents
+   compilation errors. */
+#define	IOMAP_FULL_CACHING		0
+#define	IOMAP_NOCACHE_SER		1
+#define	IOMAP_NOCACHE_NONSER		2
+#define	IOMAP_WRITETHROUGH		3
+
+
 /*
  * The PCI bus is inherently Little-Endian.  The PowerPC is being
  * run Big-Endian.  Thus all values which cross the [PCI] barrier
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/include/asm-ppc/pgtable.h linux-2.2-p68k/include/asm-ppc/pgtable.h
--- linux-2.2-p68k.org/include/asm-ppc/pgtable.h	Wed Jan  6 22:24:42 1999
+++ linux-2.2-p68k/include/asm-ppc/pgtable.h	Fri Jan  8 22:25:01 1999
@@ -615,14 +615,6 @@
 extern unsigned long iopa(unsigned long addr);
 extern unsigned long mm_ptov(unsigned long addr) __attribute__ ((const));
 
-/* Values for nocacheflag and cmode */
-/* These are not used by the APUS kernel_map, but prevents
-   compilation errors. */
-#define	KERNELMAP_FULL_CACHING		0
-#define	KERNELMAP_NOCACHE_SER		1
-#define	KERNELMAP_NOCACHE_NONSER	2
-#define	KERNELMAP_NO_COPYBACK		3
-
 /*
  * Map some physical address range into the kernel address space.
  */
diff -Nur -X m68k_nodiff linux-2.2-p68k.org/include/video/font.h linux-2.2-p68k/include/video/font.h
--- linux-2.2-p68k.org/include/video/font.h	Sat Oct 31 02:31:30 1998
+++ linux-2.2-p68k/include/video/font.h	Sat Jan  9 17:24:15 1999
@@ -11,19 +11,6 @@
 #ifndef _VIDEO_FONT_H
 #define _VIDEO_FONT_H
 
-#ifdef __ASSEMBLY__
-
-#ifdef __mc68000__
-#define FBCON_FONT_DESC_idx	0
-#define FBCON_FONT_DESC_name	(FBCON_FONT_DESC_idx   +4)
-#define FBCON_FONT_DESC_width	(FBCON_FONT_DESC_name  +4)
-#define FBCON_FONT_DESC_height	(FBCON_FONT_DESC_width +4)
-#define FBCON_FONT_DESC_data	(FBCON_FONT_DESC_height+4)
-#define FBCON_FONT_DESC_pref	(FBCON_FONT_DESC_data  +4)
-#endif
-
-#else /* __ASSEMBLY__ */
-
 #include <linux/types.h>
 
 struct fbcon_font_desc {
@@ -60,7 +47,5 @@
 
 /* Max. length for the name of a predefined font */
 #define MAX_FONT_NAME	32
-
-#endif /* __ASSEMBLY__ */
 
 #endif /* _VIDEO_FONT_H */

